
/*
             Common Public License Version 0.5

             THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF
             THIS COMMON PUBLIC LICENSE ("AGREEMENT"). ANY USE,
             REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES
             RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT.

             1. DEFINITIONS

             "Contribution" means: 
                   a) in the case of the initial Contributor, the
                   initial code and documentation distributed under
                   this Agreement, and 

                   b) in the case of each subsequent Contributor:
                   i) changes to the Program, and
                   ii) additions to the Program;

                   where such changes and/or additions to the Program
                   originate from and are distributed by that
                   particular Contributor. A Contribution 'originates'
                   from a Contributor if it was added to the Program
                   by such Contributor itself or anyone acting on such
                   Contributor's behalf. Contributions do not include
                   additions to the Program which: (i) are separate
                   modules of software distributed in conjunction with
                   the Program under their own license agreement, and
                   (ii) are not derivative works of the Program.


             "Contributor" means any person or entity that distributes
             the Program.

             "Licensed Patents " mean patent claims licensable by a
             Contributor which are necessarily infringed by the use or
             sale of its Contribution alone or when combined with the
             Program. 

             "Program" means the Contributions distributed in
             accordance with this Agreement.

             "Recipient" means anyone who receives the Program under
             this Agreement, including all Contributors.

             2. GRANT OF RIGHTS

                   a) Subject to the terms of this Agreement, each
                   Contributor hereby grants Recipient a
                   non-exclusive, worldwide, royalty-free copyright
                   license to reproduce, prepare derivative works of,
                   publicly display, publicly perform, distribute and
                   sublicense the Contribution of such Contributor, if
                   any, and such derivative works, in source code and
                   object code form.

                   b) Subject to the terms of this Agreement, each
                   Contributor hereby grants Recipient a
                   non-exclusive, worldwide, royalty-free patent
                   license under Licensed Patents to make, use, sell,
                   offer to sell, import and otherwise transfer the
                   Contribution of such Contributor, if any, in source
                   code and object code form. This patent license
                   shall apply to the combination of the Contribution
                   and the Program if, at the time the Contribution is
                   added by the Contributor, such addition of the
                   Contribution causes such combination to be covered
                   by the Licensed Patents. The patent license shall
                   not apply to any other combinations which include
                   the Contribution. No hardware per se is licensed
                   hereunder.

                   c) Recipient understands that although each
                   Contributor grants the licenses to its
                   Contributions set forth herein, no assurances are
                   provided by any Contributor that the Program does
                   not infringe the patent or other intellectual
                   property rights of any other entity. Each
                   Contributor disclaims any liability to Recipient
                   for claims brought by any other entity based on
                   infringement of intellectual property rights or
                   otherwise. As a condition to exercising the rights
                   and licenses granted hereunder, each Recipient
                   hereby assumes sole responsibility to secure any
                   other intellectual property rights needed, if any.

                   For example, if a third party patent license is
                   required to allow Recipient to distribute the
                   Program, it is Recipient's responsibility to
                   acquire that license before distributing the
                   Program.

                   d) Each Contributor represents that to its
                   knowledge it has sufficient copyright rights in its
                   Contribution, if any, to grant the copyright
                   license set forth in this Agreement.

             3. REQUIREMENTS

             A Contributor may choose to distribute the Program in
             object code form under its own license agreement, provided
             that:
                   a) it complies with the terms and conditions of
                   this Agreement; and

                   b) its license agreement:
                   i) effectively disclaims on behalf of all
                   Contributors all warranties and conditions, express
                   and implied, including warranties or conditions of
                   title and non-infringement, and implied warranties
                   or conditions of merchantability and fitness for a
                   particular purpose;

                   ii) effectively excludes on behalf of all
                   Contributors all liability for damages, including
                   direct, indirect, special, incidental and
                   consequential damages, such as lost profits;

                   iii) states that any provisions which differ from
                   this Agreement are offered by that Contributor
                   alone and not by any other party; and

                   iv) states that source code for the Program is
                   available from such Contributor, and informs
                   licensees how to obtain it in a reasonable manner
                   on or through a medium customarily used for
                   software exchange.

             When the Program is made available in source code form:
                   a) it must be made available under this Agreement;
                   and
                   b) a copy of this Agreement must be included with
                   each copy of the Program. 

             Contributors may not remove or alter any copyright notices
             contained within the Program.

             Each Contributor must identify itself as the originator of
             its Contribution, if any, in a manner that reasonably
             allows subsequent Recipients to identify the originator of
             the Contribution. 


             4. COMMERCIAL DISTRIBUTION

             Commercial distributors of software may accept certain
             responsibilities with respect to end users, business
             partners and the like. While this license is intended to
             facilitate the commercial use of the Program, the
             Contributor who includes the Program in a commercial
             product offering should do so in a manner which does not
             create potential liability for other Contributors.
             Therefore, if a Contributor includes the Program in a
             commercial product offering, such Contributor ("Commercial
             Contributor") hereby agrees to defend and indemnify every
             other Contributor ("Indemnified Contributor") against any
             losses, damages and costs (collectively "Losses") arising
             from claims, lawsuits and other legal actions brought by a
             third party against the Indemnified Contributor to the
             extent caused by the acts or omissions of such Commercial
             Contributor in connection with its distribution of the
             Program in a commercial product offering. The obligations
             in this section do not apply to any claims or Losses
             relating to any actual or alleged intellectual property
             infringement. In order to qualify, an Indemnified
             Contributor must: a) promptly notify the Commercial
             Contributor in writing of such claim, and b) allow the
             Commercial Contributor to control, and cooperate with the
             Commercial Contributor in, the defense and any related
             settlement negotiations. The Indemnified Contributor may
             participate in any such claim at its own expense.


             For example, a Contributor might include the Program in a
             commercial product offering, Product X. That Contributor
             is then a Commercial Contributor. If that Commercial
             Contributor then makes performance claims, or offers
             warranties related to Product X, those performance claims
             and warranties are such Commercial Contributor's
             responsibility alone. Under this section, the Commercial
             Contributor would have to defend claims against the other
             Contributors related to those performance claims and
             warranties, and if a court requires any other Contributor
             to pay any damages as a result, the Commercial Contributor
             must pay those damages.


             5. NO WARRANTY

             EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE
             PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT
             WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR
             IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR
             CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR
             FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely
             responsible for determining the appropriateness of using
             and distributing the Program and assumes all risks
             associated with its exercise of rights under this
             Agreement, including but not limited to the risks and
             costs of program errors, compliance with applicable laws,
             damage to or loss of data, programs or equipment, and
             unavailability or interruption of operations. 

             6. DISCLAIMER OF LIABILITY
             EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER
             RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY
             FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
             OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION
             LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF
             LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
             (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
             OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE
             OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE
             POSSIBILITY OF SUCH DAMAGES.

             7. GENERAL

             If any provision of this Agreement is invalid or
             unenforceable under applicable law, it shall not affect
             the validity or enforceability of the remainder of the
             terms of this Agreement, and without further action by the
             parties hereto, such provision shall be reformed to the
             minimum extent necessary to make such provision valid and
             enforceable.


             If Recipient institutes patent litigation against a
             Contributor with respect to a patent applicable to
             software (including a cross-claim or counterclaim in a
             lawsuit), then any patent licenses granted by that
             Contributor to such Recipient under this Agreement shall
             terminate as of the date such litigation is filed. In
             addition, If Recipient institutes patent litigation
             against any entity (including a cross-claim or
             counterclaim in a lawsuit) alleging that the Program
             itself (excluding combinations of the Program with other
             software or hardware) infringes such Recipient's
             patent(s), then such Recipient's rights granted under
             Section 2(b) shall terminate as of the date such
             litigation is filed.

             All Recipient's rights under this Agreement shall
             terminate if it fails to comply with any of the material
             terms or conditions of this Agreement and does not cure
             such failure in a reasonable period of time after becoming
             aware of such noncompliance. If all Recipient's rights
             under this Agreement terminate, Recipient agrees to cease
             use and distribution of the Program as soon as reasonably
             practicable. However, Recipient's obligations under this
             Agreement and any licenses granted by Recipient relating
             to the Program shall continue and survive. 

             Everyone is permitted to copy and distribute copies of
             this Agreement, but in order to avoid inconsistency the
             Agreement is copyrighted and may only be modified in the
             following manner. The Agreement Steward reserves the right
             to publish new versions (including revisions) of this
             Agreement from time to time. No one other than the
             Agreement Steward has the right to modify this Agreement.

             IBM is the initial Agreement Steward. IBM may assign the
             responsibility to serve as the Agreement Steward to a
             suitable separate entity. Each new version of the
             Agreement will be given a distinguishing version number.
             The Program (including Contributions) may always be
             distributed subject to the version of the Agreement under
             which it was received. In addition, after a new version of
             the Agreement is published, Contributor may elect to
             distribute the Program (including its Contributions) under
             the new version. Except as expressly stated in Sections
             2(a) and 2(b) above, Recipient receives no rights or
             licenses to the intellectual property of any Contributor
             under this Agreement, whether expressly, by implication,
             estoppel or otherwise. All rights in the Program not
             expressly granted under this Agreement are reserved.


             This Agreement is governed by the laws of the State of New
             York and the intellectual property laws of the United
             States of America. No party to this Agreement will bring a
             legal action under this Agreement more than one year after
             the cause of action arose. Each party waives its rights to
             a jury trial in any resulting litigation. 



*/

/* (C) COPYRIGHT International Business Machines Corp. 2001          */


/****************************************************************************
 **                                                                        **
 **        (C) COPYRIGHT IBM CORP 1997                                     **
 **                                                                        **
 **       LICENSED MATERIALS  -  PROPERTY OF IBM                           **
 **                                                                        **
 **       All Rights Reserved                                              **
 **                                                                        **
 **       U.S. Government Users Restricted Rights - Use,                   **
 **       duplication or disclosure restricted by GSA ADP                  **
 **       Schedule Contract with IBM Corp.                                 **
 **                                                                        **
 **       See Copyright Instructions (Form G120-2083)                      **
 **                                                                        **
 **       Origin: RES (IBM Research Division)                              **
 **                                                                        **
 ****************************************************************************
 *                                                                          *
 * Module name:         mpmath.h                                            *
 *                                                                          *
 * Descriptive name:    PKA Manager modular math include file               *
 *                                                                          *
 * Status:              Version 1 Driver 1                                  *
 *                                                                          *
 * Function:            Provides structure definitions, macros, and         *
 *                      constants for the modular math routines             *
 *                                                                          *
 * Module type:         C source code                                       *
 *                                                                          *
 * Processor:           VisualAgeC++ for OS/2                               *
 *                                                                          *
 * Restrictions:        None                                                *
 *                                                                          *
 * Linkage:             n/a                                                 *
 *                                                                          *
 * CHANGE-ACTIVITY:     Author:  Pankaj Rohatgi                             *
 *                                                                          *
 *     Date    By   Comments                                                *
 *    -------  ---  ------------------------------------------------------  *
 *  96/02/02   PR   initial implementation                                  *
 *  97/10/10   SC   added interface for conversion routines                 *
 *  99/02/28   jgd  add mp_neg_minus_eq prototype                           *
 ****************************************************************************
 */


#ifndef __MPMATH_H__
#define __MPMATH_H__
#include "ica_err.h"
#include "fixsize.h"
#include "ica_api.h"

#ifdef __LONGLONG__
typedef unsigned long long double_unit;
typedef unsigned long unit;
#else
typedef unsigned int double_unit;
typedef unsigned short unit;
#endif


#define UNITSIZE (sizeof(unit) * 8)

/* Maximum length (in units) of multiprecison integers where
all operations are fully supported.
Note: Simple non-modular operations (add, subtract, multiply, copy
normalize etc are supported beyond this size).
*/

#define MAXSIZE (2048/(sizeof(unit)*8))

#define get_upper_unit(du) ((unit)(((double_unit)(du)) >> (sizeof(unit) * 8)))
#define get_lower_unit(du) ((unit)(du))

/*
   A multi precision int is an structure consisting of a size which gives
   the size of the int in terms of units and a pointer to a unit array
   holding the multi precision integer. The endianness of the array is
   the same as that of the machine.
*/

typedef struct {
  int size;
  int maxsize;
  unit *value;
} mp_int;

/*
   One of the  __LITTLE_ENDIAN__ or __BIG_ENDIAN__ flags must be defined
   in all cases. This will affect how the mp_int value array is accessed
*/

#ifdef __LITTLE_ENDIAN__
/* CARE !!!! double eval -> no side effects */
#define MP_MS_UNIT(a) (  ((a)->value) + (((a)->size)-1)  )
#define MP_LS_UNIT(a)          ((a)->value)
#define MP_MS_PLUS_K_MS_UNIT(a,k)  ( ((a)->value)  + ( ( ((a)->size)-1) - (k)))
#define MP_LS_MINUS_K_LS_UNIT(a, k) (((a)->value) + (k))
#define MS_UNIT(a, size)       ((a) + ((size)-1))
#define LS_UNIT(a, size)       (a)
#define UNIT_PLUS_PLUS(a)      ((a)--)
#define UNIT_MINUS_MINUS(a)    ((a)++)
#define PLUS_PLUS_UNIT(a)      (--(a))
#define MINUS_MINUS_UNIT(a)    (++(a))
#define DOUBLE_UNIT_CAST(a)  (double_unit) ( ( ((double_unit) *(a)) << UNITSIZE) + *(a - 1))
#define UNIT_PLUS_EQ(a, k) ((a) -= (k))
#define UNIT_PLUS_K(a, k) ((a) - (k))
#define UNIT_MINUS_EQ(a, k) ((a) += (k))
#else
#ifdef __BIG_ENDIAN__
#define MP_MS_UNIT(a)          ((a)->value)
#define MP_LS_UNIT(a)          (((a)->value) + (((a)->size)-1)) /* Care !!! */
#define MP_MS_PLUS_K_MS_UNIT(a,k)   ( ((a)->value) + (k))
#define MP_LS_MINUS_K_LS_UNIT(a, k) ( ((a)->value)  + ( ( ((a)->size)-1) - (k)))
#define MS_UNIT(a, size)       (a)
#define LS_UNIT(a, size)       ((a) + ((size)-1))
#define UNIT_PLUS_PLUS(a)      ((a)++)
#define UNIT_MINUS_MINUS(a)    ((a)--)
#define PLUS_PLUS_UNIT(a)      (++(a))
#define MINUS_MINUS_UNIT(a)    (--(a))
#define DOUBLE_UNIT_CAST(a)  (double_unit)( ( ((double_unit) *(a)) << UNITSIZE) + *(a + 1))
#define UNIT_PLUS_EQ(a, k) ((a) += (k))
#define UNIT_PLUS_K(a, k) ((a) + (k))
#define UNIT_MINUS_EQ(a, k) ((a) -= (k))
#else
fake_type you_must_define_endianness_of_target_machine_at_compile_time;
#endif /* __BIG_ENDIAN__ */
#endif /* __LITTLE_ENDIAN__ */

/* Function Prototypes */

/* 1. Utility Functions   */

/* 1.0
True size function: the true size of a mp_int ignoring
leading 0's
*/
int mp_truesize(mp_int *a);

/*
  1.1. Normalize Function.

  Adjusts provided a, to make most significant unit nonzero.
  Side effects
     a->size  may be updated
     a->value array may have data movement performed on it.
*/

void mp_normalize(mp_int *a);

/* 1.2 Extend function
   Extends an mp_int to fit in size "size".
*/

int mp_extend(mp_int *a, int size);


/* General comparison, Results: 0: a == b, -1: a < b, 1 : a > b  */
int mp_compare_general(mp_int *a, mp_int *b);

/* Fast comparison of equal sized numbers,
   Results: 0: a == b, -1: a < b, 1 : a > b  */
int mp_compare_fast(unit *msb_a, unit *msb_b, int size);


/* Copying mp_ints */
/* Using unit pointers and size*/

void mp_copy_unit_lsb(unit *result_lsb, unit *input_lsb, int size);
void mp_copy_unit_msb(unit *result_msb, unit *input_msb, int size);

/* Using pointers to mp_ints. Error (nonzero value -1) returned on
   overflow, in which case as many LSB's are copied as possible
*/
int mp_copy(mp_int *result, mp_int *input);

/*
   Convert from internal representation to big endian character array
   */
void mpint_to_bigendian_bytearray(unit *msb_internal, int internal_size,
			     unsigned char *external, int external_byte_size);

/*
   Convert from big endian character array to internal representation
   */
void bigendian_bytearray_to_mpint( unsigned char *external,
				   int external_byte_size,
				   unsigned long bitsize,
				   unit *msb_internal, int internal_size);


/* Shift left by 1, (mult by 2), returns overflow (0 or 1) */

unit shift_left(unit *lsb_a, int size);

/* Shift right by 1, (div by 2), returns discarded rightmost bit (0 or 1) */

unit shift_right(unit *msb_a, int size);

/* returns remainder when divided by small integer.
This only works when n is no more that 24 bits long */

u_int32  get_32_rem(unit *msb_prime, int size, u_int32 n);




/* 2. Plain/Modular  Addition/Subtraction           */

/* 2.1 Plain operations */

/* c = a + b; Size of c assumed big enough, o/w nonzero returned */

int mp_add(mp_int *a, mp_int *b, mp_int *c);

/* a += b; if a overflows, a nonzero value returned */

int mp_plus_eq( mp_int *a, mp_int *b);

/* a += b where b is a unit. Result nonzero if resulting
   carry.
*/
int mp_plus_eq_unit(unit *lsb_a, unit b, int size);

/* a += b where a and b's are lsb's of equal sized
   mpints. Result nonzero if resulting
   carry.
*/
int mp_plus_eq_unit_lsb(unit *lsb_a, unit *lsb_b, int size);

/* 2.2 Modular operations */
/* All numbers assumed of equal size, variable name in prototype indicates
   whether the most significant or least significant unit is given as
   parameter, also all inputs are assumed to be less than the modulus
*/

/* c = a + b (mod n) */
void mp_add_modn( unit *lsb_a, unit *lsb_b, unit *lsb_c, unit *msb_n,
                  int size);

/* a +=b (mod n)           */

void  mp_plus_eq_modn(unit *lsb_a, unit *lsb_b, unit *msb_n, int size);


/*
  a -= b, where a and b are of size size. Result nonzero if resulting
  borrow.
*/

int mp_minus_eq(unit *lsb_a, unit *lsb_b, int size);

/* a -= b where b is a unit. Result nonzero if resulting
   borrow.
*/
int mp_minus_eq_unit(unit *lsb_a, unit b, int size);

/*
  a = b - a, where a and b are of size size.  Result nonzero if resulting
  borrow.  (Useful for replacing a by n-a without disturbing n.)
*/
int mp_neg_minus_eq(unit *lsb_a, unit *lsb_b, int size );



/* Multiplication and Squaring, mod and divide, inverses and gcd */

/*  c = a * b; c assumed big enough */
int mp_multiply(ICA_ADAPTER_HANDLE devhandle, mp_int *c, mp_int *a, mp_int *b);

/*  c = a^2; c assumed big enough */

int mp_square(ICA_ADAPTER_HANDLE devhandle, mp_int *c, mp_int *a);

/*
   Compute c = a (mod n)
   If q != NULL then the quotient is moved to q, size of q must
   be at least size of a - real size of n
   (i.e., after ignoring leading 0's).

*/

int mp_mod(ICA_ADAPTER_HANDLE devhandle, mp_int *a, mp_int *n, mp_int *c,  mp_int *q);

/* Modular Multiplication */
/* c = a * b (mod n) (all of size size) , a,b < n*/
int mp_modmult(ICA_ADAPTER_HANDLE devhandle,
			   unit *msb_c, unit *msb_a, unit *msb_b, unit *msb_n, int size);
/* Modular Squaring */
/* c = a^2 (mod n) */
int mp_modsquare(ICA_ADAPTER_HANDLE devhandle, unit *msb_c, unit *msb_a, unit *msb_n, int size);

/* Modular Exponentiation */
/*  c = a ^e (mod n) */
int mp_exponentiate(ICA_ADAPTER_HANDLE devhandle, unit *msb_c, unit *msb_a, unit *msb_n, int size,
		    unit *msb_e, int esize);

/* PKCS Modular Exponentiation  */
int mp_PKCSDecrypt(unit *msb_result,
                   unit *msb_c, int size,
                   unit *msb_p, int psize,
                   unit *msb_q, int qsize,
                   unit *msb_dp,
                   unit *msb_dq,
                   unit *msb_qInv);

/* GCD's and Inverses */

/* GCD: Assumes that c is always large enough, o/w
   will give error after partial computation.
   one way to ensure is to give a c with maxsize at
   least the min of the sizes of a and b
*/
int mp_gcd(ICA_ADAPTER_HANDLE devhandle, mp_int *a, mp_int *b, mp_int *c);

/*
   Given nonzero a,n where a < n; compute multiplicative inverse of a mod n
   Firstly we assume that GCD(a, n) = 1. This will happen for cryptographic
   applications and one can always check with the GCD algorithm.
   o/w this procedure returns -1. Other return codes are for
   other specific failures.

   The procedure used is the extended Euclidean GCD algorithm.

*/

int mp_inv(ICA_ADAPTER_HANDLE devhandle, mp_int *a, mp_int *n, mp_int *ainv);

/*
   A cheap test for primality used to seive away candidates without the
   full expense of a rabin miller test. Computes
   2^p-1 mod p == 1 ? 0: -1

   CAUTION: Upon internal failure a non-zero value is returned. Pls make
   sure that no error code coincides with -1, o/w that code will be
   made -2 in this return value.
*/
int cheap_fermat(ICA_ADAPTER_HANDLE devhandle, unit *msb_p, int size);

/* Rabin Miller test using r and p of size "size", input r
   by be greater than p in which case r mod p is used.

   Returns 0 if test passes (probable prime)
   -1 if it fails (not a prime).

   CAUTION: Upon internal failure a non-zero value is returned. Pls make
   sure that no error code coincides with -1, o/w that code will be made
   -2 in this return value.


*/

int mp_rabin_miller(ICA_ADAPTER_HANDLE devhandle, unit *msb_r, unit *msb_p, int size);


/*
   computes the jacobi symbol ( a  /  n )
   assumes that  gcd(a,n) = 1.

*/
extern int mp_jacobi_symbol(ICA_ADAPTER_HANDLE devhandle, mp_int  *a , mp_int * n );


void mpmath_init(void);

#endif /* __MPMATH_H__ */
