
/*
             Common Public License Version 0.5

             THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF
             THIS COMMON PUBLIC LICENSE ("AGREEMENT"). ANY USE,
             REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES
             RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT.

             1. DEFINITIONS

             "Contribution" means: 
                   a) in the case of the initial Contributor, the
                   initial code and documentation distributed under
                   this Agreement, and 

                   b) in the case of each subsequent Contributor:
                   i) changes to the Program, and
                   ii) additions to the Program;

                   where such changes and/or additions to the Program
                   originate from and are distributed by that
                   particular Contributor. A Contribution 'originates'
                   from a Contributor if it was added to the Program
                   by such Contributor itself or anyone acting on such
                   Contributor's behalf. Contributions do not include
                   additions to the Program which: (i) are separate
                   modules of software distributed in conjunction with
                   the Program under their own license agreement, and
                   (ii) are not derivative works of the Program.


             "Contributor" means any person or entity that distributes
             the Program.

             "Licensed Patents " mean patent claims licensable by a
             Contributor which are necessarily infringed by the use or
             sale of its Contribution alone or when combined with the
             Program. 

             "Program" means the Contributions distributed in
             accordance with this Agreement.

             "Recipient" means anyone who receives the Program under
             this Agreement, including all Contributors.

             2. GRANT OF RIGHTS

                   a) Subject to the terms of this Agreement, each
                   Contributor hereby grants Recipient a
                   non-exclusive, worldwide, royalty-free copyright
                   license to reproduce, prepare derivative works of,
                   publicly display, publicly perform, distribute and
                   sublicense the Contribution of such Contributor, if
                   any, and such derivative works, in source code and
                   object code form.

                   b) Subject to the terms of this Agreement, each
                   Contributor hereby grants Recipient a
                   non-exclusive, worldwide, royalty-free patent
                   license under Licensed Patents to make, use, sell,
                   offer to sell, import and otherwise transfer the
                   Contribution of such Contributor, if any, in source
                   code and object code form. This patent license
                   shall apply to the combination of the Contribution
                   and the Program if, at the time the Contribution is
                   added by the Contributor, such addition of the
                   Contribution causes such combination to be covered
                   by the Licensed Patents. The patent license shall
                   not apply to any other combinations which include
                   the Contribution. No hardware per se is licensed
                   hereunder.

                   c) Recipient understands that although each
                   Contributor grants the licenses to its
                   Contributions set forth herein, no assurances are
                   provided by any Contributor that the Program does
                   not infringe the patent or other intellectual
                   property rights of any other entity. Each
                   Contributor disclaims any liability to Recipient
                   for claims brought by any other entity based on
                   infringement of intellectual property rights or
                   otherwise. As a condition to exercising the rights
                   and licenses granted hereunder, each Recipient
                   hereby assumes sole responsibility to secure any
                   other intellectual property rights needed, if any.

                   For example, if a third party patent license is
                   required to allow Recipient to distribute the
                   Program, it is Recipient's responsibility to
                   acquire that license before distributing the
                   Program.

                   d) Each Contributor represents that to its
                   knowledge it has sufficient copyright rights in its
                   Contribution, if any, to grant the copyright
                   license set forth in this Agreement.

             3. REQUIREMENTS

             A Contributor may choose to distribute the Program in
             object code form under its own license agreement, provided
             that:
                   a) it complies with the terms and conditions of
                   this Agreement; and

                   b) its license agreement:
                   i) effectively disclaims on behalf of all
                   Contributors all warranties and conditions, express
                   and implied, including warranties or conditions of
                   title and non-infringement, and implied warranties
                   or conditions of merchantability and fitness for a
                   particular purpose;

                   ii) effectively excludes on behalf of all
                   Contributors all liability for damages, including
                   direct, indirect, special, incidental and
                   consequential damages, such as lost profits;

                   iii) states that any provisions which differ from
                   this Agreement are offered by that Contributor
                   alone and not by any other party; and

                   iv) states that source code for the Program is
                   available from such Contributor, and informs
                   licensees how to obtain it in a reasonable manner
                   on or through a medium customarily used for
                   software exchange.

             When the Program is made available in source code form:
                   a) it must be made available under this Agreement;
                   and
                   b) a copy of this Agreement must be included with
                   each copy of the Program. 

             Contributors may not remove or alter any copyright notices
             contained within the Program.

             Each Contributor must identify itself as the originator of
             its Contribution, if any, in a manner that reasonably
             allows subsequent Recipients to identify the originator of
             the Contribution. 


             4. COMMERCIAL DISTRIBUTION

             Commercial distributors of software may accept certain
             responsibilities with respect to end users, business
             partners and the like. While this license is intended to
             facilitate the commercial use of the Program, the
             Contributor who includes the Program in a commercial
             product offering should do so in a manner which does not
             create potential liability for other Contributors.
             Therefore, if a Contributor includes the Program in a
             commercial product offering, such Contributor ("Commercial
             Contributor") hereby agrees to defend and indemnify every
             other Contributor ("Indemnified Contributor") against any
             losses, damages and costs (collectively "Losses") arising
             from claims, lawsuits and other legal actions brought by a
             third party against the Indemnified Contributor to the
             extent caused by the acts or omissions of such Commercial
             Contributor in connection with its distribution of the
             Program in a commercial product offering. The obligations
             in this section do not apply to any claims or Losses
             relating to any actual or alleged intellectual property
             infringement. In order to qualify, an Indemnified
             Contributor must: a) promptly notify the Commercial
             Contributor in writing of such claim, and b) allow the
             Commercial Contributor to control, and cooperate with the
             Commercial Contributor in, the defense and any related
             settlement negotiations. The Indemnified Contributor may
             participate in any such claim at its own expense.


             For example, a Contributor might include the Program in a
             commercial product offering, Product X. That Contributor
             is then a Commercial Contributor. If that Commercial
             Contributor then makes performance claims, or offers
             warranties related to Product X, those performance claims
             and warranties are such Commercial Contributor's
             responsibility alone. Under this section, the Commercial
             Contributor would have to defend claims against the other
             Contributors related to those performance claims and
             warranties, and if a court requires any other Contributor
             to pay any damages as a result, the Commercial Contributor
             must pay those damages.


             5. NO WARRANTY

             EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE
             PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT
             WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR
             IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR
             CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR
             FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely
             responsible for determining the appropriateness of using
             and distributing the Program and assumes all risks
             associated with its exercise of rights under this
             Agreement, including but not limited to the risks and
             costs of program errors, compliance with applicable laws,
             damage to or loss of data, programs or equipment, and
             unavailability or interruption of operations. 

             6. DISCLAIMER OF LIABILITY
             EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER
             RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY
             FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
             OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION
             LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF
             LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
             (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
             OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE
             OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE
             POSSIBILITY OF SUCH DAMAGES.

             7. GENERAL

             If any provision of this Agreement is invalid or
             unenforceable under applicable law, it shall not affect
             the validity or enforceability of the remainder of the
             terms of this Agreement, and without further action by the
             parties hereto, such provision shall be reformed to the
             minimum extent necessary to make such provision valid and
             enforceable.


             If Recipient institutes patent litigation against a
             Contributor with respect to a patent applicable to
             software (including a cross-claim or counterclaim in a
             lawsuit), then any patent licenses granted by that
             Contributor to such Recipient under this Agreement shall
             terminate as of the date such litigation is filed. In
             addition, If Recipient institutes patent litigation
             against any entity (including a cross-claim or
             counterclaim in a lawsuit) alleging that the Program
             itself (excluding combinations of the Program with other
             software or hardware) infringes such Recipient's
             patent(s), then such Recipient's rights granted under
             Section 2(b) shall terminate as of the date such
             litigation is filed.

             All Recipient's rights under this Agreement shall
             terminate if it fails to comply with any of the material
             terms or conditions of this Agreement and does not cure
             such failure in a reasonable period of time after becoming
             aware of such noncompliance. If all Recipient's rights
             under this Agreement terminate, Recipient agrees to cease
             use and distribution of the Program as soon as reasonably
             practicable. However, Recipient's obligations under this
             Agreement and any licenses granted by Recipient relating
             to the Program shall continue and survive. 

             Everyone is permitted to copy and distribute copies of
             this Agreement, but in order to avoid inconsistency the
             Agreement is copyrighted and may only be modified in the
             following manner. The Agreement Steward reserves the right
             to publish new versions (including revisions) of this
             Agreement from time to time. No one other than the
             Agreement Steward has the right to modify this Agreement.

             IBM is the initial Agreement Steward. IBM may assign the
             responsibility to serve as the Agreement Steward to a
             suitable separate entity. Each new version of the
             Agreement will be given a distinguishing version number.
             The Program (including Contributions) may always be
             distributed subject to the version of the Agreement under
             which it was received. In addition, after a new version of
             the Agreement is published, Contributor may elect to
             distribute the Program (including its Contributions) under
             the new version. Except as expressly stated in Sections
             2(a) and 2(b) above, Recipient receives no rights or
             licenses to the intellectual property of any Contributor
             under this Agreement, whether expressly, by implication,
             estoppel or otherwise. All rights in the Program not
             expressly granted under this Agreement are reserved.


             This Agreement is governed by the laws of the State of New
             York and the intellectual property laws of the United
             States of America. No party to this Agreement will bring a
             legal action under this Agreement more than one year after
             the cause of action arose. Each party waives its rights to
             a jury trial in any resulting litigation. 



*/

/* (C) COPYRIGHT International Business Machines Corp. 2001          */


/***********************************************************************
***                                                                  ***
***       (C) COPYRIGHT IBM CORP  1997                               ***
***                                                                  ***
***       LICENSED MATERIALS  -  PROPERTY OF IBM                     ***
***                                                                  ***
***       All Rights Reserved                                        ***
***                                                                  ***
***       U.S. Government Users Restricted Rights - Use,             ***
***       duplication or disclosure restricted by GSA ADP            ***
***       Schedule Contract with IBM Corp.                           ***
***                                                                  ***
***                                                                  ***
***       ORIGINS: RES (IBM Research Division)                       ***
***                                                                  ***
************************************************************************
*
* Module Name:       mp_sw.c
*
* Descriptive Name:  Public Key cryptographic Algorithm manager (PKA_MGR)
*                    Multi-Precision software emulation of hardware math
*
* Status:            Release 1 Version 1
*
* Function:          Multi-Precision software emulation of hardware math
*
*
* Module type:
*      Processor:    Intel x86 family
*
*      Language:     C source
*
*      Compiler:     IBM VisualAge on OS/2
*
* Restrictions:
*
* Linkage:           these routines are part of the PKA manager
*
*
*
* Change History:    written January 1997 by Pankaj Rohatgi
*                    IBM Research, Hawthorne, NY
*
*
*   Date    Ver   Notes                                            by
* --------- ----  -----                                            ---
* 02-Jan-97       initial implementation                           PR
* 03-Dec-98       assert brings in printf.  fix for MB compile...  jgd
* 01-Feb-99       merge changes with PKCS stuff                    jgd,jpa
* 01-March-99    -test pkcs keytype prime p and prime q            jpa
*                 unequal length
*                -- Defect-879
* 08-Mar-99      profiling...                                      jgd
* 08-Feb-2000    Conditional Compile for MODEXTN.LIB               jpa
*                New Lib may be used in UDX or Toolkit for access
*                to additional Mod Math functions
***********************************************************************/

/*
   NOTE: THIS CODE IS FOR DEBUGGING PURPOSES ONLY!!!!.
   IT HAS TO BE MODIFIED BEFORE USE IN REAL CRYPTOGRAPHIC OPERATIONS
   SINCE IT DOES NOT ALWAYS DO STACK CLEANUP
*/

/* The following prevents assert.h from bringing in printf.
** It applies to the PKA_MGR as well as to MINIBOOT
*/
#if !defined(NDEBUG)                          /*jgd*/
   #if !defined(PKADEBUG)                     /*jgd*/
      #define NDEBUG                          /*jgd*/
   #endif                                     /*jgd*/
#endif                                        /*jgd*/

#include <assert.h>
#include <string.h>

#ifdef _WIN32
#include <windows.h>
#include <winioctl.h>
#endif

#include "platform.h"
#include "mp_hw.h"
#include "pkamgr.h"
#include "ica.h"
#include "icatypes.h"

#ifndef __PROFILE__
#define __PROFILE__ 0
#endif
#include "profiler.h"

#ifdef _DEBUG_RSA_
extern void printfUnitData( unit *inputBuffer,
                            int   inputSize);
#endif


unsigned int mapSysErr(unsigned long rc);


/* THE VISUAL AGE  COMPILER PRODUCES BUGGY CODE UNDER OPTIMIZATION FOR mult */
/* The variable ddebug and the routine bug_the_compile_bug are a workaround
   to prevent the compiler to do some bad optimization
*/
static int ddebug = 0;
static int ICA_CALL bug_the_compile_bug(char *a, int i)
{
        if (*a)
                i = (i+7*7)/(i+49);
        else
                i = (i+8*8)/(i+64);
        return (*a + i);
}


static int ICA_CALL minimum(int a, int b)
{
        return( (a <= b) ? a: b);
}


/* c = a * b  */
static int ICA_CALL  mult(mp_int *a, mp_int *b, mp_int *c)
{
  int k, temp;
  register int terms;
  register unit *aterm, *bterm;
  unit *cterm;
  register double_unit result, carry;

  /* If c is too small then return error else initialize it */
  if (c->maxsize < a->size + b->size)
    return PKAMathFail;
  else
    c->size = a->size + b->size;

  for (k=0; k < c->size; k++)
    *((c->value) + k) = 0;

  cterm = MP_LS_UNIT(c);

  /* Convolve for each unit in c, starting from the least significant */
  /* Convolution needs to be done only upto the MSB-1 unit of c, the
     last unit is the remainder
  */
  k = c->size -1;
  result = 0;
  carry = 0;
  do
  {
    /* Compute pointers to the least significant  a unit
       in the convolution and the most significant b unit in
       the convolution; Also compute the number of terms in the
       convolution.
    */

    temp = c->size - 1 -k;   /* The significance index of the term being
                                computed in the convolution */
    temp -= b->size -1;
    if (temp <= 0)
    {
      aterm = MP_LS_UNIT(a);
      bterm = MP_MS_PLUS_K_MS_UNIT(b, (0 - temp));
      terms = minimum(temp + b->size, a->size);
    }
    else
    {
      aterm = MP_LS_MINUS_K_LS_UNIT(a, temp);
      bterm = MP_MS_UNIT(b);
      terms = minimum(b->size, a->size - temp);
    }
    /* The innermost convolution loop */

    /* Take care of the compiler bug */
    if (ddebug)
        bug_the_compile_bug("bug_the_bug", k);
    do
    {
      result += ( (double_unit) (*(UNIT_MINUS_MINUS(aterm)))) *
                ( (double_unit) (*(UNIT_PLUS_PLUS(bterm))));

      /* Take care of the compiler bug */
      if (ddebug)
        bug_the_compile_bug("bug_the_bug_for_result", result);


      carry += get_upper_unit(result);
      result = get_lower_unit(result);
    } while (--terms);
    *(UNIT_MINUS_MINUS(cterm)) = get_lower_unit(result);
    result = get_lower_unit(carry);
        carry = get_upper_unit(carry);
  }
  while(--k);
  /* The last unit is the remainder */
  *cterm = get_lower_unit(result);
  /* Done; return 0 */
  return (0);

}


static int ICA_CALL special_mod(unit *msb_a, int size_a, unit n,
                               unit *msb_result,
                               int size_result)
{

  double_unit result=0;

  if (!n)
    return PKAMathFail;

  do
  {
    result <<= UNITSIZE;
    result += *(UNIT_PLUS_PLUS(msb_a));
    result %= (double_unit)n;

  }while(--size_a);

  while(--size_result)
  {
    *UNIT_PLUS_PLUS(msb_result) = 0;
  }
  *msb_result = get_lower_unit(result);

  return 0;
}
/*
   These routines give a trial quotient taking 2 or 3 units from a and
   a double unit, BEST IMPLEMENTED IN ASSEMBLY. NOTE in 3unit/2unit
   the first two units of the 3 unit are LESS that the 2 unit.
   the top unit of tryd is NOT ZERO.
*/
static unit ICA_CALL two_unit_divide(unit *areg, double_unit tryd)
{
  return((unit)((DOUBLE_UNIT_CAST(areg)) /tryd));

}
static unit ICA_CALL three_unit_divide(unit *areg, double_unit tryd)
{
  volatile double_unit dble;
  volatile unit result;
  volatile unit topd;
  volatile unit a0, a1, a2;


  a0 = *UNIT_PLUS_PLUS(areg);
  a1 = *UNIT_PLUS_PLUS(areg);
  a2 = *(areg);

  dble = (double_unit)(((double_unit)(a0)) << UNITSIZE) + a1;
  topd = get_upper_unit(tryd) + 1;
  if (topd)
    result =  (unit) (dble/topd);
  else
    result = get_upper_unit(dble);

  /*
     We are now sure that the quotient of the 3 unit/2unit will
     be greater than result.
  */

  /* Do the multiplication now, reuse dble */

  dble = (double_unit) result * (double_unit)(get_lower_unit(tryd));
  topd = a2 - get_lower_unit(dble);
  dble >>= UNITSIZE;
  dble += (double_unit) result * (double_unit)(get_upper_unit(tryd));

  if (topd > a2) dble++;
  a2 = topd;
  topd = a1 - get_lower_unit(dble);
  dble >>= UNITSIZE;
  if (topd > a1) dble++;

  a1 = topd;


  /* After the subtraction a0 may still be at most 1 and we know that
     one more subtraction will fix this
  */

  if (a0 != dble)
  {
    result++;
    dble =  (((double_unit)(a1) << UNITSIZE) + a2);
    dble -= tryd;
  }
  else
  {
    dble = (((double_unit)(a1) << UNITSIZE) + a2);
  }

  result += (unit) (dble/tryd);

  return(result);
}

/*
   Trial minus subtracts some multiple of unit array n of size nsize
   from a unit array a of size asize. The multiple is estimated to be
   try but in real life it could be 1 less than it.
   Returns 0 if the trial coefficient was OK, 1 if it was too big.
*/

static int ICA_CALL trial_minus (unit *areg, unit *nreg, int asize,
                                int nsize, unit tryq)
{

  register unit *r, *s;
  register double_unit result;
  register unit tryqq = tryq;
  register int i;
  char fail = 0;
  register char borrow = 0;
  unit temp[HW_SIZE+1];

#ifdef __LITTLE_ENDIAN__
  r = nreg - (nsize - 1);
  s = temp;
#else
#ifdef __BIG_ENDIAN__
  r = nreg + (nsize -1);
  s = temp + (asize - 1);
#else
  faketype  ERROR;
#endif
#endif

  /* Get n * tryq into temp */

  i = nsize;
  result = 0;
  do
  {
    result += (double_unit)tryqq * (double_unit)(*UNIT_MINUS_MINUS(r));
    *UNIT_MINUS_MINUS(s) = get_lower_unit(result);
    result = get_upper_unit(result);
  }while(--i);

  if (asize == nsize)
  {
    if (result)       /* Failed, must try with tryq - 1 */
    {
      fail = 1;
    }
  }
  else
  {
    *s = (unit) result;
  }

  /* Subtract anyways irrespective of failure */
#ifdef __LITTLE_ENDIAN__
  r = temp;
  s = areg - (asize -1);
#else
#ifdef __BIG_ENDIAN__
  r = temp + (asize -1);
  s = areg + (asize - 1);
#else
  faketype  ERROR;
#endif
#endif
  i = asize;
  do
  {
    result = (double_unit)*s - *UNIT_MINUS_MINUS(r) - borrow;
    *UNIT_MINUS_MINUS(s) = get_lower_unit(result);
    borrow =  (get_upper_unit(result) != 0) ? 1 : 0;
  }while(--i);

  fail += borrow;

  if (fail)
  {
    /* Need to add an n to the result */

#ifdef __LITTLE_ENDIAN__
    r = nreg - (nsize -1);
    s = areg - (asize -1);
#else
#ifdef __BIG_ENDIAN__
    r = nreg + (nsize -1);
    s = areg + (asize - 1);
#else
    faketype  ERROR;
#endif
#endif
    i = nsize;
    result = 0;
    do
    {
      result += (double_unit)*s + (double_unit)*UNIT_MINUS_MINUS(r);
      *UNIT_MINUS_MINUS(s) = get_lower_unit(result);
      result = get_upper_unit(result);
    }while(--i);
    if (asize > nsize)
    {
      *UNIT_MINUS_MINUS(s) += (unit) result;
    }
  }
  memset((char *)temp, 0, HW_SIZE * sizeof(unit));
  return((fail > 0) ? 1 : 0);
}

static int ICA_CALL local_mod(unit *msb_a, int size_a,
                              unit *msb_result,
                              unit *msb_n, int size_n)
{
  register int i;
  register unit *areg;
  register unit *nreg;
  double_unit tryd;
  unit tryq;
  register int large, asize, nsize;

  unit temp[2*HW_SIZE]; /* Working array */

  memset((char *)temp, 0, (sizeof(unit) * 2 * HW_SIZE));

  areg = MS_UNIT(temp, size_a);

  /* areg holds msb_a and nreg holds msb_n */
  mp_copy_unit_msb(areg, msb_a, size_a);
  nreg = msb_n;
  large = 0;
  nsize = size_n;
  /* Ensure that MS-UNIT of what we mod by in the main loop is
     non-zero.
  */
  while ( (!(*nreg)) && (nsize))
  {
    UNIT_PLUS_PLUS(nreg);
    nsize--;
  }
  if (!(nsize))
  {
    return PKAMathFail;
  }


  /* The rest of this procedure, esp the trial divisor part is assuming
     an nsize of at least 1. Anyway if nsize = 1 then a more efficient
     technique will be used.
  */

  if (nsize == 1)
  {
    int retval = special_mod(msb_a, size_a,  *nreg, msb_result, size_n);
    memset((char *)temp, 0, (sizeof(unit) * HW_SIZE));
    return retval;
  }

  asize = nsize; /* The size of the number we compare/divide multiple of
                    n from in the standard division algo
                 */
  /* The trial denominator */
  tryd = DOUBLE_UNIT_CAST(nreg);
  i = size_a - nsize;   /* These are the extra elements of a to
                           feed in the division process
                        */

  if (i < 0) goto out;

  /* Initial setting */
  /* get first nonzero value of a */

  while (!(*areg))
  {
    if (!(i)) goto out ;
    UNIT_PLUS_PLUS(areg);
    i--;
  }

  /* Initiate the long division/mod process where the a units are >= n */
  if (mp_compare_fast(areg, nreg, nsize) < 0)
  {
    if (!(i)) goto out;
    asize++;
    i--;
    large=1;
  }
  /* Main loop */
  for(;;)
  {
    if (!(*areg))
    {
      do
      {
        UNIT_PLUS_PLUS(areg);
        if (large)
        {
          asize = nsize;
          large = 0;
        }
        else
        {
          if (!(i)) goto out;
          i--;
        }
      }while(!(*areg));
      if (mp_compare_fast(areg, nreg, nsize) < 0)
      {
        if (!(i)) goto out;
        asize++;
        i--;
        large=1;
      }
    }
    /* Now areg upto size asize > nreg upto size nsize */
    tryq = (large) ?
            three_unit_divide(areg, tryd) : two_unit_divide(areg, tryd);
    if (!(tryq)) tryq--;              /* Very special case */

    tryq -= trial_minus(areg, nreg, asize, nsize, tryq);
    if (large)
    {
      if (!(i)) goto out;
      UNIT_PLUS_PLUS(areg);
      i--;
    }
    else
    {
      large = 1;
      if (!(i)) goto out;
      asize++;
      i--;
    }
  }

out:
  /* Copy the LEAST SIGNIFICANT size_n elements of temp into result */

  areg = LS_UNIT(temp, size_a);
  UNIT_PLUS_EQ(msb_result, size_n-1);

  do
  {
    *UNIT_MINUS_MINUS(msb_result) = *UNIT_MINUS_MINUS(areg);
  }while ((--size_a) && (--size_n));

  if (size_n > 0)
  {
    while(--size_n)
    {
      *UNIT_MINUS_MINUS(msb_result) = 0;
    }
  }

  /* Zero out temp so as to not leave anything on stack */
  memset((char *)temp, 0, (sizeof(unit) * HW_SIZE));
  return 0;

}

int hw_mod(unit *msb_a, int size_a, unit *msb_result,
                        unit *msb_n, int size_n)
{
  P_ENTER( P_hw_mod )
  assert( (size_a <= HW_SIZE ) && (size_n <= HW_SIZE));
  #ifdef __PROFILE__
  {
     int retval;
     retval = local_mod(msb_a, size_a, msb_result, msb_n, size_n);
     P_LEAVE( P_hw_mod )
     return retval;
  }
  #else
     return (local_mod(msb_a, size_a, msb_result, msb_n, size_n));
  #endif
}

#ifdef __LITTLE_ENDIAN__
#define uint_to_bigendian(b) (  \
                             (((u_int32) (b) & 0x000000ff) << 24) |  \
                             (((u_int32) (b) & 0x0000ff00) <<  8) |  \
                             (((u_int32) (b) & 0x00ff0000) >>  8) |  \
                             (((u_int32) (b) & 0xff000000) >> 24)    \
                             )
#else
#define uint_to_bigendian(b) (b)
#endif

#define BOUNDS_CHECK \
    if ((tokdatsize + extsize) > bufsize) \
    { \
      return(PKANoSpace); \
    }
//test --jpa
int fixed_hw_modmult(unit *msb_a, unit *msb_b, unit *msb_result,
                                    unit *msb_n, int nsize)
{
  mp_int t, a, b;
  unit temp[2*HW_SIZE];
  unit *msb_t;

  assert(nsize <= HW_SIZE);

  t.value = temp;
  t.maxsize = 2*HW_SIZE;

  a.size = nsize;
  b.size = nsize;

#ifdef __LITTLE_ENDIAN__
  a.value = msb_a - (nsize - 1);
  b.value = msb_b - (nsize - 1);

#else
#ifdef __BIG_ENDIAN__
  a.value = msb_a;
  b.value = msb_b;
#else
  faketype  ERROR;
#endif
#endif

  if (mult(&a, &b, &t))
    return PKAMathFail;
  msb_t = MP_MS_UNIT(&t);
  return(local_mod(msb_t, t.size, msb_result, msb_n, nsize));
}
//test --jpa

int hw_exponentiate(ICA_ADAPTER_HANDLE devhandle,
                    unit *msb_result, unit *msb_a, unit *msb_n, int size,
                    unit *msb_e, int esize)
{

#ifdef TRY_SW
  P_ENTER( P_sw_hw_exponentiate )

  unit *msb_temp, *msb_res, *t;
  unit mask;
  int i, j;
  unit temp_unit[HW_SIZE];

  /* Cheap Exponentiation, Peasant Method */
  assert(size <= HW_SIZE);
  assert(esize <=size);


  memset((char *)temp_unit, 0, HW_SIZE * sizeof(unit));

  msb_temp = MS_UNIT(temp_unit, size);
  *(LS_UNIT(temp_unit, size)) = 1;

  msb_res = msb_result;

  for (i=0; i < esize; i ++)
  {
        mask = ((unit)1) << (UNITSIZE - 1);
        for (j=0; j < UNITSIZE; j++, mask /= 2 )
        {
          /* Square */
          if (fixed_hw_modmult(msb_temp, msb_temp, msb_res, msb_n, size))
          {
            P_LEAVE( P_sw_hw_exponentiate )
            return PKAMathFail;
          }
          if ( (*msb_e) & mask)
          {
            if (fixed_hw_modmult(msb_res, msb_a, msb_temp, msb_n, size))
            {
              P_LEAVE( P_sw_hw_exponentiate )
              return PKAMathFail;
            }
          }
          else
          {
            t = msb_res;
            msb_res = msb_temp;
            msb_temp = t;
          }

          /* Now result will always be in temp */
        }
        UNIT_PLUS_PLUS(msb_e);
  }

  /* Copy over from temp_unit to result (if needed) */
  if (msb_temp != msb_result)
  {
    mp_copy_unit_msb(msb_result, msb_temp, size);
  }
  P_LEAVE( P_sw_hw_exponentiate )
  return (0);
#endif // TRY_SW

//--#ifdef NO_TRY_SW
    icaRB_t   requestBlk;
    unsigned int bufsize, tokdatsize, extsize, mlen, nLength, eLength,dLength;
    unsigned char keyModExpo[1024];
    ICA_KEY_RSA_MODEXPO *pModExpoToken = (ICA_KEY_RSA_MODEXPO *)&keyModExpo;
    unsigned char data[256];
    unsigned char result[256];
    unsigned int resultSize;
    unsigned int cbReturned, rc, success;
//test jpa
    memset(keyModExpo, 0, (sizeof(keyModExpo)));
    memset(data, 0, (sizeof(data)));
    memset(result, 0, (sizeof(result)));
//test jpa
    //
    // calculate exponent size in 256 bit blocks - for mod/expo, the exponent length must
    // equal the modulus length
    //

    mlen = ((size*sizeof(unit)*8)+255)/256;
    nLength = eLength = dLength = (mlen*256)/8;

    //
    // first we need to format the modulus/exponent into a "key" data structure
    // that the hardware can use - first write out the public exponent
    //

    bufsize = sizeof(keyModExpo);
//--    memset((unsigned char *)pModExpoToken, 0, sizeof(keyModExpo));
    tokdatsize = sizeof(struct _ICA_KEY_RSA_MODEXPO) - sizeof(ICA_KEY_RSA_MODEXPO_REC);
    extsize = eLength;
    pModExpoToken->expLength = uint_to_bigendian(eLength);
    pModExpoToken->expOffset = uint_to_bigendian(tokdatsize);
    BOUNDS_CHECK;
    mpint_to_bigendian_bytearray(msb_e, esize, (unsigned char *)pModExpoToken+tokdatsize, eLength);
    tokdatsize += eLength;

    //
    // now write out the modulus to the public token
    //

    extsize = nLength;
    pModExpoToken->nLength = uint_to_bigendian(nLength);
    pModExpoToken->nOffset = uint_to_bigendian(tokdatsize);
    BOUNDS_CHECK;
    mpint_to_bigendian_bytearray(msb_n, size, (unsigned char *)pModExpoToken+tokdatsize, nLength);
    tokdatsize += nLength;

    //
    // now write out the header info
    //

#ifdef linux   
    pModExpoToken->modulusBitLength = dLength*8;
#else
    pModExpoToken->modulusBitLength = uint_to_bigendian(dLength*8); 
#endif
    pModExpoToken->keyType = uint_to_bigendian(RSA_PUBLIC_MODULUS_EXPONENT);        //fake it out with a type
    pModExpoToken->keyLength = uint_to_bigendian(tokdatsize);

    //
    // Build the request block
    //

    // Convert input data from mp_int to big endian byte array
    mpint_to_bigendian_bytearray(msb_a, esize, (unsigned char *)data, dLength);
    requestBlk.ReqLen.length_1 = dLength;
    requestBlk.ReqPtr.pBuffer_1 = data;
    requestBlk.ReqPtr.pBuffer_2 = &keyModExpo;

    //
    // Build the reply block
    //

    resultSize= size*sizeof(unit);
    requestBlk.ReplyPtr.pBuffer_1 = &resultSize;
    requestBlk.ReplyPtr.pBuffer_2 = result;
    requestBlk.ica_status = HDDAccessDenied;

    //
    // send the modular exponentiation request to the kernel mode device driver
    //

#ifdef _WIN32
    success = DeviceIoControl(devhandle,
                              (unsigned long) IOCTL_CRYPTO_RSA_ME,
                              &requestBlk,           //User to driver data
                              sizeof(icaRB_t),
                              &requestBlk,           //Driver to user data
                              sizeof(icaRB_t),
                              &cbReturned,           //Count of bytes returned
                              NULL);                 //NULL = Thread blocks

    if (!success)
        rc = GetLastError();
    else {
        rc = 0;
        resultSize = requestBlk.ReplyLen.length_4;
        bigendian_bytearray_to_mpint(result, resultSize, resultSize*8, msb_result, size);
    }
#elif _TEST_STUB
    requestBlk.ReplyPtr.pBuffer_1 = msb_result;

    rc = icaModExpoStub(&requestBlk);
#elif linux
    
    rc = icaRsaModExpo(devhandle, 
		       dLength,
		       data,
		       pModExpoToken,
		       &resultSize,
		       result);
		
             
    if(rc==0)
      bigendian_bytearray_to_mpint(result, resultSize, resultSize*8, msb_result, size);
    
    return rc;

#endif

//test jpa
    memset(keyModExpo, 0, (sizeof(keyModExpo)));
    memset(data, 0, (sizeof(data)));
    memset(result, 0, (sizeof(result)));
//test jpa
    if (rc)
        return(mapSysErr(rc));            // Translate rc to Crypto error
    else
        return(requestBlk.ica_status);
//--#endif // NO_TRY_SW

}

int hw_modmult(ICA_ADAPTER_HANDLE devhandle, mp_int *a, mp_int *b, unit *msb_result,
               unit *msb_n,int nsize)
{
  mp_int t;
  unit temp[2*HW_SIZE];
  unit *msb_t;

  assert(nsize <= HW_SIZE);
  t.value = temp;
  t.maxsize = 2*HW_SIZE;

  if (mult(a, b, &t))
  {
    P_LEAVE( P_sw_hw_modmult )
    return PKAMathFail;
  }

  if (mp_truesize(&t) < nsize)
    mp_extend(&t, nsize);
  msb_t = MP_MS_UNIT(&t);
  #if(__PROFILE__)
  {
     int retval = local_mod(msb_t, t.size, msb_result, msb_n, nsize);
     P_LEAVE( P_sw_hw_modmult )
     return retval;
  }
  #else
     return (local_mod(msb_t, t.size, msb_result, msb_n, nsize));
  #endif
#ifdef NO_TRY_SW
    icaRB_t   requestBlk;
    unit *msb_a , *msb_b;
    unsigned int bufsize, tokdatsize, extsize, mlen, nLength, aLength, bLength;
    unsigned char keyModExpo[1024];
    ICA_KEY_RSA_MODEXPO *pModExpoToken = (ICA_KEY_RSA_MODEXPO *)&keyModExpo;
    unsigned char data[256];
    unsigned char result[256];
    unsigned int resultSize;
    unsigned int cbReturned, rc, success;
//test jpa
    memset(keyModExpo, 0, (sizeof(keyModExpo)));
    memset(data, 0, (sizeof(data)));
    memset(result, 0, (sizeof(result)));
//test jpa

    //
    // calculate exponent size in 256 bit blocks - for mod/expo, the exponent length must
    // equal the modulus length
    //

    mlen = ((nsize*sizeof(unit)*8)+255)/256;
    nLength = aLength = bLength = (mlen*256)/8;
    //
    // first we need to format the modulus/operand(b) into a "key" data structure
    // that the hardware can use - first write out operand(b)
    //

    msb_b = MP_MS_UNIT(b);
    bufsize = sizeof(keyModExpo);
//--    memset((unsigned char *)pModExpoToken, 0, sizeof(keyModExpo));
    tokdatsize = sizeof(struct _ICA_KEY_RSA_MODEXPO) - sizeof(ICA_KEY_RSA_MODEXPO_REC);
    extsize = bLength;
    pModExpoToken->expLength = uint_to_bigendian(bLength);
    pModExpoToken->expOffset = uint_to_bigendian(tokdatsize);
    BOUNDS_CHECK;
    mpint_to_bigendian_bytearray(msb_b, b->size, (unsigned char *)pModExpoToken+tokdatsize, bLength);
    tokdatsize += bLength;

    //
    // now write out the modulus to the public token
    //

    extsize = nLength;
    pModExpoToken->nLength = uint_to_bigendian(nLength);
    pModExpoToken->nOffset = uint_to_bigendian(tokdatsize);
    BOUNDS_CHECK;
    mpint_to_bigendian_bytearray(msb_n, nsize, (unsigned char *)pModExpoToken+tokdatsize, nLength);
    tokdatsize += nLength;

    //
    // now write out the header info
    //
    
#ifdef linux
    pModExpoToken->modulusBitLength = nLength * 8;
#else
    pModExpoToken->modulusBitLength = uint_to_bigendian(nLength*8); 
#endif

    pModExpoToken->keyType = uint_to_bigendian(RSA_PUBLIC_MODULUS_EXPONENT);        //fake it out with a type
    pModExpoToken->keyLength = uint_to_bigendian(tokdatsize);

    //
    // Build the request block
    //

    msb_a = MP_MS_UNIT(a);
    // Convert input data from mp_int to big endian byte array
    mpint_to_bigendian_bytearray(msb_a, a->size, (unsigned char *)data, aLength);
    requestBlk.ReqLen.length_1 = aLength;
    requestBlk.ReqPtr.pBuffer_1 = data;
    requestBlk.ReqPtr.pBuffer_2 = &keyModExpo;

    //
    // Build the reply block
    //

    resultSize= nsize*sizeof(unit);
    requestBlk.ReplyPtr.pBuffer_1 = &resultSize;
    requestBlk.ReplyPtr.pBuffer_2 = result;
    requestBlk.ica_status = HDDAccessDenied;

    //

    //
    // send the modular exponentiation request to the kernel mode device driver
    //

#ifdef _WIN32
    success = DeviceIoControl(devhandle,
                              (unsigned long) IOCTL_CRYPTO_RSA_MULT,
                              &requestBlk,           //User to driver data
                              sizeof(icaRB_t),
                              &requestBlk,           //Driver to user data
                              sizeof(icaRB_t),
                              &cbReturned,           //Count of bytes returned
                              NULL);                 //NULL = Thread blocks

    if (!success)
        rc = GetLastError();
    else {
        rc = 0;
        resultSize = requestBlk.ReplyLen.length_4;
        bigendian_bytearray_to_mpint(result, resultSize, resultSize*8, msb_result, nsize);
    }
#elif _TEST_STUB
    requestBlk.ReplyPtr.pBuffer_1 = msb_result;

    rc = icaModMultStub(&requestBlk);

#elif linux
   
    rc = icaRsaModMult(devhandle, 
		       aLength,
		       data,
		       pModExpoToken,
		       &resultSize,
		       result);
		
    if(rc==0)
      bigendian_bytearray_to_mpint(result, resultSize, resultSize*8, msb_result, nsize);
         
    return rc;

#endif

//test jpa
    memset(keyModExpo, 0, (sizeof(keyModExpo)));
    memset(data, 0, (sizeof(data)));
    memset(result, 0, (sizeof(result)));
//test jpa
    if (rc)
        return(mapSysErr(rc));            // Translate rc to Crypto error
    else
        return(requestBlk.ica_status);

#endif // NO_TRY_SW
}
