
/*
             Common Public License Version 0.5

             THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF
             THIS COMMON PUBLIC LICENSE ("AGREEMENT"). ANY USE,
             REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES
             RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT.

             1. DEFINITIONS

             "Contribution" means: 
                   a) in the case of the initial Contributor, the
                   initial code and documentation distributed under
                   this Agreement, and 

                   b) in the case of each subsequent Contributor:
                   i) changes to the Program, and
                   ii) additions to the Program;

                   where such changes and/or additions to the Program
                   originate from and are distributed by that
                   particular Contributor. A Contribution 'originates'
                   from a Contributor if it was added to the Program
                   by such Contributor itself or anyone acting on such
                   Contributor's behalf. Contributions do not include
                   additions to the Program which: (i) are separate
                   modules of software distributed in conjunction with
                   the Program under their own license agreement, and
                   (ii) are not derivative works of the Program.


             "Contributor" means any person or entity that distributes
             the Program.

             "Licensed Patents " mean patent claims licensable by a
             Contributor which are necessarily infringed by the use or
             sale of its Contribution alone or when combined with the
             Program. 

             "Program" means the Contributions distributed in
             accordance with this Agreement.

             "Recipient" means anyone who receives the Program under
             this Agreement, including all Contributors.

             2. GRANT OF RIGHTS

                   a) Subject to the terms of this Agreement, each
                   Contributor hereby grants Recipient a
                   non-exclusive, worldwide, royalty-free copyright
                   license to reproduce, prepare derivative works of,
                   publicly display, publicly perform, distribute and
                   sublicense the Contribution of such Contributor, if
                   any, and such derivative works, in source code and
                   object code form.

                   b) Subject to the terms of this Agreement, each
                   Contributor hereby grants Recipient a
                   non-exclusive, worldwide, royalty-free patent
                   license under Licensed Patents to make, use, sell,
                   offer to sell, import and otherwise transfer the
                   Contribution of such Contributor, if any, in source
                   code and object code form. This patent license
                   shall apply to the combination of the Contribution
                   and the Program if, at the time the Contribution is
                   added by the Contributor, such addition of the
                   Contribution causes such combination to be covered
                   by the Licensed Patents. The patent license shall
                   not apply to any other combinations which include
                   the Contribution. No hardware per se is licensed
                   hereunder.

                   c) Recipient understands that although each
                   Contributor grants the licenses to its
                   Contributions set forth herein, no assurances are
                   provided by any Contributor that the Program does
                   not infringe the patent or other intellectual
                   property rights of any other entity. Each
                   Contributor disclaims any liability to Recipient
                   for claims brought by any other entity based on
                   infringement of intellectual property rights or
                   otherwise. As a condition to exercising the rights
                   and licenses granted hereunder, each Recipient
                   hereby assumes sole responsibility to secure any
                   other intellectual property rights needed, if any.

                   For example, if a third party patent license is
                   required to allow Recipient to distribute the
                   Program, it is Recipient's responsibility to
                   acquire that license before distributing the
                   Program.

                   d) Each Contributor represents that to its
                   knowledge it has sufficient copyright rights in its
                   Contribution, if any, to grant the copyright
                   license set forth in this Agreement.

             3. REQUIREMENTS

             A Contributor may choose to distribute the Program in
             object code form under its own license agreement, provided
             that:
                   a) it complies with the terms and conditions of
                   this Agreement; and

                   b) its license agreement:
                   i) effectively disclaims on behalf of all
                   Contributors all warranties and conditions, express
                   and implied, including warranties or conditions of
                   title and non-infringement, and implied warranties
                   or conditions of merchantability and fitness for a
                   particular purpose;

                   ii) effectively excludes on behalf of all
                   Contributors all liability for damages, including
                   direct, indirect, special, incidental and
                   consequential damages, such as lost profits;

                   iii) states that any provisions which differ from
                   this Agreement are offered by that Contributor
                   alone and not by any other party; and

                   iv) states that source code for the Program is
                   available from such Contributor, and informs
                   licensees how to obtain it in a reasonable manner
                   on or through a medium customarily used for
                   software exchange.

             When the Program is made available in source code form:
                   a) it must be made available under this Agreement;
                   and
                   b) a copy of this Agreement must be included with
                   each copy of the Program. 

             Contributors may not remove or alter any copyright notices
             contained within the Program.

             Each Contributor must identify itself as the originator of
             its Contribution, if any, in a manner that reasonably
             allows subsequent Recipients to identify the originator of
             the Contribution. 


             4. COMMERCIAL DISTRIBUTION

             Commercial distributors of software may accept certain
             responsibilities with respect to end users, business
             partners and the like. While this license is intended to
             facilitate the commercial use of the Program, the
             Contributor who includes the Program in a commercial
             product offering should do so in a manner which does not
             create potential liability for other Contributors.
             Therefore, if a Contributor includes the Program in a
             commercial product offering, such Contributor ("Commercial
             Contributor") hereby agrees to defend and indemnify every
             other Contributor ("Indemnified Contributor") against any
             losses, damages and costs (collectively "Losses") arising
             from claims, lawsuits and other legal actions brought by a
             third party against the Indemnified Contributor to the
             extent caused by the acts or omissions of such Commercial
             Contributor in connection with its distribution of the
             Program in a commercial product offering. The obligations
             in this section do not apply to any claims or Losses
             relating to any actual or alleged intellectual property
             infringement. In order to qualify, an Indemnified
             Contributor must: a) promptly notify the Commercial
             Contributor in writing of such claim, and b) allow the
             Commercial Contributor to control, and cooperate with the
             Commercial Contributor in, the defense and any related
             settlement negotiations. The Indemnified Contributor may
             participate in any such claim at its own expense.


             For example, a Contributor might include the Program in a
             commercial product offering, Product X. That Contributor
             is then a Commercial Contributor. If that Commercial
             Contributor then makes performance claims, or offers
             warranties related to Product X, those performance claims
             and warranties are such Commercial Contributor's
             responsibility alone. Under this section, the Commercial
             Contributor would have to defend claims against the other
             Contributors related to those performance claims and
             warranties, and if a court requires any other Contributor
             to pay any damages as a result, the Commercial Contributor
             must pay those damages.


             5. NO WARRANTY

             EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE
             PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT
             WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR
             IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR
             CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR
             FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely
             responsible for determining the appropriateness of using
             and distributing the Program and assumes all risks
             associated with its exercise of rights under this
             Agreement, including but not limited to the risks and
             costs of program errors, compliance with applicable laws,
             damage to or loss of data, programs or equipment, and
             unavailability or interruption of operations. 

             6. DISCLAIMER OF LIABILITY
             EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER
             RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY
             FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
             OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION
             LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF
             LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
             (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
             OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE
             OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE
             POSSIBILITY OF SUCH DAMAGES.

             7. GENERAL

             If any provision of this Agreement is invalid or
             unenforceable under applicable law, it shall not affect
             the validity or enforceability of the remainder of the
             terms of this Agreement, and without further action by the
             parties hereto, such provision shall be reformed to the
             minimum extent necessary to make such provision valid and
             enforceable.


             If Recipient institutes patent litigation against a
             Contributor with respect to a patent applicable to
             software (including a cross-claim or counterclaim in a
             lawsuit), then any patent licenses granted by that
             Contributor to such Recipient under this Agreement shall
             terminate as of the date such litigation is filed. In
             addition, If Recipient institutes patent litigation
             against any entity (including a cross-claim or
             counterclaim in a lawsuit) alleging that the Program
             itself (excluding combinations of the Program with other
             software or hardware) infringes such Recipient's
             patent(s), then such Recipient's rights granted under
             Section 2(b) shall terminate as of the date such
             litigation is filed.

             All Recipient's rights under this Agreement shall
             terminate if it fails to comply with any of the material
             terms or conditions of this Agreement and does not cure
             such failure in a reasonable period of time after becoming
             aware of such noncompliance. If all Recipient's rights
             under this Agreement terminate, Recipient agrees to cease
             use and distribution of the Program as soon as reasonably
             practicable. However, Recipient's obligations under this
             Agreement and any licenses granted by Recipient relating
             to the Program shall continue and survive. 

             Everyone is permitted to copy and distribute copies of
             this Agreement, but in order to avoid inconsistency the
             Agreement is copyrighted and may only be modified in the
             following manner. The Agreement Steward reserves the right
             to publish new versions (including revisions) of this
             Agreement from time to time. No one other than the
             Agreement Steward has the right to modify this Agreement.

             IBM is the initial Agreement Steward. IBM may assign the
             responsibility to serve as the Agreement Steward to a
             suitable separate entity. Each new version of the
             Agreement will be given a distinguishing version number.
             The Program (including Contributions) may always be
             distributed subject to the version of the Agreement under
             which it was received. In addition, after a new version of
             the Agreement is published, Contributor may elect to
             distribute the Program (including its Contributions) under
             the new version. Except as expressly stated in Sections
             2(a) and 2(b) above, Recipient receives no rights or
             licenses to the intellectual property of any Contributor
             under this Agreement, whether expressly, by implication,
             estoppel or otherwise. All rights in the Program not
             expressly granted under this Agreement are reserved.


             This Agreement is governed by the laws of the State of New
             York and the intellectual property laws of the United
             States of America. No party to this Agreement will bring a
             legal action under this Agreement more than one year after
             the cause of action arose. Each party waives its rights to
             a jury trial in any resulting litigation. 



*/

/* (C) COPYRIGHT International Business Machines Corp. 2001          */


/***********************************************************************
***                                                                  ***
***       (C) COPYRIGHT IBM CORP  1997                               ***
***                                                                  ***
***       LICENSED MATERIALS  -  PROPERTY OF IBM                     ***
***                                                                  ***
***       All Rights Reserved                                        ***
***                                                                  ***
***       U.S. Government Users Restricted Rights - Use,             ***
***       duplication or disclosure restricted by GSA ADP            ***
***       Schedule Contract with IBM Corp.                           ***
***                                                                  ***
***                                                                  ***
***       ORIGINS: RES (IBM Research Division)                       ***
***                                                                  ***
************************************************************************
*
* Module Name:       mp_modul.c
*
* Descriptive Name:  Public Key cryptographic Algorithm manager (PKA_MGR)
*                    2048-bit modular arithmetic using 1024-bit hardware
*
* Status:            Release 1 Version 1
*
* Function:          2048-bit modular arithmetic using 1024-bit hardware
*                    implements mult & higher order functions.
*
*
* Module type:
*      Processor:    Intel x86 family
*
*      Language:     C source
*
*      Compiler:     IBM VisualAge on OS/2
*
* Restrictions:
*
* Linkage:           these routines are called by the PKA manager
*
*
*
* Change History:    written Feb 1997 by Pankaj Rohatgi
*                    IBM Research, Hawthorne, NY
*
*
*   Date    Ver   Notes                                            by
* --------- ----  -----                                            ---
* 01-Feb-97       initial implementation                           PR
* 01-Nov-97       added routines to help for x9.31 spec.           SC
* 01-Dec-98       added PKCS Decrypt routine                       JPA
* 03-Dec-98       assert brings in printf...not for MB             jgd
* 29-Jan-99       remove compiler msgs..                           jgd
* 08-Feb-00       ...with explanation of 29-Jan-99 change       JPA,jgd
* 01-March-99    -test pkcs keytype prime p and prime q            jpa
*                 length moved to mp_hw & mp_sw
*                -- Defect-879
* 08-Mar-99      profiling...                                      jgd
* 08-Feb-2000    Conditional Compile for MODEXTN.LIB               jpa
*                New Lib may be used in UDX or Toolkit for access
*                to additional Mod Math functions
* 22-Sep-2000    KEY Generation Error                              jpa
*                mp_meta_mod changed because of KeyGen error
*                that caused Key to fail validation test.
*                Fix found by Pankaj
*                -- Defect-1687
* 02-Feb-2001    Potential memory overwrite in mp_rabin_miller     jpa
*                The mp_copy(&t,&p) normalized 't' to a t.size
*                less then size, subsequent shift_right of 't'
*                for size would overwrite outside of 't'
*                -- Defect-1789
***********************************************************************/
#ifndef __PROFILE__
#define __PROFILE__ 0
#endif
#include "profiler.h"

#include <string.h>
/*    #include <assert.h>        jgd */
#include "platform.h"
#include "mp_hw.h"
#include "x931prim.h"
#include "fips.h"
#include "pkamgr.h"

int from_rm = 0;
static const unit unit_msb_mask = (((unit) 1) << (UNITSIZE - 1));
static const unit allone =  (unit) ((int) -1);
static const unit allone_minus_1 = (unit)((int) -2);

static char init = 0;
static unit allones[HW_SIZE];
static unit allones_minus_1[HW_SIZE];
static int ICA_CALL mp_mult_by_unit(mp_int *c, mp_int *b, unit a);

static int ICA_CALL maxI(int a, int b)
{
    return ( (a > b) ? a: b);
}

static void ICA_CALL set_allone(unit *msb, int size)
{
    while (size--)
    {
        *UNIT_PLUS_PLUS(msb) = allone;
    }
}

static void ICA_CALL init_allones(void)
{
  int i;
  if (init)
    return;
  else
    init=1;
  for (i=0; i< HW_SIZE; i++)
  {
    allones_minus_1[i] = allones[i] = allone;
  }
  init = 1;
  *LS_UNIT(allones_minus_1, HW_SIZE) = allone_minus_1;

}

static int ICA_CALL is_allones(unit *msb, int size)
{
  if (!size) return 0;
  do
  {
    if ( (*UNIT_PLUS_PLUS(msb)) != allone)
      return 0;
  }while(--size);
  return 1;
}

/* Shift left by 1, (mult by 2), returns overflow (0 or 1) */

unit shift_left(unit *lsb_a, int size)
{
    unit carry_in = 0;
    unit carry_out;

    P_ENTER( P_shift_left )

    do {
        carry_out = (((*lsb_a) & (unit_msb_mask)) ? 1: 0);
        *lsb_a <<= 1;
        *UNIT_MINUS_MINUS(lsb_a) += carry_in;
        carry_in = carry_out;
    }while (--size);

    P_LEAVE( P_shift_left )

    return carry_out;

}

/* Shift right by 1, (div by 2), returns discarded rightmost bit (0 or 1) */

unit shift_right(unit *msb_a, int size)
{
  unit carry_in = 0;
  unit carry_out;

  P_ENTER( P_shift_right )

  do
  {
    carry_out = (((*msb_a) & ((unit)1)) ? unit_msb_mask: 0);
    *msb_a /= 2;
    *UNIT_PLUS_PLUS(msb_a) += carry_in;
    carry_in = carry_out;
  }while (--size);

  P_LEAVE( P_shift_right)
  return carry_out;

}

static int ICA_CALL mp_mult_by_unit(mp_int *c, mp_int *b, unit a)
{
  double_unit result = 0;
  unit *lsb_b = MP_LS_UNIT(b);
  unit *lsb_c = MP_LS_UNIT(c);
  int size;

  size = b->size;
   if ( size ) {
  do
  {
    result +=  (double_unit ) (*UNIT_MINUS_MINUS(lsb_b) ) * a;
    *UNIT_MINUS_MINUS(lsb_c) = get_lower_unit(result);
    result = get_upper_unit(result);
  }while (--size);
  *lsb_c = get_lower_unit(result);   }
  else c->size = 0;
  return 0;
}

static int ICA_CALL mult_by_allones(mp_int *c, mp_int *b, int length_of_allones)
{
  unit *r, *s;
  register int i = length_of_allones;

  r = MP_LS_UNIT(c);
  do
  {
    *UNIT_MINUS_MINUS(r) = 0;
  }while(--i);

  i = b->size;
  s = MP_LS_UNIT(b);

  do
  {
    *UNIT_MINUS_MINUS(r) = *UNIT_MINUS_MINUS(s);
  }while(--i);


  i = mp_minus_eq(MP_LS_UNIT(c), MP_LS_UNIT(b), b->size);
  if (i)
  {
    s = MP_LS_MINUS_K_LS_UNIT(c, b->size);
    mp_minus_eq_unit(s, (unit)i, c->size - b->size);

  }
  return 0;

}


/* This special function uses the modmult hw to actually
   find out the result of a multiplication
*/

static int ICA_CALL extract_mult_from_mod_hw(ICA_ADAPTER_HANDLE devhandle,
                                                                                         mp_int *c, mp_int *a, mp_int *b)
{
  int size;
  unit temp[HW_SIZE];
  unit *msb_r, *msb_t, *lsb_r, *lsb_t;
  int extra;

  size = c->size = a->size + b->size;
  if (c->size <= HW_SIZE)
    return (hw_modmult(devhandle, a, b, MP_MS_UNIT(c), MS_UNIT(allones, size), size));
  /*
    Simple algorithm. Let
    a * b = X * (allones = 2^HW_SIZE - 1) + R where R < allones.
    R can be computed by taking mod with allones
    X can be computed using R and T = a *b (mod allones_minus_1)
  */

  msb_r = MP_LS_MINUS_K_LS_UNIT(c, HW_SIZE -1); /* reuse space in c */
  msb_t = MS_UNIT(temp, HW_SIZE);
  lsb_r = MP_LS_UNIT(c);
  lsb_t = LS_UNIT(temp, HW_SIZE);

  if (hw_modmult(devhandle, a, b, msb_r,  MS_UNIT(allones, HW_SIZE), HW_SIZE))
    return PKAMathFail;
  if (hw_modmult(devhandle, a, b, msb_t, MS_UNIT(allones_minus_1, HW_SIZE), HW_SIZE))
  {
    memset(temp, 0, HW_SIZE *sizeof(unit));
    return PKAMathFail;
  }

  if (mp_minus_eq(lsb_t, lsb_r, HW_SIZE))
  {
    mp_minus_eq_unit(lsb_t, (unit) 2, HW_SIZE);
  }
  /* Now we have X and R */

  /* Move X to the the c units above HW_SIZE */
  /* Abuse msb_r as a pointer to these units */

  extra = size - HW_SIZE;   /* Units of X to be copied into MSB's of c */
  MINUS_MINUS_UNIT(msb_r);
  mp_copy_unit_lsb(msb_r, lsb_t, extra);

  /* Now we need to subtract X from c */
  if (mp_minus_eq(lsb_r, lsb_t, HW_SIZE))
  {
    mp_minus_eq_unit(msb_r, (unit) 1, extra);
  }
  return 0;
}


/* c->size = a->size + b->size.
   a and b are not allones.
   b fits in the HW and is tiny, i.e., <= HW_SIZE/2.
   In this case we process chunks of HW sized pieces
   using 1 modmult for 1 multiplication
*/
static int ICA_CALL mult_long_by_tiny(ICA_ADAPTER_HANDLE devhandle,
                                                                          mp_int *c, mp_int *a, mp_int *b)
{

    unit temp[HW_SIZE];
    mp_int t, ta;
    int i;
    int asize = a->size;
    int bsize = b->size;
    int retval = 0;

    unit *lsb_c = MP_LS_UNIT(c);
    int carry = 0;
    int achunk, acur;

    t.maxsize =  HW_SIZE;
    t.value = temp;

    i = c->size;
    do
    {
        *UNIT_MINUS_MINUS(lsb_c) = 0;
    }while (--i);

    mp_normalize(a);
    mp_normalize(b);

    achunk = HW_SIZE - b->size;
    acur = a->size;

    lsb_c = MP_LS_UNIT(c);


#ifdef __LITTLE_ENDIAN__
    ta.value = a->value;
#else
#ifdef __BIG_ENDIAN__
    ta.value = a->value + (a->size - ((a->size > achunk) ? achunk: a->size));
#else
    faketype ERROR;
#endif
#endif

    while (acur > 0)
    {
        if (acur < achunk)
            ta.size = acur;
        else
            ta.size = achunk;

        acur -= ta.size;

        t.size = b->size + ta.size;

        if ((retval = hw_modmult(devhandle, &ta, b, MP_MS_UNIT(&t),
             MS_UNIT(allones, t.size), t.size)) != 0)
            break;

        if (carry)
        {
            carry = mp_plus_eq_unit(lsb_c, (unit) carry, t.size);
        }

        carry += mp_plus_eq_unit_lsb(lsb_c, MP_LS_UNIT(&t), t.size);

        UNIT_MINUS_EQ(lsb_c, ta.size);

#ifdef __LITTLE_ENDIAN__
        ta.value += ta.size;
#else
#ifdef __BIG_ENDIAN__
        ta.value -= ta.size;
#else
        faketype ERROR;
#endif
#endif
    }
    memset(temp, 0, HW_SIZE*sizeof(unit));
    mp_extend(a, asize);
    mp_extend(b, bsize);
    return retval;
}



/* c->size = a->size + b->size.
   a and b are not allones.
   b fits in the HW
*/

static int ICA_CALL mult_long_by_short(ICA_ADAPTER_HANDLE devhandle,
                                                                           mp_int *c, mp_int *a, mp_int *b)
{

  unit temp[2*HW_SIZE];
  mp_int t, ta;
  int i;
  int asize = a->size;
  unit *lsb_c = MP_LS_UNIT(c);
  int carry = 0;
  int retval = 0;

  /* Zero out c */
  i = c->size;
  do
  {
    *UNIT_MINUS_MINUS(lsb_c) = 0;
  }while (--i);

  lsb_c = MP_LS_UNIT(c);
  ta.maxsize = HW_SIZE;
  t.maxsize = HW_SIZE + b->size;
  t.value = temp;

#ifdef __LITTLE_ENDIAN__
  ta.value = a->value;
#else
#ifdef __BIG_ENDIAN__
  if (asize >= HW_SIZE)
    ta.value = a->value + (a->size - HW_SIZE);
  else
    ta.value = a->value;
#else
  faketype ERROR;
#endif
#endif

  while(asize > 0)
  {
    if (asize >= HW_SIZE)
    {
      ta.size = HW_SIZE;
      asize -= HW_SIZE;
    }
    else
    {
      ta.size = asize;
      asize = 0;
    }

    t.size = ta.size + b->size;
    if (is_allones(MP_MS_UNIT(&ta), ta.size))
    {
      mult_by_allones(&t, b, ta.size);
    }
    else
      retval = extract_mult_from_mod_hw(devhandle, &t, &ta, b);

    if (retval)
      break;

    if (carry)
    {
      carry = mp_plus_eq_unit(lsb_c, (unit) carry, t.size);
    }

    carry += mp_plus_eq_unit_lsb(lsb_c, MP_LS_UNIT(&t), t.size);

    UNIT_MINUS_EQ(lsb_c, ta.size);

#ifdef __LITTLE_ENDIAN__
    ta.value += ta.size;
#else
#ifdef __BIG_ENDIAN__
    ta.value -= ta.size;
#else
    faketype ERROR;
#endif
#endif

  }

  memset(temp, 0, 2*HW_SIZE*sizeof(unit));
  return retval;
}


/*
    c = a * b; c->maxsize assumed to be at least a->size + b->size
    c->size will be set to a->size + b->size with NO normalization
*/
static int ICA_CALL direct_mp_multiply(ICA_ADAPTER_HANDLE devhandle,
                                                                           mp_int *c, mp_int *a, mp_int *b)
{
  int size;

  FSMSTATE("PKA2201")     /* been here done this! */
  size =  c->size = a->size + b->size;

  /* Take care of some annoying base cases */
  if (a->size == 1)
  {
    return(mp_mult_by_unit(c, b, *(a->value)));
  }
  else
  {
    if (b->size == 1)
    {
      return(mp_mult_by_unit(c, a, *(b->value)));
    }
  }

  if (size <= HW_SIZE)
  {
    return (hw_modmult(devhandle, a, b, MP_MS_UNIT(c),
               MS_UNIT(allones, size), size));
  }


  if ( (a->size <= HW_SIZE) || (b->size <= HW_SIZE))
  {
    FSMSTATE("PKA2202")     /* been here done this! */
    if (is_allones(MP_MS_UNIT(a), a->size))
    {
      return(mult_by_allones(c, b, a->size));
    }
    else
    {
      if (is_allones(MP_MS_UNIT(b), b->size))
      {
        return(mult_by_allones(c, a, b->size));
      }
    }

    if ((a->size <= HW_SIZE) && (b->size <= HW_SIZE))
      return extract_mult_from_mod_hw(devhandle, c, a, b);

    if (a->size <= HW_SIZE)
    {
      if (a->size <= HW_SIZE/2)
        return mult_long_by_tiny(devhandle, c, b, a);  /* This is optimized  for the
                                               HW Chararteristic */
      else
        return mult_long_by_short(devhandle, c, b, a);
    }
    else
    {
      if (b->size <= HW_SIZE/2)
        return mult_long_by_tiny(devhandle, c, a, b); /* This is optimized for HW
                                              characteristic  */
      else
        return mult_long_by_short(devhandle, c, a, b);
    }

  }
  else
  {
    /* For speed do karatsuba when sizes are equal and multiple of 2 */
    /* Those mults will be the workhorse */

    if ((a->size == b->size) && (a->size %2 == 0))
    {

      /* Karatsuba */
      /* Since this code will only need one karatsuba recursion
         to reach hw assisted mult, instead of being
         recursive it just calls the extract_mult_from_mod_hw(c, a, b)
         function
      */
      unit *a1ma0, *b0mb1;
      unit ma1ma0cb0mb1[2*HW_SIZE], middle[MAXSIZE];
      int sign = 0;
      int newsize;
      mp_int rec_a, rec_b, rec_c;
      int karatret=0;

      FSMSTATE("PKA2203")
      newsize = size/4;
      rec_a.maxsize = rec_a.size = rec_b.size = rec_b.maxsize = newsize;
      rec_c.maxsize = rec_c.size = size/2;

      /* The next two calls are the extreme terms in the karatsuba algorithm.
         Trick, which extreme value each of these 2 calls are actually depends
         on the endianness of the machine
      */
      rec_a.value = a->value + newsize;
      rec_b.value = b->value + newsize;
      rec_c.value = c->value + size/2;

      karatret = direct_mp_multiply(devhandle, &rec_c, &rec_a, &rec_b);
      if (karatret)
          return karatret;

      rec_a.value = a->value;
      rec_b.value = b->value;
      rec_c.value = c->value;

      karatret = direct_mp_multiply(devhandle, &rec_c, &rec_a, &rec_b);

      if (karatret)
          return karatret;

      a1ma0 = LS_UNIT(ma1ma0cb0mb1, newsize);
      b0mb1 = LS_UNIT(ma1ma0cb0mb1 + newsize, newsize);
      /* Yet another trick, we want to compute (a1 - a0 ) * (b0 - b1)
         but depending on endianness we will either calculate this
         or (a0 - a1) * (b1 - b0) which is the same thing
      */
      if (mp_compare_fast(MS_UNIT(a->value, newsize),
                          MS_UNIT((a->value + newsize), newsize),
                          newsize)  < 0)
      {
        sign++;
        mp_copy_unit_lsb(a1ma0, LS_UNIT((a->value + newsize), newsize),
                                newsize);
        mp_minus_eq(a1ma0, LS_UNIT(a->value, newsize), newsize);

      }
      else
      {
        mp_copy_unit_lsb(a1ma0, LS_UNIT(a->value, newsize), newsize);
        mp_minus_eq(a1ma0, LS_UNIT((a->value + newsize), newsize), newsize);
      }

      if (mp_compare_fast(MS_UNIT((b->value + newsize), newsize),
                          MS_UNIT(b->value, newsize), newsize) < 0)
      {
        sign++;
        mp_copy_unit_lsb(b0mb1, LS_UNIT(b->value, newsize), newsize);
        mp_minus_eq(b0mb1, LS_UNIT((b->value + newsize), newsize), newsize);

      }
      else
      {
        mp_copy_unit_lsb(b0mb1, LS_UNIT((b->value + newsize), newsize),
                         newsize);
        mp_minus_eq(b0mb1, LS_UNIT(b->value, newsize), newsize);
      }

      rec_a.value = ma1ma0cb0mb1;
      rec_b.value = ma1ma0cb0mb1 + newsize;
      rec_c.value = middle;

      karatret = direct_mp_multiply(devhandle, &rec_c, &rec_a, &rec_b);
      if (karatret)
      {
         memset(ma1ma0cb0mb1, 0 , 2*HW_SIZE*sizeof(unit));
         memset(middle, 0, MAXSIZE * sizeof(unit));
         return karatret;
      }
      /*
         Now combine everything. Use ma1ma0cb0mb1 as a temp and abuse
         the variable rec_a rec_b;
      */

      rec_a.maxsize=rec_b.maxsize=rec_a.size=rec_b.size = size/2;
      rec_a.value = ma1ma0cb0mb1;
      rec_b.value = c->value;
      mp_copy_unit_lsb(MP_LS_UNIT(&rec_a), MP_LS_UNIT(&rec_b), size/2);
      rec_b.value = middle;
      if (sign %2 == 0)
      {
        if (mp_plus_eq(&rec_a, &rec_b))
          sign = 1;
        else
          sign = 0;
      }
      else
      {
        if (mp_minus_eq(MP_LS_UNIT(&rec_a), MP_LS_UNIT(&rec_b), size/2))
          sign = -1;
        else
          sign = 0;

      }
      rec_b.value = c->value + size/2;
      if (mp_plus_eq(&rec_a, &rec_b))
        sign++;

      rec_b.value = c->value + size/4;

      if (mp_plus_eq(&rec_b, &rec_a))
        sign++;

      if (sign > 0)
      {
        mp_plus_eq_unit(MP_LS_MINUS_K_LS_UNIT(c, (size/4)*3),
                                  (unit)sign, size/4);
      }
      else
      {
        if (sign < 0)
        {
          mp_minus_eq_unit(MP_LS_MINUS_K_LS_UNIT(c, (size/4)*3) ,
                           (unit)(0 - sign), size/4);
        }
      }

      memset(ma1ma0cb0mb1, 0, 2*HW_SIZE*sizeof(unit));
      memset(middle, 0, MAXSIZE*sizeof(unit));
      return karatret;
    }
    else
    {
      /* Really not  time critical */
      /* Split a and b into two peices, use four recursive calls */
      unit a0b1[MAXSIZE];
      unit b0a1[MAXSIZE];
      mp_int rec_a, rec_b, rec_c;
      int a0size, a1size, b0size, b1size;
      int fourret = 0;

      FSMSTATE("PKA2204")
      a0size = a->size/2;
      b0size = b->size/2;
      a1size = a->size - a0size;
      b1size = b->size - b0size;


      /* The first term, a0b0 which is put in the LSB's of c */
      rec_a.size = rec_a.maxsize = a0size;
      rec_b.size = rec_b.maxsize = b0size;
      rec_c.size = rec_c.maxsize = a0size + b0size;

#ifdef __LITTLE_ENDIAN__
      rec_a.value = a->value;
      rec_b.value = b->value;
      rec_c.value = c->value;
#else
#ifdef __BIG_ENDIAN__
      rec_a.value = a->value + a1size;
      rec_b.value = b->value + b1size;
      rec_c.value = c->value + (a1size+b1size);
#else
      faketype ERROR;
#endif
#endif
      fourret = direct_mp_multiply(devhandle, &rec_c, &rec_a, &rec_b);

      if (fourret)
               return (fourret);

      /* Now we compute the a0b1 term */
      rec_b.maxsize = rec_b.size = b1size;
      rec_c.maxsize = rec_c.size = a0size + b1size;
      rec_c.value = a0b1;

#ifdef __LITTLE_ENDIAN__
      rec_b.value = b->value + b0size;
#else
#ifdef __BIG_ENDIAN__
      rec_b.value = b->value;
#else
      faketype ERROR;
#endif
#endif

      fourret = direct_mp_multiply(devhandle, &rec_c, &rec_a, &rec_b);

      if (fourret)
      {
              memset(a0b1, 0, MAXSIZE*sizeof(unit));
              return fourret;
      }

      /* Now the a1b1 term which gets put in the MSB's of c */

      rec_a.size = rec_a.maxsize = a1size;
      rec_c.size = rec_c.maxsize = a1size + b1size;

#ifdef __LITTLE_ENDIAN__
      rec_a.value = a->value + a0size;
      rec_c.value = c->value + (a0size + b0size);
#else
#ifdef __BIG_ENDIAN__
      rec_a.value = a->value;
      rec_c.value = c->value;

#else
      faketype ERROR;
#endif
#endif
      fourret = direct_mp_multiply(devhandle, &rec_c, &rec_a, &rec_b);
      if (fourret)
      {
              memset(a0b1, 0, MAXSIZE*sizeof(unit));
              return fourret;
      }

      /* Now we do the a1b0 term */
      rec_b.maxsize=rec_b.size=b0size;
      rec_c.maxsize=rec_c.size=b0size + a1size;
      rec_c.value = b0a1;

#ifdef __LITTLE_ENDIAN__
      rec_b.value = b->value;
#else
#ifdef __BIG_ENDIAN__
      rec_b.value = b->value + b1size;
#else
      faketype ERROR;
#endif
#endif
      fourret = direct_mp_multiply(devhandle, &rec_c, &rec_a, &rec_b);
      if (fourret)
      {
           memset(b0a1, 0, MAXSIZE*sizeof(unit));
           memset(a0b1, 0, MAXSIZE*sizeof(unit));
           return fourret;
      }


      /* Now combine everything */
      /* First add in the a0b1 term */
      rec_a.size = rec_a.maxsize = a0size + b1size;
      rec_a.value = a0b1;

      rec_c.size = rec_c.maxsize = c->size - b0size;

#ifdef __LITTLE_ENDIAN__
      rec_c.value = c->value + b0size;
#else
#ifdef __BIG_ENDIAN__
      rec_c.value = c->value;
#else
      faketype ERROR;
#endif
#endif

      mp_plus_eq(&rec_c, &rec_a);

      /* Now add in the a1b0 term */

      rec_a.size = rec_a.maxsize = a1size + b0size;
      rec_a.value = b0a1;

      rec_c.size = rec_c.maxsize = c->size - a0size;

#ifdef __LITTLE_ENDIAN__
      rec_c.value = c->value + a0size;
#else
#ifdef __BIG_ENDIAN__
      rec_c.value = c->value;
#else
      faketype ERROR;
#endif
#endif

      mp_plus_eq(&rec_c, &rec_a);
      memset(b0a1, 0, MAXSIZE*sizeof(unit));
      memset(a0b1, 0, MAXSIZE*sizeof(unit));
      return fourret;
    }
  }
}


static int ICA_CALL indirect_mp_multiply(ICA_ADAPTER_HANDLE devhandle,
                                                                                 mp_int *c, mp_int *a, mp_int *b)
{
  unit temp[2*MAXSIZE]; /* This should always be big enough. */
  mp_int t;
  int retval;

  FSMSTATE("PKA1505")
  t.size = a->size + b->size;
  t.maxsize = 2*MAXSIZE;
  t.value = temp;

  retval = direct_mp_multiply(devhandle, &t, a, b);

  if (retval)
  {
    memset(temp, 0, 2*MAXSIZE*sizeof(unit));
    return retval;
  }
  /* normalize t, copy into c and check overflow */
  if (mp_copy(c, &t))
  {
    memset(temp, 0, 2*MAXSIZE*sizeof(unit));
    return PKAMathFail;
  }
  else
    return retval;
}

/* c = a*b ; size of c could be a->size + b->size - 1 */
int mp_multiply(ICA_ADAPTER_HANDLE devhandle, mp_int *c, mp_int *a, mp_int *b)
{
   FSMSTATE("PKA1504")
   P_ENTER( P_mp_multiply )

   if ( (a->size > MAXSIZE) || (b->size > MAXSIZE))
   {
     P_LEAVE( P_mp_multiply )
     return PKAMathFail;
   }
   if (c->maxsize < a->size + b->size - 1)
   {
     P_LEAVE( P_mp_multiply )
     return PKAMathFail;
   }
   else
   {
     if (c->maxsize > a->size + b->size - 1)
     {
       #if(__PROFILE__)
       {
         int retval = direct_mp_multiply(devhandle, c, a, b);
         P_LEAVE( P_mp_multiply )
         return retval;
       }
       #else
         return(direct_mp_multiply(devhandle, c, a, b));
       #endif
     }
     else
     {
       #if(__PROFILE__)
       {
         int retval = indirect_mp_multiply(devhandle, c, a, b);
         P_LEAVE( P_mp_multiply )
         return retval;
       }
       #else
         return (indirect_mp_multiply(devhandle, c, a, b));
       #endif
     }
   }
}
/*  c = a^2; c assumed big enough */

#ifndef _MODEXTNLIB
int mp_square(ICA_ADAPTER_HANDLE devhandle, mp_int *c, mp_int *a)
{
    /* For the workhorse usage in modular exponentiaion
       where a is of size > HW_SIZE, we have a special recursive
       routine more efficient than multiplication, otherwise
       we route this request to a regular multiplication
       request
    */
    FSMSTATE("PKA1703")
    P_ENTER( P_mp_square )
    if(
           (c->maxsize >= 2* (a->size))
       &&  (a->size > HW_SIZE)
       &&  (a->size %2 == 0)
      )
    {
        unit a1a0 [MAXSIZE];
        mp_int rec_c, rec_a, rec_b;
        int size = a->size;
        int newsize = size/2;
        int squareret = 0;

        unit carry;

        c->size = 2 *(size);
        /* First the recursive square calls */
        /* Here again semantiacally things will be different depending on
           little endian and big endian  */

        rec_c.maxsize = rec_c.size = size;
        rec_a.size = rec_a.maxsize = newsize;
        rec_a.value = a->value;
        rec_c.value = c->value;

        squareret = mp_square(devhandle, &rec_c, &rec_a);

        if (squareret)
        {
             P_LEAVE( P_mp_square )
             return (squareret);
        }

        rec_c.value = c->value + size;
        rec_a.value = a->value + newsize;

        squareret = mp_square(devhandle, &rec_c, &rec_a);
        if (squareret)
        {
              P_LEAVE( P_mp_square )
              return (squareret);
        }

        /* Now to compute the a1a0 term */

        rec_b.size  = rec_b.maxsize = newsize;
        rec_b.value = a->value;

        rec_c.value = a1a0;

        squareret = direct_mp_multiply(devhandle, &rec_c, &rec_a, &rec_b);

        if (squareret)
        {
          memset(a1a0, 0, MAXSIZE *sizeof(unit));
          P_LEAVE( P_mp_square )
          return (squareret);
        }
        /* We now compute 2*a1a0, if overflow put in carry */
        carry = shift_left(LS_UNIT(a1a0, size), size);
        rec_a.value = c->value + newsize;
        rec_a.maxsize=rec_a.size=size;

        if (mp_plus_eq(&rec_a, &rec_c))
            carry++;
        if (carry)
        {

            rec_a.size = newsize;
#ifdef __LITTLE_ENDIAN__
            rec_a.value = c->value + size + newsize;
#else
#ifdef __BIG_ENDIAN__
            rec_a.value = c->value;
#else
faketype ERROR;
#endif
#endif
            mp_plus_eq_unit(MP_LS_UNIT(&rec_a), carry,  newsize);

        }
        memset(a1a0, 0, MAXSIZE*sizeof(unit));
        P_LEAVE( P_mp_square )
        return squareret;

    }
    else
      {
         #if(__PROFILE__)
           int square2ret = mp_multiply(devhandle, c, a, a);
           P_LEAVE( P_mp_square )
           return square2ret;
         #else
           return mp_multiply(devhandle, c, a, a);
         #endif
      }
}
#endif /**** _MODEXTNLIB **/

static int ICA_CALL is_zero_metaunit(unit *msb, int metaunit)
{
  do
  {
    if ((*UNIT_PLUS_PLUS(msb)))
      return 0;
  }while(--metaunit);
  return 1;
}

static int ICA_CALL is_one_metaunit(unit *msb, int metaunit)
{
  metaunit--;
  while(metaunit--)
  {
    if ( (*UNIT_PLUS_PLUS(msb)) != 0)
      return 0;
  };
  if (*msb != 1)
    return 0;
  else
    return 1;
}

static int ICA_CALL is_one_zero_metaunit(unit *msb, int metaunit)
{
  if (is_one_metaunit(msb, metaunit))
  {
    UNIT_PLUS_EQ(msb, metaunit);
    return (is_zero_metaunit(msb, metaunit));

  }
  else
  {
    return 0;
  }
}

/* This takes as input two mp_ints A and B and returns the
quotient A/B. Some properties assumed of the input are.
1) Q = A/B < B-1
3) A and B both fit in HW.

The returned quotient is of the same size as B.

Returns a nonzero failure value.

*/

static int ICA_CALL compute_quotient_from_hw_mod(unit *msb_a, int asize,
                                                unit *msb_b,
                                                int bsize, unit *msb_q)
{
    unit temp1[2*(HW_SIZE/3)], temp2[2*(HW_SIZE/3)];
    unit *msb_bm1;
    unit *t;
    unit *r;
    int retval = 0;

    FSMSTATE("PKA2110")     /* been here done this */
    msb_bm1 = MS_UNIT(temp1, bsize);
    mp_copy_unit_msb(msb_bm1, msb_b, bsize);
    mp_minus_eq_unit(LS_UNIT(temp1, bsize), (unit)1, bsize);
    t = msb_q;
    r = MS_UNIT(temp2, bsize);

    /* Compute T = A mod B-1 */
    retval = hw_mod(msb_a, asize, t, msb_bm1, bsize);


    /* Compute R = A mod B,*/
    if (!retval)
      retval = hw_mod(msb_a, asize, r, msb_b, bsize);


    if (!retval)
    {
      if (mp_compare_fast(t, r, bsize) >= 0)
      {
        /* T > R so q is T-R, T is already in q*/
        mp_minus_eq(UNIT_PLUS_K(t, bsize-1), LS_UNIT(temp2, bsize), bsize);
      }
      else
      {
        /* T < R so Q = T + (B-1) - R; */
        mp_minus_eq(LS_UNIT(temp1, bsize), LS_UNIT(temp2, bsize), bsize);
        mp_plus_eq_unit_lsb(UNIT_PLUS_K(t, bsize-1), LS_UNIT(temp1, bsize),
                                bsize);
      }
    }
    memset(temp1, 0, 2*(HW_SIZE/3)*sizeof(unit));
    memset(temp2, 0, 2*(HW_SIZE/3)*sizeof(unit));
    return retval;
}

/* Divisor not 10 */
/* divident 2* metaunit units long
   divisor  2* metaunit units long
   To compute the quotient

   Returns a nonzero failure value

*/


static int  ICA_CALL two_metaunit_divide(unit *msb_divident, unit *msb_divisor,
                                unit *msb_result, int metaunit)
{

  unit fullq[2*(HW_SIZE/3)];
  int retval = 0;

  FSMSTATE("PKA2108")     /* been here done this */
  retval = compute_quotient_from_hw_mod(msb_divident, 2*metaunit,
                                        msb_divisor, 2*metaunit,
                                        MS_UNIT(fullq, 2*metaunit));
  if (!retval)
    mp_copy_unit_lsb(UNIT_PLUS_K(msb_result, metaunit-1),
                                        LS_UNIT(fullq, 2*metaunit), metaunit);
  memset(fullq, 0, 2*(HW_SIZE/3)*sizeof(unit));
  return retval;
}


/*
  Returns the result of dividing given 3 metaunits by given two
  metaunits. Result if a metaunit. The first two metaunits of
  the divident can be at most the first two units of the divisor
  Returns allones if top 2 units of divident= 2 metaunits being divided by.
  Also divisor is not 10

  Returns a nonzero failure value
*/
static int  ICA_CALL three_metaunit_divide(unit *msb_3_unit, unit *msb_2_unit,
                                          unit *msb_result, int metaunit)
{
  unit fullq[2*(HW_SIZE/3)];
  int retval = 0;

  FSMSTATE("PKA2107")     /* been here done this! */
  if (mp_compare_fast(msb_3_unit, msb_2_unit, 2* metaunit) == 0)
  {
    set_allone(msb_result, metaunit);
    return 0;
  }
  /* O/w less */

  retval = compute_quotient_from_hw_mod(msb_3_unit, 3*metaunit, msb_2_unit,
                               2*metaunit, MS_UNIT(fullq, 2*metaunit));
  if (!retval)
    mp_copy_unit_lsb(UNIT_PLUS_K(msb_result, metaunit-1),
                                 LS_UNIT(fullq, 2*metaunit),
                                 metaunit);
  memset(fullq, 0, 2*(HW_SIZE/3)*sizeof(unit));
  return retval;

}



/*
   Trial minus subtracts some multiple of unit array msb_n of size
   nsize*metaunit from a unit array msb_a of size asize*metaunit.
   The multiple is estimated to be tryq which is metaunit units long but
   in real life it could be 1 less than it.
   This should be coded in assembly. Returns 0 if the trial coefficient
   was OK, -1 if it was too big and some other nonzero value (not -1)
   if some math failure occurs.

*/

static int ICA_CALL trial_minus (ICA_ADAPTER_HANDLE devhandle,
                                                                 unit *msb_a, unit *msb_n, int asize,
                                 int nsize, unit *tryq, int metaunit)
{
  unit temp[MAXSIZE + 2*(HW_SIZE/3)];
  mp_int multiple;
  mp_int a, n, q;
  int retval=0;

  FSMSTATE("PKA2109")     /* been here done this! */
  multiple.maxsize = MAXSIZE + 2*(HW_SIZE/3);
  multiple.value = temp;
  multiple.size  = (nsize + 1)*metaunit;

  n.size = n.maxsize = nsize *metaunit;
  q.size = q.maxsize = metaunit;
  a.size =  a.maxsize = asize*metaunit;

#ifdef __LITTLE_ENDIAN__
  n.value = msb_n - (nsize*metaunit -1);
  q.value = tryq - (metaunit -1);
  a.value = msb_a - (asize*metaunit -1);
#else
#ifdef __BIG_ENDIAN__
  n.value=msb_n;
  q.value=tryq;
  a.value=msb_a;
#else
  faketype ERROR;
#endif
#endif

  retval = direct_mp_multiply(devhandle, &multiple, &n, &q);
  if (retval)
  {
    /* Insurance against someone messing up return code definitions */
    if (retval == -1)
      retval = -2;
    memset(temp, 0, (MAXSIZE + 2*(HW_SIZE/3))*sizeof(unit));
    return retval;
  }

  /* Now subtract from a, note that potentially a is smaller sized
     than n
  */

  if (asize == nsize)
  {
    if ( mp_minus_eq(MP_LS_UNIT(&a), MP_LS_UNIT(&multiple), asize*metaunit)
        || (*MP_MS_UNIT(&multiple)))
    {
      retval = -1;
      mp_plus_eq_unit_lsb(MP_LS_UNIT(&a), MP_LS_UNIT(&n), nsize*metaunit);
    }
  }
  else
  {
    if (mp_minus_eq(MP_LS_UNIT(&a), MP_LS_UNIT(&multiple), asize*metaunit))
    {
      int carry;
      retval = -1;
      carry = mp_plus_eq_unit_lsb(MP_LS_UNIT(&a),
                                  MP_LS_UNIT(&n), nsize*metaunit);
      if (carry)
        mp_plus_eq_unit(UNIT_PLUS_K(msb_a,
                                  (metaunit -1)), (unit)1, metaunit);
    }
  }
  memset(temp, 0, (MAXSIZE + 2*(HW_SIZE/3))*sizeof(unit));
  return retval;
}


/* a and n are mp_ints each of size a multiple of metaunit
   units. sizeof a >= sizeof n. n is at least three metaunits long.
   Most significant metaunit of n is not 0.
   Hw assistance to compute upto 3 metaunit/2 metaunit
   is available. True sizes of a and n are given which may be
   used in the processing. (Given a and n may have sizes more
   than 2*MAXSIZE). Reduce a to a mod n, output quotient
   result to q if q is not null
*/

static int ICA_CALL mp_meta_mod(ICA_ADAPTER_HANDLE devhandle,
                                                                mp_int *a, mp_int *n,
                                mp_int *q, int metaunit)
{
  int asize, nsize, i;
  int large = 0;
  unit *tryd;   /* The trial denominator is of size 2 * metaunit */
  int one_zero; /* This will be nonzero iff the most sig metaunit of
                   tryd is 1 and least sig is 0 */

  unit *qreg, *areg, *nreg;
  unit temp[HW_SIZE/3];
  unit *tryq;
  int retval = 0;

  FSMSTATE("PKA2106")       /* been here done this! */
  nsize = n->size/metaunit;
  tryd = MP_MS_UNIT(n);
  tryq = MS_UNIT(temp, metaunit);
  one_zero = is_one_zero_metaunit(tryd, metaunit);


  asize = nsize; /* The size of the number we compare/divide multiple of
                    n from in the standard division algo
                 */
  i = (a->size/metaunit) - nsize; /* These are the extra elements of a to
                                     feed in the division process
                                  */
  if (q)
  {
    qreg = MS_UNIT(q->value, q->maxsize);
    q->size = 0;
  }
  else
    qreg = 0;

  areg = MP_MS_UNIT(a);
  nreg = MP_MS_UNIT(n);


  /* Initiate the long division/mod process where the a units are >= n */
  if (mp_compare_fast(areg, nreg, nsize * metaunit) < 0)
  {
    if (!(i)) goto out;
    asize++;
    i--;
    large=1;
  }
  /* Main loop */
  for (;;)
  {
    if (is_zero_metaunit(areg, metaunit))
    {
      do
      {
        UNIT_PLUS_EQ(areg, metaunit);
        if (large)
        {
          asize = nsize;
          large = 0;
        }
        else
        {
          {
            int j = metaunit;
            do
            {
              *UNIT_PLUS_PLUS(qreg) = 0;
            }while (--j);

          }
          q->size += metaunit;
          if (!(i)) goto out;
          i--;
        }
      }while(is_zero_metaunit(areg, metaunit));

      if (mp_compare_fast(areg, nreg, metaunit * nsize) < 0)
      {
        if (!(i)) goto out;
        asize++;
        i--;
        large=1;
      }
    }
    /* Now areg upto size asize > nreg upto size nsize */
    if (one_zero)
    {
      /* Special case */
      if (large)
      {
        /* The only way this is possible is that the two most significant
           metaunits of a are also 1 0. But a upto nsize metaunits is less
           than n.
           In this case the trial quotient or in fact the actual quotient
           has to be allones
        */
        set_allone(tryq, metaunit);

      }
      else
      {
        mp_copy_unit_msb(tryq, areg, metaunit);
      }
    }
    else
    {
      if (large)
        retval = three_metaunit_divide(areg, tryd, tryq, metaunit);
      else
        retval = two_metaunit_divide(areg, tryd, tryq, metaunit);
    }

    if (retval)
    {
      if (retval == -1)
            retval = -2;
      goto out;
    }

    retval = trial_minus(devhandle, areg, nreg, asize, nsize, tryq, metaunit);

    if (retval == -1)
    {
      mp_minus_eq_unit(LS_UNIT(temp, metaunit), (unit) 1, metaunit);
      retval = 0;
    }
    else
    {
      if (retval)
             goto out;
    }

    if (qreg)
    {
      {
        unit *s = tryq;
        int j = metaunit;
        while(j--)
        {
          *UNIT_PLUS_PLUS(qreg) = *UNIT_PLUS_PLUS(s);
        }
      }
      q->size += metaunit;
    }
    if (large)
    {
      if (!(i)) goto out;
      UNIT_PLUS_EQ(areg, metaunit);
      i--;
    }
    else
    {
      large = 1;
      if (!(i)) goto out;
      asize++;
      i--;
    }
  }

out:

  /* Clean up q, i.e., make it a valid mp_int. In big-endian
  case there is nothing to do, o/w we have to adjust where
  q starts in its array
  */

#ifdef __LITTLE_ENDIAN__
  if (!retval)
  {
    if (q)
      q->value = q->value + (q->maxsize - q->size);
  }
#endif

  /* Zero out temp so as to not leave anything on stack */

  memset(temp, 0, (sizeof(temp)));

  return retval;

}

/*
   Special case where c = a mod b, where n is 1 unit long
   q if nonzero will hold the quotient
*/
static int ICA_CALL special_mod(mp_int *a, unit b, mp_int *c, mp_int *q)
{

  double_unit temp;
  unit *msb_a, *msb_q;
  int asize;

  asize = a->size;
  msb_a = MP_MS_UNIT(a);
  c->size = 1;

  while (!(*msb_a))
  {
    UNIT_PLUS_PLUS(msb_a);
    asize--;
  }

  if (q)
  {
    if (*msb_a >= b)
    {
      q->size = asize;
      temp = 0;
    }
    else
    {
      if (q->maxsize < asize - 1)
           return PKAMathFail;
      else
           q->size = asize -1;
      temp = *UNIT_PLUS_PLUS(msb_a);
      asize--;
    }
    msb_q = MP_MS_UNIT(q);
    while (asize --)
    {
      temp <<= UNITSIZE;
      temp += *UNIT_PLUS_PLUS(msb_a);
      *msb_q = (unit)((double_unit)temp/(double_unit)b);
      temp  -= ((double_unit)(*UNIT_PLUS_PLUS(msb_q)))
                           *(double_unit)b;
    }
    c->value[0] = get_lower_unit(temp);
  }
  else
  {
    temp = 0;
    while(asize--)
    {
      temp <<= UNITSIZE;
      temp += *UNIT_PLUS_PLUS(msb_a);
      temp %= b;
    }
    c->value[0] = get_lower_unit(temp);
  }

  return 0;
}

/*
   Compute c = a (mod n)
   If q != NULL then the quotient is moved to q, size of q must
   be at least size of a - real size of n
   (i.e., after ignoring leading 0's).
   The size of upon exit will be exactly the size of n. Therefore
   a's maxsize must be at least that of n;

  One of the critical things this routine does is to identify a meta-unit
  which consists of several units. Then the mp_ints involved in the
  computation can be reformulated as consisting of an array of
  metaunits as opposed to an array of units

  The metaunit is the largest collection of units has the following property.

  1) The divisor  is AT LEAST 2 metaunits long.
  2) The hardware is capable of directly performing a mod operation with
     something which is 3 metaunits long.

  3) Adjust operands internally so as to make them multiples of
     metaunits.

  When n is large (at least as large as HW_SIZE) then the size of a metaunit
  is constrained by 2) and hence a metaunit is of size approx HW_SIZE/3 units
  otherwise it is constrained by 1).
*/

int mp_mod(ICA_ADAPTER_HANDLE devhandle,
                   mp_int *a, mp_int *n, mp_int *c,  mp_int *q)
{
  P_ENTER( P_mp_mod )

  int ntrue, atrue;
  int i;
  unit *s, *r;

  FSMSTATE("PKA2101")      /* been here done this! */
  if (c->maxsize < n->size)
  {
    P_LEAVE( P_mp_mod )
    return PKAMathFail;
  }
  /* First take care of the simple base case where the hardware
     can do what is required
  */

  if ((a->size <= HW_SIZE) && (n->size <= HW_SIZE) && (q == NULL))
  {
    FSMSTATE("PKA2102")     /* been here done this! */
    c->size = n->size;
    #if(__PROFILE__)
    {
    int retval = hw_mod(MP_MS_UNIT(a), a->size, MP_MS_UNIT(c),
                   MP_MS_UNIT(n), n->size);
    P_LEAVE( P_mp_mod )
    return retval;
    }
    #else
    return (hw_mod(MP_MS_UNIT(a), a->size, MP_MS_UNIT(c),
                   MP_MS_UNIT(n), n->size));
    #endif
  }

  /* Now the case where we have to intervene */

  atrue = mp_truesize(a);
  ntrue = mp_truesize(n);
  c->size = n->size;
  if (ntrue == 0)
  {
    P_LEAVE( P_mp_mod )
    return PKAMathFail;
  }

  /* Base case, if c is obviously less than n just copy over and return
  */
  if (atrue < ntrue)
  {
    FSMSTATE("PKA2103")
    if (q !=NULL)
    {
      q->size = 1;
      *(q->value) = 0;
    }
    i = atrue;
    s = MP_LS_UNIT(c);
    r = MP_LS_UNIT(a);
    while(i--)
    {
      *UNIT_MINUS_MINUS(s) = *UNIT_MINUS_MINUS(r);
    };

    i = n->size - atrue;

    while(i--)
    {

      *UNIT_MINUS_MINUS(s) = 0;
    }

    P_LEAVE(P_mp_mod)
    return 0;
  };
  /* Now get rid of the case when ntrue is small, i.e., only 1 unit
     and therefore the calculation can be done directly
     without invoking hw
  */
  if (ntrue == 1)
  {
    unit unit_n = *MP_LS_UNIT(n);
    FSMSTATE("PKA2104")
    #if(__PROFILE__)
    {
       int retval = special_mod(a, unit_n, c, q);
       P_LEAVE( P_mp_mod )
       return retval;
    }
    #else
       return special_mod(a, unit_n, c, q);
    #endif
  }
  else
  {
    /* Compute the size of a metaunit in units */
    int metaunit;
    mp_int newa, newq, newn;
    unit tempa[2*MAXSIZE+HW_SIZE/3];  /*
                                        holds the divident, main routine
                                        destroys it so we keep a copy
                                      */
    unit tempn[MAXSIZE + HW_SIZE/3];  /* Used to hold n */
    unit tempq[MAXSIZE + HW_SIZE/3];  /* Used to hold q,
                                         later remove this */


    FSMSTATE("PKA2105")    /* been here done this! */


    metaunit = ntrue/3;
    if ((metaunit * 3) < ntrue)
      metaunit++;
    if (metaunit > HW_SIZE/3)
      metaunit = HW_SIZE/3;

    /* First take care of a */
    /* How many metaunits in a ?*/

    i = atrue/metaunit;
    if (i * metaunit < atrue)
      i++;
    /*
      We create these larger arrays to hold copies of parameters
      whose size is a multiple of metaunits. In some parts of
      the processing we deal with metaunits at a time (to
      do division/mod), yet at other times we deal with
      units so it is advisable to keep the true sizes around
    */
    newa.maxsize = 2*MAXSIZE+HW_SIZE/3;
    newa.size = i*metaunit;
    newa.value = tempa;

    i = atrue;
    s = MP_LS_UNIT(a);
    r = MP_LS_UNIT(&newa);

    while (i--)
    {
      *UNIT_MINUS_MINUS(r) = *UNIT_MINUS_MINUS(s);
    }
    i = newa.size - atrue;
    while (i--)
    {
      *UNIT_MINUS_MINUS(r) = 0;
    }
    /* Now take care of n */
    i = ntrue/metaunit;
    if (i*metaunit < ntrue)
      i++;
    newn.maxsize = MAXSIZE+HW_SIZE/3;
    newn.size = i*metaunit;
    newn.value = tempn;

    i = ntrue;
    s = MP_LS_UNIT(n);
    r = MP_LS_UNIT(&newn);

    while (i--)
    {
      *UNIT_MINUS_MINUS(r) = *UNIT_MINUS_MINUS(s);
    }
    i = newn.size - ntrue;
    while (i--)
    {
      *UNIT_MINUS_MINUS(r) = 0;
    }

    newq.maxsize = MAXSIZE + HW_SIZE/3;
    newq.value = tempq;

    if (q)
    {
      i = mp_meta_mod(devhandle, &newa, &newn, &newq, metaunit);
    }
    else
    {
      i = mp_meta_mod(devhandle, &newa, &newn, NULL, metaunit);
    }

    if (!(i))
    {
      /* Copy back results */
      /* in the last n->size units of c goes the last n->size units
         of newa
      */
      mp_copy(c, &newa);
      mp_extend(c, n->size);

      if (q)
      {
        if (mp_copy(q, &newq))
          i = PKAMathFail;
      }

    }
    /* Clean up temps */
    memset(tempa,0,sizeof(tempa));
    memset(tempn,0,sizeof(tempn));
    if (q)
    {
      memset(tempq, 0, sizeof(tempq));
    }
    P_LEAVE( P_mp_mod )
    return (i);
  }
}


/* Modular Multiplication */
/* c = a * b (mod n) (all of size size) Make sure a, b  < n*/
#ifndef _MODEXTNLIB
int mp_modmult(ICA_ADAPTER_HANDLE devhandle,
                           unit *msb_c, unit *msb_a, unit *msb_b, unit *msb_n, int size)
{
    P_ENTER( P_mp_modmult )

    unit temp[2*MAXSIZE];
    mp_int c, a, b, n, t;
    int retval = 0;

    FSMSTATE("PKA1503")
    c.size=c.maxsize=a.size=a.maxsize=b.size=b.maxsize=n.size=n.maxsize=size;
#ifdef __LITTLE_ENDIAN__
    c.value = msb_c - (size -1);
    a.value = msb_a - (size -1);
    b.value = msb_b - (size -1);
    n.value = msb_n - (size -1);
#else
#ifdef __BIG_ENDIAN__
    c.value = msb_c;
    a.value = msb_a;
    b.value = msb_b;
    n.value = msb_n;
#else
    faketype ERROR;
#endif
#endif

    if (size > HW_SIZE)
    {
        t.maxsize = 2*MAXSIZE;
        t.size=2*size;
        t.value = temp;
        retval = mp_multiply(devhandle, &t, &a, &b);
        if (!retval)
           retval = mp_mod(devhandle, &t, &n, &c, NULL);
        memset(temp, 0, 2*MAXSIZE * sizeof(unit));
        P_LEAVE( P_mp_modmult )
        return retval;
    }
    else
    {
        #if(__PROFILE__)
        retval = hw_modmult(devhandle, &a, &b, msb_c, msb_n, size);
        P_LEAVE( P_mp_modmult )
        return retval;
        #else
        return hw_modmult(devhandle, &a, &b, msb_c, msb_n, size);
        #endif
    }
}
#endif /**** _MODEXTNLIB **/

/* Modular Squaring */
/* c = a^2 (mod n) */
#ifndef _MODEXTNLIB
int mp_modsquare(ICA_ADAPTER_HANDLE devhandle, unit *msb_c, unit *msb_a, unit *msb_n, int size)
{
    P_ENTER( P_mp_modsquare )

    unit temp[2*MAXSIZE];
    mp_int c, a, b, n, t;
    int retval = 0;

    FSMSTATE("PKA1701")
    c.size=c.maxsize=a.size=a.maxsize=b.size=b.maxsize=n.size=n.maxsize=size;
#ifdef __LITTLE_ENDIAN__
    c.value = msb_c - (size -1);
    a.value = msb_a - (size -1);
    b.value = msb_a - (size -1);
    n.value = msb_n - (size -1);
#else
#ifdef __BIG_ENDIAN__
    c.value = msb_c;
    a.value = msb_a;
    b.value = msb_a;
    n.value = msb_n;
#else
    faketype ERROR;
#endif
#endif

    if (size <= HW_SIZE)
    {
        #if(__PROFILE__)
        retval = hw_modmult(devhandle, &a, &b, msb_c, msb_n, size);
        P_LEAVE( P_mp_modsquare )
        return retval;
        #else
        return hw_modmult(devhandle, &a, &b, msb_c, msb_n, size);
        #endif

    }
    else
    {
        t.maxsize = 2*MAXSIZE;
        t.size=2*size;
        t.value = temp;
        retval = mp_square(devhandle, &t, &a);

        if (!retval)
          retval = mp_mod(devhandle, &t, &n, &c, NULL);

        memset(temp, 0, 2*MAXSIZE * sizeof(unit));
        P_LEAVE( P_mp_modsquare )
        return retval;
    }
}
#endif /**** _MODEXTNLIB **/

#ifndef _MODEXTNLIB
/* Modular Exponentiation */
/*  c = a ^e (mod n) , assume esize <= size*/
int mp_exponentiate(ICA_ADAPTER_HANDLE devhandle, unit *msb_c, unit *msb_a, unit *msb_n, int size,
                    unit *msb_e, int esize)
{
  P_ENTER( P_mp_exponentiate )

  unit *msb_temp, *msb_res, *t;
  unit mask;
  int i, j;
  unit temp_unit[MAXSIZE];
  int retval = 0;
  int started=0;

  FSMSTATE("PKA1501")
  if ((size > MAXSIZE) || (esize > size))
  {
    P_LEAVE( P_mp_exponentiate )
    return (PKAMathFail);
  }
  if (size <= HW_SIZE)
  {
    #if(__PROFILE__)
    retval = hw_exponentiate(devhandle, msb_c, msb_a, msb_n, size, msb_e, esize);
    P_LEAVE( P_mp_exponentiate )
    return retval;
    #else
    return (hw_exponentiate(devhandle, msb_c, msb_a, msb_n, size, msb_e, esize));
    #endif
  }

  /*
     There are 4 choices. Use regular arithmetic or montgomery
     method and use peasant method or quaternian/octerian method
  */

  /* Code for regular arithmetic/ peasant method (the worst combination) */
  memset((char *)temp_unit, 0, MAXSIZE * sizeof(unit));

  msb_temp = MS_UNIT(temp_unit, size);
  *(LS_UNIT(temp_unit, size)) = 1;
  msb_res = msb_c;
  mp_copy_unit_msb(msb_res, msb_temp, size);

  for (i=0; i < esize; i ++)
  {

    mask = ((unit)1) << (UNITSIZE - 1);
    for (j=0; j < UNITSIZE; j++, mask /=2 )
    {

                if (started)
                {
                        /* Square */

                        if ((retval = mp_modsquare(devhandle, msb_res, msb_temp, msb_n, size)) != 0)
                        {
                                memset(temp_unit, 0, MAXSIZE*sizeof(unit));
                   P_LEAVE( P_mp_exponentiate )
                                return retval;
                        }
                }

        if ( (*msb_e) & mask)
        {
                  if (!started)
                  {
                          /* The first time */
                          started = 1;
                          /* Swap */
                          t = msb_res;
                          msb_res = msb_temp;
                          msb_temp = t;
                  }

                  if ((retval = mp_modmult(devhandle, msb_temp, msb_a, msb_res, msb_n, size)) != 0)
                  {
                           memset(temp_unit, 0, MAXSIZE*sizeof(unit));
                           P_LEAVE( P_mp_exponentiate )
                           return retval;
                  }
        }
        else
        {
                  t = msb_res;
                  msb_res = msb_temp;
                  msb_temp = t;
        }

      /* Now result will always be in temp */
    }
    UNIT_PLUS_PLUS(msb_e);
  }

  /* Copy over from temp_unit to result (if needed) */
  if (msb_temp != msb_c)
  {
    mp_copy_unit_msb(msb_c, msb_temp, size);
  }
  memset(temp_unit, 0, MAXSIZE*sizeof(unit));
  P_LEAVE( P_mp_exponentiate )
  return retval;
}
#endif /**** _MODEXTNLIB **/

/*
   A cheap test for primality used to seive away candidates without the
   full expense of a rabin miller test. Computes
   2^p-1 mod p == 1 ? 0: -1

   CAUTION: Upon internal failure a non-zero value is returned. Pls make
   sure that no error code coincides with -1, if so the programs arbitrarily
   makes it -2.

   Actually checks 2^p mod p == 2.
*/

#ifndef _MODEXTNLIB
int cheap_fermat(ICA_ADAPTER_HANDLE devhandle, unit *msb_p, int size)
{
  P_ENTER( P_cheap_fermat )

  unit cunits[MAXSIZE];
  unit aunits[MAXSIZE];
  unit temp_unit[MAXSIZE];
  mp_int a, c;
  unit *msb_temp, *msb_res, *t, *msb_e;
  unit mask;
  int i, j;
  int mathretval=0;

  if (size > MAXSIZE)
  {
    P_LEAVE( P_cheap_fermat )
    return PKAMathFail;
  }
  a.value = aunits;
  c.value = cunits;
  a.maxsize=c.maxsize=MAXSIZE;
  c.size=a.size=size;
  msb_e = msb_p;

  memset(aunits, 0, sizeof(unit)*MAXSIZE);
  *MP_LS_UNIT(&a)=2;

  if (size <= HW_SIZE)
  {
    mathretval = hw_exponentiate(devhandle, MP_MS_UNIT(&c), MP_MS_UNIT(&a),
                                 msb_p, size, msb_p, size);
    msb_temp = MP_MS_UNIT(&c);
  }
  else
  {

    memset(temp_unit, 0, MAXSIZE * sizeof(unit));
    msb_temp = MS_UNIT(temp_unit, size);
    *(LS_UNIT(temp_unit, size)) = 1;
    msb_res = MP_MS_UNIT(&c);

    /* Do this exponentiations via a sequence of squarings and
       mults (which in this case would be a modular add)
    */
    for (i=0; i<size; i++)
    {
      mask = ((unit)1) << (UNITSIZE - 1);
      for (j=0; j < UNITSIZE; j++, mask /=2 )
      {
        /* Square */
        mathretval = mp_modsquare(devhandle, msb_res, msb_temp, msb_p, size);
        if (mathretval)
          break;

        if ( (*msb_e) & mask)
        {
          /* Multiply by 2 mod p*/
          mp_add_modn(UNIT_PLUS_K(msb_res,size-1),
                      UNIT_PLUS_K(msb_res,size-1),
                      UNIT_PLUS_K(msb_temp,size-1),
                      msb_p, size);
        }
        else
        {
          t = msb_res;
          msb_res = msb_temp;
          msb_temp = t;
        }
        /* Now result will always be in temp */
      }

      if (mathretval)
        break;

      UNIT_PLUS_PLUS(msb_e);
    }
  }

  if (mathretval)
  {
    memset(cunits, 0, sizeof(unit)*MAXSIZE);
    if (mathretval == -1)
      mathretval = -2;
    P_LEAVE( P_cheap_fermat )
    return mathretval;
  }
  /* Result is now always in msb_temp */
  {
    int retval;

    if (mp_compare_fast(msb_temp, MP_MS_UNIT(&a), size))
      retval = -1;
    else
      retval = 0;

    memset(cunits, 0, sizeof(unit)*MAXSIZE);
    P_LEAVE( P_cheap_fermat )
    return retval;
  }
}
#endif /**** _MODEXTNLIB **/


/*
   Rabin Miller test using r and p of size "size", input r
   by be greater than p in which case r mod p is used.

   Returns 0 if test passes (probable prime)
   -1 if it fails (not a prime).

   CAUTION: Upon internal failure a non-zero value is returned. Pls make
   sure that no error code coincides with -1, o/w this code will
   arbitrarily make it -2.
*/

#ifndef _MODEXTNLIB
int rabin_count = 0;
int mp_rabin_miller(ICA_ADAPTER_HANDLE devhandle, unit *msb_r, unit *msb_p, int size)
{
  P_ENTER( P_mp_rabin_miller )

  int i;
  mp_int p, r, t, c, pm1;
  unit temp[MAXSIZE];
  unit pm1unit[MAXSIZE];
  unit cunit[MAXSIZE];
  int retval = -1;

  p.maxsize=r.maxsize=p.size = r.size = size;

  rabin_count++;
  c.maxsize=pm1.maxsize=t.maxsize=MAXSIZE;
  c.size=pm1.size=t.size = size;
  pm1.value = pm1unit;
  t.value = temp;
  c.value = cunit;


#ifdef __LITTLE_ENDIAN__
  p.value = msb_p - (size-1);
  r.value = msb_r - (size-1);
#else
#ifdef __BIG_ENDIAN__
  p.value = msb_p;
  r.value = msb_r;
#else
  faketype ERROR;
#endif
#endif


  if ((i = mp_compare_fast(msb_r, msb_p, size)) == 0)
  {
    /* Extremely rare; to be safe say its not prime */
    P_LEAVE( P_mp_rabin_miller )
    return retval;
  }

  if (i > 0)
  {
    retval = mp_mod(devhandle, &r, &p, &t, NULL);
    if (retval)
    {
      if (retval == -1)
        retval = -2;
      goto primeout;
    }
    mp_extend(&t, size);
    mp_copy_unit_lsb(MP_LS_UNIT(&r), MP_LS_UNIT(&t), size);
  }


  /* Now we need to get p-1 and figure out how many trailing 0's in it */

  mp_copy(&t, &p);
  mp_extend(&t, size);
  mp_minus_eq_unit(MP_LS_UNIT(&t), (unit)1, size);

  /* Store a copy in pm1 */
  mp_copy(&pm1, &t);
  mp_extend(&pm1, size);

  i=0;

  while (!((*MP_LS_UNIT(&t)) & ((unit) 1)))
  {
    i++;
    shift_right(MP_MS_UNIT(&t), t.size);    //D1789 use t.size
  }

  /* Now the Rabin Test begins */
  retval = mp_exponentiate(devhandle, MP_MS_UNIT(&c), MP_MS_UNIT(&r), msb_p, size,
                           MP_MS_UNIT(&t), t.size);

  if (retval)
  {
    if (retval == -1)
      retval = -2;
    goto primeout;
  }
  if ( (is_one_metaunit(MP_MS_UNIT(&c), size)) ||
       (mp_compare_fast(MP_MS_UNIT(&c), MP_MS_UNIT(&pm1), size) == 0))
  {
    retval = 0;
    goto primeout;
  }
  else
  {
    while(i--)
    {
      mp_copy_unit_lsb(MP_LS_UNIT(&t), MP_LS_UNIT(&c), size);

      from_rm = 1;
      retval = mp_modsquare(devhandle, MP_MS_UNIT(&c), MP_MS_UNIT(&t), msb_p, size);
      if (retval)
      {
        if (retval == -1)
          retval = -2;
        goto primeout;
      }

      if (is_one_metaunit(MP_MS_UNIT(&c), size))
      {
        retval = -1;
        goto primeout;
      }

      if (mp_compare_fast(MP_MS_UNIT(&pm1),MP_MS_UNIT(&c), size) == 0)
      {
        if (i)
        {
          retval = 0;
        }
        else
        {
          retval = -1;
        }
        goto primeout;
      }
    }
    retval = -1;
  }

primeout:
  memset(temp, 0, sizeof(unit) *MAXSIZE);
  memset(pm1unit, 0, sizeof(unit) *MAXSIZE);
  memset(cunit, 0, sizeof(unit) *MAXSIZE);
  from_rm = 0;
  P_LEAVE( P_mp_rabin_miller )
  return retval;
}
#endif /****** _MODEXTNLIB ***/


/* Same as GCD but input parameters may get
   trashed: Assumes that c is always large enough, o/w
   will give error after partial computation.
   one way to ensure is to give a c with maxsize at
   least the min of the sizes of a and b.

*/

static int ICA_CALL mp_gcd_trash(ICA_ADAPTER_HANDLE devhandle,
                                                                 mp_int *a, mp_int *b, mp_int *gcd)
{
    unit zero_unit=0;
    mp_int *t, *t1;
    mp_int temp, zero;
    unit  tempbuf[MAXSIZE];
    int retval = 0;

    zero.maxsize = zero.size = 1;
    zero.value = &zero_unit;

    if ( mp_compare_general(a, b) < 0)
    {
      /* B > A , remedy situation, switch aa, bb */
      t1 = a;
      a = b;
      b = t1;
    }

    temp.size = temp.maxsize=MAXSIZE;
    temp.value = tempbuf;
    t = &temp;

    /*
       Keep going using the relation if x > y, gcd(x, y) = gcd (x%y, y)
       until one of the inputs becomes 0. the gcd is then the other unit
    */

    while ((!(retval)) && (mp_compare_general(b, &zero)))
    {

        mp_normalize(b);
        retval = mp_mod(devhandle, a, b, t, 0);

        /* Prepare for next round */

        t1 = a;
        a  = b;
        b  = t;
        t  = t1;
    }

    /* GCD is done, result is in a, copy to gcd. */

    if (!(retval))
    {
      mp_normalize(a);
      if (mp_copy(gcd, a))
        retval = PKAMathFail;
    }

    memset(tempbuf, 0, MAXSIZE * sizeof(unit));
    return retval;
}

/* GCD: Assumes that c is always large enough, o/w
   will give error after partial computation.
   one way to ensure is to give a c with maxsize at
   least the min of the sizes of a and b
*/
int mp_gcd(ICA_ADAPTER_HANDLE devhandle, mp_int *a, mp_int *b, mp_int *gcd)
{
    P_ENTER( P_mp_gcd )

    unit temp_a[MAXSIZE];
    unit temp_b[MAXSIZE];
    mp_int a1, b1;
    int retval = 0;

    /* Copy to locals */

    a1.maxsize=b1.maxsize=MAXSIZE;
    a1.value = temp_a;
    b1.value = temp_b;

    mp_copy(&a1, a);
    mp_copy(&b1, b);

    /* Call GCD, which may trash locals */
    retval = mp_gcd_trash(devhandle, &a1, &b1, gcd);
    memset(temp_a, 0, MAXSIZE *sizeof(unit));
    memset(temp_b, 0, MAXSIZE *sizeof(unit));

    P_LEAVE( P_mp_gcd )
    return retval;

}

static int ICA_CALL update_invariant(ICA_ADAPTER_HANDLE devhandle,
                                                                         mp_int * bigm, mp_int * smallm,
                                     mp_int *q,
                                     char *signbig, char * signsmall)
{
    /*
       *bigm and *smallm are mp_int whose sign is +ve or negative
       depending on whether *signbig/ *signsamll are 0.

       The following needs to be done taking the signs in account

       bigm must get the value of original smallm
       smallm would be original bigm - q * original smallm.

       Assumes the unit buffers of bigm and smallm are large enough to
       always store the results.

    */

    int compare;

    mp_int temp;    /* Temporary variable with storage */
    unit tempbuf[MAXSIZE];
    int retval = 0;

    temp.size =temp.maxsize = MAXSIZE;
    temp.value = tempbuf;

    mp_normalize(smallm);
    mp_normalize(q);

    retval = mp_multiply(devhandle, &temp, smallm, q);
    {
      if (retval)
          {
                          memset(tempbuf, 0, MAXSIZE*sizeof(unit));
                          return retval;
          }
    }

    mp_normalize(&temp);
    mp_normalize(bigm);

    /* Update bigm to be the updated value smallm, update the sign */


    if (*signsmall == *signbig)
    {

      int size;
      size = max(bigm->size, temp.size);
      mp_extend(bigm, size);
      mp_extend(&temp, size);
      compare = mp_compare_fast(MP_MS_UNIT(bigm), MP_MS_UNIT(&temp),size) ;
      if (*signsmall)
      {
        if ( compare >= 0)
        {
          mp_minus_eq(MP_LS_UNIT(&temp), MP_LS_UNIT(bigm), size);
          mp_copy(bigm, &temp);
          *signsmall = 0;
        }        else
        {
          mp_minus_eq(MP_LS_UNIT(bigm), MP_LS_UNIT(&temp), size);
          *signsmall = 1;
        }
      }
      else
      {
        if (compare >= 0)
        {
          mp_minus_eq(MP_LS_UNIT(bigm), MP_LS_UNIT(&temp), size);
          *signsmall = 0;
        }
        else
        {
          mp_minus_eq(MP_LS_UNIT(&temp), MP_LS_UNIT(bigm), size);
          mp_copy(bigm, &temp);
          *signsmall = 1;
        }
      }
    }
    else
    {
        *signbig = *signsmall;
        mp_plus_eq(bigm, &temp);
        *signsmall = (!(*signsmall));
    }

    mp_normalize(bigm);


    /* Swap bigm with smallm */

    temp.value = bigm->value;
    temp.size = bigm->size;
    temp.maxsize = bigm->maxsize;

    bigm->value = smallm->value;
    bigm->size = smallm->size;
    bigm->maxsize = smallm->maxsize;

    smallm->value = temp.value;
    smallm->size = temp.size;
    smallm->maxsize = temp.maxsize;

    memset(tempbuf, 0, sizeof(tempbuf));
    return retval;

}

/*
   Given nonzero a,n where a < n; compute multiplicative inverse of a mod n
   Firstly we assume that GCD(a, n) = 1. This will happen for cryptographic
   applications and one can always check with the GCD algorithm.

   The procedure used is the extended Euclidean GCD algorithm.
   a and n get trashed in the bargain, a copy of the original
   n is therefore provided for reference.

*/

static int ICA_CALL mp_inv_trash(ICA_ADAPTER_HANDLE devhandle,
                                 mp_int *a, mp_int *n, mp_int *copyofn,
                                 mp_int *ainv)
{
    unit zero_unit =0;
    mp_int bigm, smallm, q;
    char signbig, signsmall;    /* The sign of the bigm and smallm
                                   nonzero means negative
                                */

    /* If a0 and n0 are initial values then we maintain the invariant
       that

       n = bigm * a0 mod n0
       a = smallm *a0 mod n0
    */

    mp_int *t, *t1;
    mp_int temp, zero;
    unit bigmbuf[MAXSIZE], smallmbuf[MAXSIZE], qbuf[MAXSIZE],
         tempbuf[MAXSIZE];
    int retval = 0;

    zero.maxsize = zero.size = 1;
    zero.value = &zero_unit;

    bigm.maxsize=smallm.maxsize=q.maxsize=temp.maxsize=MAXSIZE;

    bigm.value = bigmbuf;
    bigm.size = 1;
    *MP_MS_UNIT(&bigm)=0;   /* bigm is initially 0 */
    signbig = 0;


    smallm.value = smallmbuf;
    smallm.size = 1;
    *MP_MS_UNIT(&smallm) = 1;   /* smallm is intially 1 */

    signsmall = 0;


    q.value = qbuf; /* big enough buffer for q */

    temp.size = copyofn->size;
    temp.value = tempbuf;
    t = &temp;


    /*
       Keep going using the relation if x > y, gcd(x, y) = gcd (x%y, y)
       until one of the inputs becomes 0. The GCD is then the other unit
       Loop invariant n > a ; so we check only a;

    */

    while ((!(retval)) && (mp_compare_general(a, &zero)))
    {

        mp_normalize(a);
        retval = mp_mod(devhandle, n, a, t, &q);

        /* Prepare for next round, and update bigm, smallm */

        t1 = n;
        n  = a;
        a  = t;
        t  = t1;

        retval = update_invariant(devhandle, &bigm, &smallm, &q, &signbig, &signsmall);

    }

    /* GCD is done, it is in n, check that it is 1 else
       inverse doesn't exist
    */
    if (!retval)
    {
        mp_normalize(n);
        if ((n->size != 1) || ( *MP_MS_UNIT(n) != (unit) 1) )
            retval = -1;
    };

    if (!retval)
    {

        /*
        Copy the result, i.e, bigm to ainv after taking into account
        the sign
        */
        mp_normalize(&bigm);

        if (signbig)
        {

            mp_copy(&smallm, copyofn);
            mp_extend(&bigm, copyofn->size);
            mp_minus_eq(MP_LS_UNIT(&smallm), MP_LS_UNIT(&bigm), bigm.size);
            mp_normalize(&smallm);
            mp_copy(ainv, &smallm);

        }
        else
        {
            mp_copy(ainv, &bigm);
        }
    }

    memset(bigmbuf, 0, sizeof(unit) * MAXSIZE);
    memset(smallmbuf, 0, sizeof(unit) * MAXSIZE);
    memset(qbuf, 0, sizeof(unit) * MAXSIZE);
    memset(tempbuf, 0, sizeof(unit) * MAXSIZE);
    return retval;

}

/*
   Given nonzero a,n where a < n; compute multiplicative inverse of a mod n
   Firstly we assume that GCD(a, n) = 1. This will happen for cryptographic
   applications and one can always check with the GCD algorithm.
   o/w this procedure returns nonzero value.

   The procedure used is the extended Euclidean GCD algorithm.

*/

int mp_inv(ICA_ADAPTER_HANDLE devhandle, mp_int *a, mp_int *n, mp_int *ainv)
{
  P_ENTER( P_mp_inv )

  unit tempbuf_a[MAXSIZE];
  unit tempbuf_n[MAXSIZE];
  mp_int temp_a, temp_n;
  int retval = 0;

  temp_a.maxsize=temp_n.maxsize = MAXSIZE;
  temp_a.size = a->size;
  temp_a.value = tempbuf_a;
  temp_n.size = n->size;
  temp_n.value = tempbuf_n;


  if (mp_copy(&temp_a, a))
    retval = PKAMathFail;
  if (mp_copy(&temp_n, n))
    retval = PKAMathFail;

  if (!retval)
    retval = mp_inv_trash(devhandle, &temp_a, &temp_n, n, ainv);

  memset(tempbuf_a, 0, MAXSIZE *sizeof (unit));
  memset(tempbuf_n, 0, MAXSIZE *sizeof (unit));
  P_LEAVE( P_mp_inv )
  return retval;
}

/*
   computes the jacobi symbol ( a  /  n )
   assumes that  gcd(a,n) = 1.

*/
static int count_powers_of_two( mp_int * n )
{
  int i=0;

  while (!((*MP_LS_UNIT(n)) & ((unit) 1)))
  {
    i++;
    shift_right(MP_MS_UNIT(n), n->size);
      }

   mp_normalize ( n );
   return i;
}

#define LASTBYTE( a ) ( *( MP_LS_UNIT( &a)) %256)
int mp_jacobi_symbol(ICA_ADAPTER_HANDLE devhandle, mp_int  *a , mp_int * n )
{
   P_ENTER( P_mp_jacobi_symbol )

   mp_int  t1, t2, t3;
   unit    t1unit[ MAXSIZE ] , t2unit[ MAXSIZE ], t3unit[ MAXSIZE ];
   unsigned char    t1mod4, t2mod4, t2mod8;
   int     res = 1, retval =0;
   int     pow2;
   int status = 0;

   t1.size = t2.size = t3.size = 0;
   t1.maxsize = t2.maxsize = t3.maxsize = MAXSIZE;
   t1.value = t1unit;
   t2.value = t2unit;
   t3.value = t3unit;

   do{
     if ( (status = mp_copy( &t1, a  )) != 0 )
       break;

     if( (status =  mp_copy( &t2, n)) != 0 )
       break;
     if ( (status = mp_extend( &t3, t2.size)) != 0 )
       break;

     mp_normalize( &t3);

     if ( ( t3.size >1 ) ||
          ( ( t3.size == 1 ) && (!( *MP_LS_UNIT(&t3) == (unit) 1))))
       { retval = 0; break;}

   /* smaller value in t1 */
     if ( mp_compare_general( &t1, &t2 ) > 0 ){
       t2.size = t1.size;
       t2.value = t1unit;
       t1.size = n->size;
       t1.value = t2unit;
     }

    do {
      mp_normalize( &t1);
      mp_normalize( &t2);
      t3.size = 0;

      if ( t1.size == 0 )
         { if ( (t2.size == 1 ) && (*MP_MS_UNIT(&t2) == (unit)1))
           retval =  res;
         else retval = 0;
         break;}
      if ( ( t1.size == 1 ) && ( *MP_MS_UNIT( &t1) == (unit)1))
        { retval = res; break;}
      pow2 = count_powers_of_two( &t1);
      t2mod8 =  LASTBYTE( t2) & 0x7 ;

      /* first invert reciprocity */

      t2mod8 = ( t2mod8 * t2mod8 -1)/8;
      pow2 = ( pow2 * t2mod8 ) %2;
      res = ( pow2? -res:res);

      t1mod4 = LASTBYTE(t1) & 0x3;
      t2mod4 =  LASTBYTE( t2) & 0x3 ;
      res = ( ( t1mod4 == 3 ) && ( t2mod4 ==3 ) ) ? ( -res) : res;

      if ( (status = mp_mod(devhandle, &t2, &t1, &t3, (mp_int *) NULL )) != 0 )
        break;

     {
      unit * temp = t2.value;
      t2.size  =  t1.size;
      t2.value =  t1.value;
      t1.size  =  t3.size;
      t1.value =  t3.value;
      t3.value =  temp;
     }

   }while(&mp_jacobi_symbol!=0 /* ==1, forever or until break*/);
   }while(&mp_jacobi_symbol==0 /* ==0, once or until break*/ );
   memset( t1unit, 0, sizeof( t1unit));
   memset( t2unit, 0, sizeof( t2unit));
   memset( t3unit, 0, sizeof( t3unit ));
   P_LEAVE(P_mp_jacobi_symbol)
   return retval;
}


void mpmath_init(void)
{
  init_allones();
#ifndef _MODEXTNLIB
   init_x931( );
#endif /***** _MODEXTNLIB ****/
}
