
/*
             Common Public License Version 0.5

             THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF
             THIS COMMON PUBLIC LICENSE ("AGREEMENT"). ANY USE,
             REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES
             RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT.

             1. DEFINITIONS

             "Contribution" means: 
                   a) in the case of the initial Contributor, the
                   initial code and documentation distributed under
                   this Agreement, and 

                   b) in the case of each subsequent Contributor:
                   i) changes to the Program, and
                   ii) additions to the Program;

                   where such changes and/or additions to the Program
                   originate from and are distributed by that
                   particular Contributor. A Contribution 'originates'
                   from a Contributor if it was added to the Program
                   by such Contributor itself or anyone acting on such
                   Contributor's behalf. Contributions do not include
                   additions to the Program which: (i) are separate
                   modules of software distributed in conjunction with
                   the Program under their own license agreement, and
                   (ii) are not derivative works of the Program.


             "Contributor" means any person or entity that distributes
             the Program.

             "Licensed Patents " mean patent claims licensable by a
             Contributor which are necessarily infringed by the use or
             sale of its Contribution alone or when combined with the
             Program. 

             "Program" means the Contributions distributed in
             accordance with this Agreement.

             "Recipient" means anyone who receives the Program under
             this Agreement, including all Contributors.

             2. GRANT OF RIGHTS

                   a) Subject to the terms of this Agreement, each
                   Contributor hereby grants Recipient a
                   non-exclusive, worldwide, royalty-free copyright
                   license to reproduce, prepare derivative works of,
                   publicly display, publicly perform, distribute and
                   sublicense the Contribution of such Contributor, if
                   any, and such derivative works, in source code and
                   object code form.

                   b) Subject to the terms of this Agreement, each
                   Contributor hereby grants Recipient a
                   non-exclusive, worldwide, royalty-free patent
                   license under Licensed Patents to make, use, sell,
                   offer to sell, import and otherwise transfer the
                   Contribution of such Contributor, if any, in source
                   code and object code form. This patent license
                   shall apply to the combination of the Contribution
                   and the Program if, at the time the Contribution is
                   added by the Contributor, such addition of the
                   Contribution causes such combination to be covered
                   by the Licensed Patents. The patent license shall
                   not apply to any other combinations which include
                   the Contribution. No hardware per se is licensed
                   hereunder.

                   c) Recipient understands that although each
                   Contributor grants the licenses to its
                   Contributions set forth herein, no assurances are
                   provided by any Contributor that the Program does
                   not infringe the patent or other intellectual
                   property rights of any other entity. Each
                   Contributor disclaims any liability to Recipient
                   for claims brought by any other entity based on
                   infringement of intellectual property rights or
                   otherwise. As a condition to exercising the rights
                   and licenses granted hereunder, each Recipient
                   hereby assumes sole responsibility to secure any
                   other intellectual property rights needed, if any.

                   For example, if a third party patent license is
                   required to allow Recipient to distribute the
                   Program, it is Recipient's responsibility to
                   acquire that license before distributing the
                   Program.

                   d) Each Contributor represents that to its
                   knowledge it has sufficient copyright rights in its
                   Contribution, if any, to grant the copyright
                   license set forth in this Agreement.

             3. REQUIREMENTS

             A Contributor may choose to distribute the Program in
             object code form under its own license agreement, provided
             that:
                   a) it complies with the terms and conditions of
                   this Agreement; and

                   b) its license agreement:
                   i) effectively disclaims on behalf of all
                   Contributors all warranties and conditions, express
                   and implied, including warranties or conditions of
                   title and non-infringement, and implied warranties
                   or conditions of merchantability and fitness for a
                   particular purpose;

                   ii) effectively excludes on behalf of all
                   Contributors all liability for damages, including
                   direct, indirect, special, incidental and
                   consequential damages, such as lost profits;

                   iii) states that any provisions which differ from
                   this Agreement are offered by that Contributor
                   alone and not by any other party; and

                   iv) states that source code for the Program is
                   available from such Contributor, and informs
                   licensees how to obtain it in a reasonable manner
                   on or through a medium customarily used for
                   software exchange.

             When the Program is made available in source code form:
                   a) it must be made available under this Agreement;
                   and
                   b) a copy of this Agreement must be included with
                   each copy of the Program. 

             Contributors may not remove or alter any copyright notices
             contained within the Program.

             Each Contributor must identify itself as the originator of
             its Contribution, if any, in a manner that reasonably
             allows subsequent Recipients to identify the originator of
             the Contribution. 


             4. COMMERCIAL DISTRIBUTION

             Commercial distributors of software may accept certain
             responsibilities with respect to end users, business
             partners and the like. While this license is intended to
             facilitate the commercial use of the Program, the
             Contributor who includes the Program in a commercial
             product offering should do so in a manner which does not
             create potential liability for other Contributors.
             Therefore, if a Contributor includes the Program in a
             commercial product offering, such Contributor ("Commercial
             Contributor") hereby agrees to defend and indemnify every
             other Contributor ("Indemnified Contributor") against any
             losses, damages and costs (collectively "Losses") arising
             from claims, lawsuits and other legal actions brought by a
             third party against the Indemnified Contributor to the
             extent caused by the acts or omissions of such Commercial
             Contributor in connection with its distribution of the
             Program in a commercial product offering. The obligations
             in this section do not apply to any claims or Losses
             relating to any actual or alleged intellectual property
             infringement. In order to qualify, an Indemnified
             Contributor must: a) promptly notify the Commercial
             Contributor in writing of such claim, and b) allow the
             Commercial Contributor to control, and cooperate with the
             Commercial Contributor in, the defense and any related
             settlement negotiations. The Indemnified Contributor may
             participate in any such claim at its own expense.


             For example, a Contributor might include the Program in a
             commercial product offering, Product X. That Contributor
             is then a Commercial Contributor. If that Commercial
             Contributor then makes performance claims, or offers
             warranties related to Product X, those performance claims
             and warranties are such Commercial Contributor's
             responsibility alone. Under this section, the Commercial
             Contributor would have to defend claims against the other
             Contributors related to those performance claims and
             warranties, and if a court requires any other Contributor
             to pay any damages as a result, the Commercial Contributor
             must pay those damages.


             5. NO WARRANTY

             EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE
             PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT
             WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR
             IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR
             CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR
             FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely
             responsible for determining the appropriateness of using
             and distributing the Program and assumes all risks
             associated with its exercise of rights under this
             Agreement, including but not limited to the risks and
             costs of program errors, compliance with applicable laws,
             damage to or loss of data, programs or equipment, and
             unavailability or interruption of operations. 

             6. DISCLAIMER OF LIABILITY
             EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER
             RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY
             FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
             OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION
             LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF
             LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
             (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
             OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE
             OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE
             POSSIBILITY OF SUCH DAMAGES.

             7. GENERAL

             If any provision of this Agreement is invalid or
             unenforceable under applicable law, it shall not affect
             the validity or enforceability of the remainder of the
             terms of this Agreement, and without further action by the
             parties hereto, such provision shall be reformed to the
             minimum extent necessary to make such provision valid and
             enforceable.


             If Recipient institutes patent litigation against a
             Contributor with respect to a patent applicable to
             software (including a cross-claim or counterclaim in a
             lawsuit), then any patent licenses granted by that
             Contributor to such Recipient under this Agreement shall
             terminate as of the date such litigation is filed. In
             addition, If Recipient institutes patent litigation
             against any entity (including a cross-claim or
             counterclaim in a lawsuit) alleging that the Program
             itself (excluding combinations of the Program with other
             software or hardware) infringes such Recipient's
             patent(s), then such Recipient's rights granted under
             Section 2(b) shall terminate as of the date such
             litigation is filed.

             All Recipient's rights under this Agreement shall
             terminate if it fails to comply with any of the material
             terms or conditions of this Agreement and does not cure
             such failure in a reasonable period of time after becoming
             aware of such noncompliance. If all Recipient's rights
             under this Agreement terminate, Recipient agrees to cease
             use and distribution of the Program as soon as reasonably
             practicable. However, Recipient's obligations under this
             Agreement and any licenses granted by Recipient relating
             to the Program shall continue and survive. 

             Everyone is permitted to copy and distribute copies of
             this Agreement, but in order to avoid inconsistency the
             Agreement is copyrighted and may only be modified in the
             following manner. The Agreement Steward reserves the right
             to publish new versions (including revisions) of this
             Agreement from time to time. No one other than the
             Agreement Steward has the right to modify this Agreement.

             IBM is the initial Agreement Steward. IBM may assign the
             responsibility to serve as the Agreement Steward to a
             suitable separate entity. Each new version of the
             Agreement will be given a distinguishing version number.
             The Program (including Contributions) may always be
             distributed subject to the version of the Agreement under
             which it was received. In addition, after a new version of
             the Agreement is published, Contributor may elect to
             distribute the Program (including its Contributions) under
             the new version. Except as expressly stated in Sections
             2(a) and 2(b) above, Recipient receives no rights or
             licenses to the intellectual property of any Contributor
             under this Agreement, whether expressly, by implication,
             estoppel or otherwise. All rights in the Program not
             expressly granted under this Agreement are reserved.


             This Agreement is governed by the laws of the State of New
             York and the intellectual property laws of the United
             States of America. No party to this Agreement will bring a
             legal action under this Agreement more than one year after
             the cause of action arose. Each party waives its rights to
             a jury trial in any resulting litigation. 



*/

/* (C) COPYRIGHT International Business Machines Corp. 2001          */


/***********************************************************************
***                                                                  ***
***       (C) COPYRIGHT IBM CORP  1997, 1999                         ***
***                                                                  ***
***       LICENSED MATERIALS  -  PROPERTY OF IBM                     ***
***                                                                  ***
***       All Rights Reserved                                        ***
***                                                                  ***
***       U.S. Government Users Restricted Rights - Use,             ***
***       duplication or disclosure restricted by GSA ADP            ***
***       Schedule Contract with IBM Corp.                           ***
***                                                                  ***
***                                                                  ***
***       ORIGINS: RES (IBM Research Division)                       ***
***                                                                  ***
************************************************************************
*
* Module Name:       rsa.c
*
* Descriptive Name:  Public Key cryptographic Algorithm manager (PKA_MGR)
*                    interface from PKA manager to math routines
*                    to implement RSA
*
* Status:            Release 1 Version 1
*
* Function:          RSA routines
*
*
* Module type:
*      Processor:    Intel x86 family
*
*      Language:     C source
*
*      Compiler:     IBM VisualAge on OS/2
*
* Restrictions:
*
* Linkage:           these routines are called by the PKA manager
*
*
*
* Change History:    written April 1997 by Pankaj Rohatgi
*                    IBM Research, Hawthorne, NY
*
*
*   Date    Ver   Notes                                            by
* --------- ----  -----                                            ---
* 16-Apr-97       initial implementation                           PR
* 10-Nov-97       changes to support X9.31 compliant RSA           SC
* 07-Dec-98       __MINIBOOT__ def'd, don't want exit.  retcode is
*                       always zero in this case anyway            jgd
* 28-Jan-98       clean up #ifndef nesting...compiler info msg     jgd
* 01-Feb-99       merge with PKCS changes, known ans, other...     jgd
* 01-March-99    -prelinkc,postlinkc interface change:             jpa
*                   rsa_key_gen
*                   rsa_key_operation
*                   rsa_ompute_blinding_values
*                   rsa_init
*                -For rsa_key_gen and pkcs extend prime p and
*                 prime q to equal length
*                -- Defect-879
* 28-Feb-99       fix X9.31 overwrite of n...use mp_new_minus_eq()
*                       add BOUNDS_CHECK for q (rsakeygen)         jgd
* 03-Mar-99       begin profiling...
*                       add if(!retval) encrypt, after mp_exponen  jgd
* 01-Apr-99       rsa_known_answer_test() LEEDS-2 does not include
*                       blinding                                   jpa
*
* 05-May-99       threading                                        jgd
* 10-Mar-2000     Defect 1478 @D001                                jpa
*                 RSA Key generation using regen_data that has     jpa
*                 a byte size(x) where 20<x<64 bytes in length
*                 would not always reproduce the same key
*                 --FIX: Always SHA the regen_data
***********************************************************************/
#include <string.h>
#include <stdio.h>

#include "platform.h"
#include "pkamgr.h"
#include "rsa.h"
#include "rand.h"    /* To get rand_get_next_64 */

   #ifndef TRUE
      #define TRUE 1
   #endif
   #ifndef FALSE
      #define FALSE 0
   #endif


#include "x931prim.h"
#include "sha.h"

#ifndef __PROFILE__
#define __PROFILE__ 0
#endif
#include "profiler.h"

/*
  Static data for known answer tests.
*/

static unsigned char testkeytok[] =

{
0x01, 0x00, 0x00, 0x00, 0x34, 0x02, 0x00, 0x00, 0x01, 0x02,
0x00, 0x00, 0x44, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00,
0x20, 0x00, 0x00, 0x00, 0x24, 0x00, 0x00, 0x00, 0x20, 0x00,
0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00,
0x40, 0x00, 0x00, 0x00, 0x44, 0x00, 0x00, 0x00, 0x44, 0x00,
0x00, 0x00, 0x68, 0x01, 0x00, 0x00, 0x60, 0x00, 0x00, 0x00,
0x64, 0x00, 0x00, 0x00, 0x84, 0x00, 0x00, 0x00, 0xa8, 0x00,
0x00, 0x00, 0xc8, 0x00, 0x00, 0x00, 0xe8, 0x00, 0x00, 0x00,
0x28, 0x01, 0x00, 0x00, 0xac, 0x01, 0x00, 0x00, 0xf0, 0x01,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03,
0xba, 0x09, 0x10, 0x6c, 0x75, 0x4e, 0xb6, 0xfe, 0xbb, 0xc2,
0x14, 0x79, 0x9f, 0xf1, 0xb8, 0xde, 0x1b, 0x4c, 0xbb, 0x7a,
0x7a, 0x78, 0x2b, 0x15, 0x7c, 0x1b, 0xc1, 0x52, 0x90, 0xa1,
0xa3, 0xab, 0x00, 0x00, 0x00, 0x01, 0x60, 0x46, 0xeb, 0x39,
0xe0, 0x3b, 0xea, 0xb6, 0x21, 0xd0, 0x3c, 0x08, 0xb8, 0xae,
0x6b, 0x66, 0xcf, 0xf9, 0x55, 0xb6, 0x4b, 0x4f, 0x48, 0xb7,
0xee, 0x15, 0x2a, 0x32, 0x6b, 0xf8, 0xcb, 0x25, 0x7c, 0x06,
0x0a, 0xf2, 0xf8, 0xdf, 0x24, 0xa9, 0xd2, 0x81, 0x62, 0xfb,
0xbf, 0xf6, 0x7b, 0x3e, 0xbc, 0xdd, 0xd2, 0x51, 0xa6, 0xfa,
0xc7, 0x63, 0xa8, 0x12, 0x80, 0xe1, 0xb5, 0xc1, 0x17, 0xc7,
0xea, 0xd9, 0xf2, 0x26, 0x95, 0x7d, 0x47, 0x24, 0x16, 0x8a,
0xd2, 0xb0, 0x7b, 0x1e, 0xf2, 0x44, 0x8a, 0xa6, 0x39, 0x24,
0x32, 0x34, 0xdb, 0x25, 0x49, 0x63, 0x71, 0x76, 0xf2, 0xa5,
0xdc, 0xc3, 0xfc, 0x04, 0x26, 0x7b, 0xd8, 0x45, 0xe6, 0x03,
0x4a, 0xef, 0xb2, 0xbd, 0xc3, 0x6e, 0xbe, 0x35, 0x7c, 0x00,
0x6b, 0xeb, 0xc7, 0x38, 0xba, 0x34, 0x5c, 0x60, 0x75, 0x3d,
0xfe, 0xee, 0xcf, 0xd7, 0xf8, 0x4a, 0x90, 0xc5, 0x72, 0x6c,
0x47, 0x28, 0xf5, 0x88, 0xb1, 0x0c, 0x6e, 0x51, 0x89, 0xf3,
0x36, 0xd9, 0xab, 0x36, 0x4e, 0xe4, 0xfc, 0xb7, 0xe1, 0x62,
0x5d, 0xe1, 0xab, 0x1e, 0x30, 0xe6, 0x03, 0xfb, 0xd9, 0x84,
0x27, 0xba, 0x19, 0xfc, 0xb5, 0x10, 0x4d, 0x42, 0x3c, 0x91,
0x41, 0xcb, 0x3f, 0xa2, 0x65, 0x71, 0xf3, 0xf7, 0x82, 0x55,
0xc5, 0x65, 0x76, 0x7e, 0xbb, 0xf6, 0x5b, 0x99, 0x2c, 0xbd,
0xe8, 0x5b, 0x6b, 0x10, 0x98, 0x0c, 0x99, 0x18, 0x68, 0xf0,
0xf8, 0xa9, 0x7c, 0x4c, 0xdc, 0x12, 0xe1, 0xb0, 0x44, 0x0b,
0xa4, 0x01, 0x06, 0xcf, 0xbd, 0x22, 0x6f, 0xaf, 0x0f, 0xd2,
0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0xbb, 0xa2, 0xd1, 0x5d, 0xbb, 0x30, 0x3c, 0x8a, 0x21, 0xc5,
0xeb, 0xbc, 0xba, 0xe5, 0x2b, 0x71, 0x25, 0x08, 0x79, 0x20,
0xdd, 0x7c, 0xdf, 0x35, 0x8e, 0xa1, 0x19, 0xfd, 0x66, 0xfb,
0x06, 0x40, 0x12, 0xec, 0x8c, 0xe6, 0x92, 0xf0, 0xa0, 0xb8,
0xe8, 0x32, 0x1b, 0x04, 0x1a, 0xcd, 0x40, 0xb7, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00 };

static unsigned char test_sig_dat_in[]=

{
0x00, 0x9d, 0xfe, 0xa7, 0xdc, 0x6b, 0xba, 0xd0, 0x98, 0xf2,
0x76, 0x49, 0x54, 0x85, 0x32, 0x3e, 0x10, 0x1c, 0xfe, 0xa7,
0xdc, 0x6b, 0xba, 0xd0, 0x98, 0xf2, 0x76, 0x49, 0x54, 0x85,
0x32, 0x3e, 0x10, 0x1c, 0xfe, 0xa7, 0xdc, 0x6b, 0xba, 0xd0,
0x98, 0xf2, 0x76, 0x49, 0x54, 0x85, 0x32, 0x3e, 0x10, 0x1c,
0xfe, 0xa7, 0xdc, 0x6b, 0xba, 0xd0, 0x98, 0xf2, 0x76, 0x49,
0x54, 0x85, 0x32, 0x3e, 0xfe, 0xa7, 0xdc, 0x6b, 0xba, 0xd0,
0x98, 0xf2, 0x76, 0x49, 0x54, 0x85, 0x32, 0x3e, 0x10, 0x1c,
0xfe, 0xa7, 0xdc, 0x6b, 0xba, 0xd0, 0x98, 0xf2, 0x76, 0x49,
0x54, 0x85, 0x32, 0x3e, 0x10, 0x1c, 0xfe, 0xa7, 0xdc, 0x6b,
0xba, 0xd0, 0x98, 0xf2, 0x76, 0x49, 0x54, 0x85, 0x32, 0x3e,
0x10, 0x1c, 0xfe, 0xa7, 0xdc, 0x6b, 0xba, 0xd0, 0x98, 0xf2,
0x76, 0x49, 0x54, 0x85, 0x32, 0x3e, 0x33, 0xcc, 0xfe, 0xa7,
0xdc, 0x6b, 0xba, 0xd0, 0x98, 0xf2, 0x76, 0x49, 0x54, 0x85,
0x32, 0x3e, 0x10, 0x1c, 0xfe, 0xa7, 0xdc, 0x6b, 0xba, 0xd0,
0x98, 0xf2, 0x76, 0x49, 0x54, 0x85, 0x32, 0x3e, 0x33, 0xcc,
0xfe, 0xa7, 0xdc, 0x6b, 0xba, 0xd0, 0x98, 0xf2, 0x76, 0x49,
0x54, 0x85, 0x32, 0x3e, 0x10, 0x1c, 0xfe, 0xa7, 0xdc, 0x6b,
0xba, 0xd0, 0x98, 0xf2, 0x76, 0x49, 0x54, 0x85, 0x32, 0x3e,
0x33, 0xcc, 0xfe, 0xa7, 0xdc, 0x6b, 0xba, 0xd0, 0x98, 0xf2,
0x76, 0x49, 0x54, 0x85, 0x32, 0x3e, 0x10, 0x1c, 0xfe, 0xa7,
0xdc, 0x6b, 0xba, 0xd0, 0x98, 0xf2, 0x76, 0x49, 0x54, 0x85,
0x32, 0x3e, 0x33, 0xcc, 0xfe, 0xa7, 0xdc, 0x6b, 0xba, 0xd0,
0x98, 0xf2, 0x76, 0x49, 0x54, 0x85, 0x32, 0x3e, 0x10, 0x1c,
0xfe, 0xa7, 0xdc, 0x6b, 0xba, 0xd0, 0x98, 0xf2, 0x76, 0x49,
0x54, 0x85, 0x32, 0x3e, 0x33, 0xcc, 0x06
};

unsigned char test_sig_dat_out[] =
{
0x00, 0xd1, 0x37, 0x87, 0x5d, 0x70, 0xd2, 0xf7, 0xba, 0xd8,
0x0a, 0xc8, 0x3c, 0x6b, 0x47, 0x2c, 0x89, 0xc7, 0xc8, 0xab,
0xd2, 0x5e, 0xc1, 0xf1, 0x75, 0x7e, 0x3c, 0xdd, 0xa4, 0xfe,
0xee, 0x99, 0x89, 0x07, 0x78, 0x27, 0xc6, 0x15, 0x47, 0x18,
0xb7, 0xb5, 0x73, 0x76, 0x2e, 0x5c, 0x70, 0x18, 0xfa, 0x79,
0x7c, 0x69, 0x57, 0x41, 0xba, 0xd5, 0xbb, 0xe8, 0x56, 0xbb,
0xc9, 0x41, 0x54, 0x77, 0xa9
};

/*
   Data and prototypes for RSA engine
*/

#ifdef _DEBUG_RSA_
void printfUnitData( unit *inputBuffer,
                     int   inputSize);
#endif

static unit_msb_mask = ( 1 << (UNITSIZE -1));

#define TOKEN_HEADER_SIZE (sizeof(struct _ICA_KEY_RSA_MODEXPO)-sizeof(ICA_KEY_RSA_MODEXPO_REC))
#define ALIGN4(x) (((((x) + (3)))/4)*4)
#define ALIGN32(x) (((((x) + (31)))/32)*32)
#define BOUNDS_CHECK \
    if ((tokdatsize + extsize) > bufsize) \
    { \
      retval = PKANoSpace; \
      goto rsa_keygen_out; \
    }

#define BAD_RETVAL_CHECK \
    if (retval) \
    {\
      goto rsa_keygen_out; \
    }

#ifdef __LITTLE_ENDIAN__
#define uint_to_bigendian(b) (  \
                             (((u_int32) (b) & 0x000000ff) << 24) |  \
                             (((u_int32) (b) & 0x0000ff00) <<  8) |  \
                             (((u_int32) (b) & 0x00ff0000) >>  8) |  \
                             (((u_int32) (b) & 0xff000000) >> 24)    \
                             )
#else
#define uint_to_bigendian(b) (b)
#endif

int rsa_key_gen(ICA_ADAPTER_HANDLE devhandle, icaRSAKeyGen_RB_t *rsakeygen,
                int (*abort_callback)(void), struct _task_ctx *ctx )
{
  P_ENTER( P_rsa_key_gen )    /* profiler */

  /* Check a few things first */

  char chinese, strongprimes=0, evenexponent=0,fixedexp = 0;
  char pkcs = FALSE;
#ifdef PKADEBUG
  char Ap_div_q = FALSE;
#endif
  restriction rist = REL0;
  unsigned long modbits;
  unsigned long bufsize;
  unsigned long extsize;

  modbits = rsakeygen->mod_size;

  if ((*(rsakeygen->key_size) < TOKEN_HEADER_SIZE) ||
      (*(rsakeygen->key_private_size) < TOKEN_HEADER_SIZE))
  {
    P_LEAVE( P_rsa_key_gen )    /* profiler */
    return PKANoSpace;
  }
  if ((modbits/UNITSIZE > MAXSIZE) || modbits == 0)
  {
    P_LEAVE( P_rsa_key_gen )
    return PKABadParm;
  }

  /*---------------------------------------------------------------
    changed to add x9.31 types
    changed to add PKCS type     jpa 10.16.98
    ---------------------------------------------------------------*/
  if (( rsakeygen->key_type == RSA_PRIVATE_CHINESE_REMAINDER ) ||
      ( rsakeygen->key_type == RSA_X931_PRIVATE_CHINESE_REMAINDER ) ||
      ( rsakeygen->key_type == RSA_PKCS_PRIVATE_CHINESE_REMAINDER ) ||
      ( rsakeygen->key_type == RSA_PKCS_X931_PRIVATE_CHINESE_REMAINDER ))
  {
    chinese = 1;
    if (( rsakeygen->key_type == RSA_PKCS_PRIVATE_CHINESE_REMAINDER ) ||
        ( rsakeygen->key_type == RSA_PKCS_X931_PRIVATE_CHINESE_REMAINDER ))
       pkcs = TRUE;
  }
  else
  {
    if ( (rsakeygen->key_type == RSA_PRIVATE_MODULUS_EXPONENT) ||
          ( rsakeygen->key_type == RSA_X931_PRIVATE_MODULUS_EXPONENT) )
      chinese=0;
    else
    {
      P_LEAVE( P_rsa_key_gen )    /* profiler */
      return PKABadParm;
    }
  }

  if ( ( rsakeygen->key_type == RSA_X931_PRIVATE_CHINESE_REMAINDER ) ||
       ( rsakeygen->key_type == RSA_X931_PRIVATE_MODULUS_EXPONENT ) ||
       ( rsakeygen->key_type == RSA_PKCS_X931_PRIVATE_CHINESE_REMAINDER ))
    strongprimes = 1;

  switch ( rsakeygen->public_exp )
    {
    case RSA_EXPONENT_RANDOM:
      rist = REL0;
      break;
    case RSA_EXPONENT_3:
      rist = REL3;
      break;
    case RSA_EXPONENT_65537:
      rist = REL65537;
      break;
    case RSA_EXPONENT_2:
      evenexponent = 1;
         break;
    case RSA_EXPONENT_FIXED:
      fixedexp = 1;
      break;
    default:
      P_LEAVE( P_rsa_key_gen )    /* profiler */
      return PKABadParm;

    }

  /* Now that requirements have been worked out. To begin the work. */
  {  /*var scope parens */

    int psize, qsize;
    int nsize, esize;
    PRAN_CTX pctx;
    unsigned char def_seed[24];
    ICA_KEY_RSA_MODEXPO *pModExpoToken;
    ICA_KEY_RSA_CRT *pCrtToken;
    unsigned long temp;
    unit p[MAXSIZE/2];
    unit q[MAXSIZE/2];
    unit * pPrimeLarge = p;
    unit * pPrimeSmall = q;
    unit dpq[MAXSIZE/2];
    unit tempunit[MAXSIZE];
    unit n[MAXSIZE];
    unit e[MAXSIZE];
    unit d[MAXSIZE];
    unit phi[MAXSIZE];
    mp_int a, b, c, tt, fixede;
    int tokdatsize;
    int retval = PKAGood;

    unsigned char primeP[(MAXSIZE*sizeof(unit))/2+8],
                  primeQ[(MAXSIZE*sizeof(unit))/2];
    unsigned int primePSize,
                 primeQSize;
    unsigned char subprimeP[(MAXSIZE*sizeof(unit))/2+8],
                  subprimeQ[(MAXSIZE*sizeof(unit))/2];
    unsigned int subprimePSize,
                 subprimeQSize;
    unsigned char modulusN[MAXSIZE*sizeof(unit)];
    unsigned int modulusNSize,
                 mlen;
    unsigned char exponentE[MAXSIZE*sizeof(unit)],
                  exponentD[MAXSIZE*sizeof(unit)];
    unsigned int exponentESize,
                 exponentDSize;
    unsigned char qInverse[(MAXSIZE*sizeof(unit))/2+8];
    unsigned int qInverseSize;

    pModExpoToken = rsakeygen->key_token;

    if (fixedexp){

#ifndef linux

      /* get e */
      fixede.size=((uint_to_bigendian(rsakeygen->key_token->expLength))+sizeof(unit )-1)/sizeof(unit);
      fixede.maxsize= MAXSIZE;
      fixede.value = e;
      bigendian_bytearray_to_mpint( ( unsigned char *) rsakeygen->key_token +
                                    (uint_to_bigendian(rsakeygen->key_token->expOffset)),
                                    (uint_to_bigendian(rsakeygen->key_token->expLength)),
                                    (uint_to_bigendian(rsakeygen->key_token->expLength))*8,

                                    MP_MS_UNIT( &fixede), fixede.size );
#else

      int length;
      unsigned char *exp;
     
      rsakeygen->key_token->keyType = uint_to_bigendian(RSA_PUBLIC_MODULUS_EXPONENT);     
      
      length = (modbits + 7)/8;
      rsakeygen->key_token->modulusBitLength = length*8;
      exp = rsakeygen->key_token->keyRecord;
     
      /* get e */
      fixede.size=(length+sizeof(unit)-1)/sizeof(unit);
      fixede.maxsize= MAXSIZE;
      fixede.value = e;
      
      bigendian_bytearray_to_mpint(exp, 
				   length,
				   rsakeygen->key_token->modulusBitLength,
				   MP_MS_UNIT( &fixede), fixede.size );
      
				   
#endif

      mp_normalize( &fixede );

      evenexponent = !( *(MP_LS_UNIT( &fixede )) & (unit)0x1);
    }

    if ( (rsakeygen->regen_data) && (rsakeygen->regen_size))
    {
        /*******************************************************
        *** @D001
        *** All regen_data of any size is NOW SHA(ed). Resulting
        *** in a 20 byte value
        *******************************************************/
        /* we need at least 20 bytes for ANSI pseudo random numbers */
            unsigned char regen20[20];
            SHA_CTX sctx;

            /* hash the given data to get 20 bytes */
            SHAA_Init(&sctx);
            SHAA_Update(&sctx, rsakeygen->regen_data, rsakeygen->regen_size);
            SHAA_Final(&sctx, regen20);
            pran_init(&pctx, SEED_ONLY, regen20, sizeof(regen20));
            memset(regen20, 0, sizeof(regen20));
    }
    else
    {
       int status;

       status = rand_get_next_64(devhandle, def_seed);
       if (status)
            return(status);
       status = rand_get_next_64(devhandle, def_seed+8);
       if (status)
            return(status);
       status = rand_get_next_64(devhandle, def_seed+16);
       if (status)
            return(status);
       pran_init(&pctx, SEED_ONLY, def_seed, 24);
    }


    /* First a recommemded size of p */

    /*
       Here the assumption is that p and q are of large size otherwise
       there could be attacks if |p-q| is small.
    */

    temp = ((modbits+1)/2);
    psize = ( temp + UNITSIZE - 1)/UNITSIZE;
    a.maxsize=b.maxsize=MAXSIZE/2;
    a.size = psize;
    a.value = p;

    temp = modbits - temp;
    qsize = ( temp + UNITSIZE - 1)/UNITSIZE;
    b.size = qsize;
    b.value = q;

  /**********************************************************
   *** Determine the two primes
   *** (p = variable "a") (q = variable "b")
   ***********************************************************/
    if ( strongprimes) {

      retval = generate_x931_primes(devhandle, &pctx, modbits, rsakeygen->public_exp,
                                    &fixede, &a, &b, abort_callback);
      BAD_RETVAL_CHECK;
    }else{

      /* We don't require x931_stronprimes */
      /* Two cases, for bitlenghts <=480, don't even bother strengthening primes
         since modulus is factorizable anyway, for higher bitlenghts generate
         primes with strongness properties like the x931 primes but without
         size restrictions.
      */

      if (modbits <=480)
      {

       if(rsakeygen->public_exp == RSA_EXPONENT_FIXED)
       {
       //
       //Only allow exponent of 3 or 65537
       //
        mp_int temp;
        unit internal[2];

        rist=REL0;
        //temp.size = sizeof(internal)/sizeof(unit);
        temp.value = internal;
        temp.maxsize = sizeof(internal)/sizeof(unit);

        temp.size = 1;
        *LS_UNIT(temp.value, temp.size) = 0x03;

        if(!mp_compare_general(&fixede, &temp))
        {
          rist = REL3;
        } else {
         temp.size = (3 + sizeof(unit) - 1)/sizeof(unit);
         if (temp.size == 1)
          *LS_UNIT(temp.value, temp.size) = (unit)0x10001;
         else
         {
          if (temp.size == 2)
          {
           *MS_UNIT(temp.value, temp.size) = 0x1;
           *LS_UNIT(temp.value, temp.size) = 1;
          }else{
           unit *msb;
           /* esize == 3 */
           msb = MS_UNIT(temp.value, temp.size);
           *UNIT_PLUS_PLUS(msb) = 1;
           *UNIT_PLUS_PLUS(msb) = 0;
           *msb = 1;
          } // endif (temp.size == 2)
         } // endif (temp.size == 1)
         if(!mp_compare_general(&fixede, &temp))
         {
             rist = REL65537;
         }
        } //endif (mp_compare_general)
       } //endif (rsakeygen->public_exp)
       if ((rist == REL3) || (rist == REL65537))
       {
        retval = mp_genprime(devhandle, &pctx, MS_UNIT(p, psize), psize, abort_callback,
                                                  rist, (modbits-temp));

         BAD_RETVAL_CHECK;

        retval = mp_genprime(devhandle, &pctx, MS_UNIT(q, qsize), qsize, abort_callback,
                                                  rist, temp);

         BAD_RETVAL_CHECK;
       }else{
        retval = PKABadParm;
        BAD_RETVAL_CHECK;
       }
      }
      else
      {
         retval = mp_generate_strong_prime_pair(devhandle, &pctx, modbits,
                                                rsakeygen->public_exp,
                                                &fixede, &a, &b,
                                                abort_callback);
         BAD_RETVAL_CHECK;
      }

    }
  /**********************************************************
   *** Determine the modulus from two primes
   *** n = pq   ------- (p = variable "a") (q = variable "b")
   ***********************************************************/
    c.maxsize=MAXSIZE;
    c.value = n;

    retval = mp_multiply(devhandle, &c, &a, &b);

    BAD_RETVAL_CHECK;

    nsize = c.size;

    //
    // calculate modulus size in 256 bit blocks
    //

    mlen = (modbits+255)/256;

    //
    // calculate modulus size in bytes padded to the next 256 bit (i.e., 32 byte) block
    //

    modulusNSize = (mlen*256)/8;

    mpint_to_bigendian_bytearray(MS_UNIT(n, nsize), nsize, modulusN, modulusNSize);

    /* In case of chinese, write out stuff quickly before it gets
       messed up in the d, phi calculations
    */
    if (chinese)
    {
      /* Write out things, esp p and q before messing them up */
      DEBUG_PRINTF(("****PKA_MGR-RSA.C: Prime(p)->%08x\n",p));
      DEBUG_PRINTF(("****PKA_MGR-RSA.C: Prime(pPrimeLarge)->%08x\n",pPrimeLarge));
      DEBUG_PRINTF(("****PKA_MGR-RSA.C: Prime(q)->%08x\n",q));
      DEBUG_PRINTF(("****PKA_MGR-RSA.C: Prime(pPrimesmall)->%08x\n",pPrimeSmall));
      if(pkcs)
      {
        /**********************************************************
        *** Determine which prime is the least, assign prime q
        *** the least value.
        ***     0   ->  p == q
        ***    -1   ->  p < q
        ***     1   ->  p > q
        **********************************************************/
        int tmpSize;
        tmpSize= psize= a.size;
        qsize = b.size;
        if (qsize > psize)
        {
         tmpSize = qsize;
        }
        if (qsize != psize)
        {
          mp_extend(&a,tmpSize);
          mp_extend(&b,tmpSize);
          psize= a.size;
          qsize = b.size;
        }
        if (mp_compare_fast(MS_UNIT(pPrimeLarge,psize),  /* prime p */
                            MS_UNIT(pPrimeSmall,qsize),  /* prime q */
                            tmpSize) < 0)
        {
         DEBUG_PRINTF(("****PKA_MGR-RSA.C: Prime(q) > Prime(p)\n"));
         /**********************************************************
         *** Prime q > p
         *** Prime q should be the least prime, exchange p & q
         ***********************************************************/
         tt.size = psize;
         tt.value = pPrimeLarge;
         psize = qsize;
         pPrimeLarge = pPrimeSmall;
         qsize = tt.size;
         pPrimeSmall = tt.value;
        }
      } /* end else pkcs */

      //
      // calculate byte size of prime p padded to 256 bit block
      //

     // primePSize = (((mlen/2) + 1)*256)/8;
      primePSize = (mlen * 16) + 8;    //64bits greater then half the modulus length
      mpint_to_bigendian_bytearray(MS_UNIT(pPrimeLarge, psize), psize,
                                   primeP, primePSize);

      //
      // calculate byte size of prime q padded to 256 bit block
      //

     // primeQSize = (((mlen + 1)/2)*256)/8;
      primeQSize = (mlen * 16);
      mpint_to_bigendian_bytearray(MS_UNIT(pPrimeSmall, qsize), qsize,
                                   primeQ, primeQSize);

    }


    a.size=psize;
    b.size=qsize;
    a.value=pPrimeLarge;
    b.value=pPrimeSmall;
    b.maxsize=a.maxsize=MAXSIZE/2;
    c.maxsize=MAXSIZE;
    c.value=phi;

  /**********************************************************
   *** Determine phi from two primes
   *** phi = (p-1)(q-1) -----   (p = variable "a") (q = variable "b")
   ***********************************************************/
    mp_minus_eq_unit(MP_LS_UNIT(&a), (unit)1, a.size);
    mp_minus_eq_unit(MP_LS_UNIT(&b), (unit)1, b.size);

    retval = mp_multiply(devhandle, &c, &a, &b);
    BAD_RETVAL_CHECK;


    b.maxsize=MAXSIZE;
    b.value=d;


    /* Compute the real e and d */

    for (;;)
    {
      switch (rsakeygen->public_exp)
      {
        case RSA_EXPONENT_RANDOM:
          esize = nsize;
          mp_gen_seived_random(devhandle, &pctx, MS_UNIT(e, esize), esize);
          break;
        case RSA_EXPONENT_3:
          esize = 1;
          *LS_UNIT(e, esize) = 3;
          break;
        case RSA_EXPONENT_65537:
          esize = (3 + sizeof(unit) - 1)/sizeof(unit);
          if (esize == 1)
           *LS_UNIT(e, esize) = (unit)0x10001;
          else
          {
            if (esize == 2)
            {
              *MS_UNIT(e, esize) = 0x1;
              *LS_UNIT(e, esize) = 1;
            }
            else
            {
              unit *msb;
              /* esize == 3 */
              msb = MS_UNIT(e, esize);
              *UNIT_PLUS_PLUS(msb) = 1;
              *UNIT_PLUS_PLUS(msb) = 0;
              *msb = 1;
            }
          }
          break;
      case RSA_EXPONENT_2:
        esize = 1;
        *LS_UNIT( e, esize) = 2;
        break;
      case RSA_EXPONENT_FIXED:
        esize = nsize;
        break;
      default:
        break;
      }

      a.value=e;
      a.maxsize=MAXSIZE;
      a.size=esize;

      /* Reduce e mod phi(n) */

      tt.value = tempunit;
      tt.maxsize = MAXSIZE;

      if ( !fixedexp)
        retval = mp_mod(devhandle, &a, &c, &tt, 0);
      else
        retval = mp_mod(devhandle, &fixede, &c, &tt, 0 );

      BAD_RETVAL_CHECK;

      mp_copy(&a, &tt);
      mp_normalize(&a);
      esize = a.size;

      /*-----------------------------------------------------------
        Added for compliance with X9.31 specification.
        -----------------------------------------------------------*/

      if ( evenexponent) {
        /* If exponent is even then d = inverse of e ( mod lcm(p,q)/2 ) */
        if ((retval =  shift_right( MP_MS_UNIT(&c), c.size )) != 0) break;
        if ((retval = shift_right( MP_MS_UNIT(&c), c.size )) != 0) break;
        if ((retval = mp_inv(devhandle, &a, &c, &b)) != 0) break;
        if ((retval  = shift_left( MP_LS_UNIT(&c), c.size)) != 0) break;
        if ((retval = shift_left( MP_LS_UNIT(&c), c.size )) != 0) break;
      }
      else
        retval = mp_inv(devhandle, &a, &c, &b);

      /* If we get a d, we go out of this loop*/
      if (!retval)
        break;


      /* we could not get phi relative prime to e, generate another e */
      if (retval == -1) {
          retval = PKAGood;
        }

      BAD_RETVAL_CHECK;
    } /* end of e generation */

    mp_extend(&b, nsize);

    /* b holds d */

    //
    // for these tokens, the exponent length is equal to the modulus length
    //

    exponentESize = modulusNSize;
    mpint_to_bigendian_bytearray(MS_UNIT(e, esize), esize, exponentE, exponentESize);

    if (chinese)
    {
      if(pkcs)
      {

        /**********************************************************
        *** Create PKCS qInv
        *** tt = a^(-1)Mod c
        *** tt = Multiplicative inverse of a Mod c
        ***********************************************************/
        tt.maxsize = MAXSIZE;
        c.value = pPrimeLarge;
        c.size = psize;
        c.maxsize=MAXSIZE/2;
        a.value = pPrimeSmall;
        a.size = qsize;
        a.maxsize=MAXSIZE/2;
#ifdef PKADEBUG
      DEBUG_PRINTF(("****PKA_MGR-RSA.C: Increment p & q\n"));
      printfUnitData(c.value,c.size);
      printfUnitData(a.value,a.size);
#endif
        mp_plus_eq_unit(LS_UNIT(pPrimeSmall, qsize), (unit)1, qsize);
        mp_plus_eq_unit(LS_UNIT(pPrimeLarge, psize), (unit)1, psize);
#ifdef PKADEBUG
      DEBUG_PRINTF(("****PKA_MGR-RSA.C: Post Increment p & q\n"));
      printfUnitData(c.value,c.size);
      printfUnitData(a.value,a.size);
      DEBUG_PRINTF(("****PKA_MGR-RSA.C: Calling mp_inv\n"));
      DEBUG_PRINTF(("****PKA_MGR-RSA.C: Prime(p)->%08x\n",c.value));
      DEBUG_PRINTF(("****PKA_MGR-RSA.C: Prime(psize)->%08x\n",c.size));
      DEBUG_PRINTF(("****PKA_MGR-RSA.C: Prime(pmaxsize)->%08x\n",c.maxsize));
      printfUnitData(c.value,c.size);
      DEBUG_PRINTF(("****PKA_MGR-RSA.C: Prime(q)->%08x\n",a.value));
      DEBUG_PRINTF(("****PKA_MGR-RSA.C: Prime(qsize)->%08x\n",a.size));
      DEBUG_PRINTF(("****PKA_MGR-RSA.C: Prime(qmaxsize)->%08x\n",a.maxsize));
      printfUnitData(a.value,a.size);
#endif
        retval = mp_inv(devhandle, &a, &c, &tt);
        BAD_RETVAL_CHECK;
#ifdef PKADEBUG
      DEBUG_PRINTF(("****PKA_MGR-RSA.C: qInv\n"));
      DEBUG_PRINTF(("****PKA_MGR-RSA.C: Prime(qInv)->%08x\n",tt.value));
      DEBUG_PRINTF(("****PKA_MGR-RSA.C: Prime(qInvSize)->%08x\n",tt.size));
      DEBUG_PRINTF(("****PKA_MGR-RSA.C: Prime(qInvMaxsize)->%08x\n",tt.maxsize));
      printfUnitData(tt.value,tt.size);
#endif
        /**************************************************************
        *** Normalize and extend result(U or qInv)
        ***************************************************************/
        mp_extend(&tt, psize);
#ifdef PKADEBUG
      DEBUG_PRINTF(("****PKA_MGR-RSA.C: qInv Extended \n"));
      DEBUG_PRINTF(("****PKA_MGR-RSA.C: Prime(qInv)->%08x\n",tt.value));
      DEBUG_PRINTF(("****PKA_MGR-RSA.C: Prime(qInvSize)->%08x\n",tt.size));
      DEBUG_PRINTF(("****PKA_MGR-RSA.C: Prime(qInvMaxsize)->%08x\n",tt.maxsize));
      printfUnitData(tt.value,tt.size);
      DEBUG_PRINTF(("****PKA_MGR-RSA.C: Decrement p & q\n"));
      printfUnitData(c.value,c.size);
      printfUnitData(a.value,a.size);
#endif
        mp_minus_eq_unit(LS_UNIT(pPrimeSmall, qsize), (unit)1, qsize);
        mp_minus_eq_unit(LS_UNIT(pPrimeLarge, psize), (unit)1, psize);
#ifdef PKADEBUG
      DEBUG_PRINTF(("****PKA_MGR-RSA.C: Post Decrement p & q\n"));
      printfUnitData(c.value,c.size);
      printfUnitData(a.value,a.size);
#endif

         //
         // calculate the byte sie of qInverse padded to a 256 bit block
         //

         // qInverseSize = (((mlen/2) + 1)*256)/8;
         qInverseSize = (mlen * 16) + 8;   //64bits greater then half the modulus length
         mpint_to_bigendian_bytearray(MP_MS_UNIT(&tt),
                                      tt.size,
                                      qInverse,
                                      qInverseSize);
      }

      /* b holds d */

      c.maxsize=MAXSIZE/2;
      c.value = dpq;

      a.value = pPrimeLarge;
      a.size=psize;
      a.maxsize=MAXSIZE/2;

      /**********************************************************
      *** Dp = d Mod(p-1)
      *** c = b Mod a
      ***********************************************************/
      retval = mp_mod(devhandle, &b, &a, &c, 0);
      BAD_RETVAL_CHECK;

      mp_extend(&c, psize);

      //
      // calculate byte size of subprime p padded to 256 bit block
      //

      //subprimePSize = (((mlen/2) + 1)*256)/8;
      subprimePSize = (mlen * 16) + 8;    //64bits greater then half the modulus length

      mpint_to_bigendian_bytearray(MP_MS_UNIT(&c),
                                   c.size,
                                   subprimeP,
                                   subprimePSize);


      a.value = pPrimeSmall;
      a.size=qsize;

      /**********************************************************
      *** Dq = d Mod(q-1)
      *** c = b Mod a
      ***********************************************************/
      retval = mp_mod(devhandle, &b, &a, &c, 0);
      BAD_RETVAL_CHECK;

      mp_extend(&c, qsize);

      //
      // calculate byte size of prime q padded to 256 bit block
      //

      //subprimeQSize = (((mlen + 1)/2)*256)/8;
      subprimeQSize = (mlen * 16);

      mpint_to_bigendian_bytearray(MP_MS_UNIT(&c),
                                   c.size,
                                   subprimeQ,
                                   subprimeQSize);


    } /* endif (chinese) */
    else
    {
      /* b holds d */

      /* Write out everything */

      //
      // for these tokens the exponent length is equal to the modulus length
      //

      exponentDSize = modulusNSize;
      mpint_to_bigendian_bytearray(MP_MS_UNIT(&b), b.size, exponentD, exponentDSize);

    }

  rsa_keygen_out:
    if (!retval)
    {

        //
        // build the public key token in the buffer passed to this call - first
        // write out the public exponent
        //

        bufsize = *(rsakeygen->key_size);
        if (bufsize < sizeof(struct _ICA_KEY_RSA_MODEXPO))
            memset((unsigned char *)pModExpoToken, 0, bufsize);
        else
            memset((unsigned char *)pModExpoToken, 0, sizeof(struct _ICA_KEY_RSA_MODEXPO));

        tokdatsize = SZ_HEADER_MODEXPO;
        //
        // now write out the exponent to the public token
        //
        extsize = exponentESize;
        BOUNDS_CHECK;
        pModExpoToken->expLength = uint_to_bigendian(exponentESize);
        pModExpoToken->expOffset = uint_to_bigendian(tokdatsize);
        memcpy((unsigned char *)pModExpoToken + tokdatsize,
               exponentE, exponentESize);
        tokdatsize += exponentESize;

        //
        // now write out the modulus to the public token
        //

        extsize =  modulusNSize;
        BOUNDS_CHECK;
        pModExpoToken->nLength = uint_to_bigendian(modulusNSize);
        pModExpoToken->nOffset = uint_to_bigendian(tokdatsize);
        memcpy((unsigned char *)pModExpoToken + tokdatsize,
               modulusN, modulusNSize);
        tokdatsize += modulusNSize;

        //
        // now write out the header info
        //

#ifdef linux
	pModExpoToken->modulusBitLength = modbits; 
#else
	pModExpoToken->modulusBitLength = uint_to_bigendian(modbits);
#endif
 
        pModExpoToken->keyType = uint_to_bigendian(RSA_PUBLIC_MODULUS_EXPONENT);
        pModExpoToken->keyLength = uint_to_bigendian(tokdatsize);
        *(rsakeygen->key_size) = tokdatsize;

        //
        // build the private key token in the buffer passed to this call
        //

        if(pkcs) {

            //
            // write out the private key token in PKCS CRT format to
            // the buffer passed to this call - first write out the subprime dp
            //

            bufsize = *(rsakeygen->key_private_size);
            pCrtToken = rsakeygen->x.key_private_crt;
            if (bufsize < sizeof(struct _ICA_KEY_RSA_CRT))
                memset((unsigned char *)pCrtToken, 0, bufsize);
            else
                memset((unsigned char *)pCrtToken, 0, sizeof(struct _ICA_KEY_RSA_CRT));

            tokdatsize = SZ_HEADER_CRT;
            //
            // now write out the subprime dp to the private token
            //
            extsize = subprimePSize;
            pCrtToken->dpLength = uint_to_bigendian(subprimePSize);
            pCrtToken->dpOffset = uint_to_bigendian(tokdatsize);
            BOUNDS_CHECK;
            memcpy((unsigned char *)pCrtToken + tokdatsize,
                   subprimeP, subprimePSize);
            tokdatsize += subprimePSize;

            //
            // now write out the subprime dq to the private token
            //

            extsize = subprimeQSize;
            pCrtToken->dqLength = uint_to_bigendian(subprimeQSize);
            pCrtToken->dqOffset = uint_to_bigendian(tokdatsize);
            BOUNDS_CHECK;
            memcpy((unsigned char *)pCrtToken + tokdatsize,
                   subprimeQ, subprimeQSize);
            tokdatsize += subprimeQSize;

            //
            // now write out the prime p to the private token
            //

            extsize = primePSize;
            pCrtToken->pLength = uint_to_bigendian(primePSize);
            pCrtToken->pOffset = uint_to_bigendian(tokdatsize);
            BOUNDS_CHECK;
            memcpy((unsigned char *)pCrtToken + tokdatsize,
                   primeP, primePSize);
            tokdatsize += primePSize;

            //
            // now write out the prime q to the private token
            //

            extsize = primeQSize;
            pCrtToken->qLength = uint_to_bigendian(primeQSize);
            pCrtToken->qOffset = uint_to_bigendian(tokdatsize);
            BOUNDS_CHECK;
            memcpy((unsigned char *)pCrtToken + tokdatsize,
                   primeQ, primeQSize);
            tokdatsize += primeQSize;

            //
            // now write out the multiplicative inverse U to the private token
            //

            extsize = qInverseSize;
            pCrtToken->qInvLength = uint_to_bigendian(qInverseSize);
            pCrtToken->qInvOffset = uint_to_bigendian(tokdatsize);
            BOUNDS_CHECK;
            memcpy((unsigned char *)pCrtToken + tokdatsize,
                   qInverse, qInverseSize);
            tokdatsize += qInverseSize;

            //
            // now write out the header info
            //

            extsize = modbits;
#ifdef linux
	    pCrtToken->modulusBitLength= modbits; 
#else
	    pCrtToken->modulusBitLength = uint_to_bigendian(modbits);
#endif
           

            if(strongprimes)
                pCrtToken->keyType = uint_to_bigendian(RSA_PKCS_X931_PRIVATE_CHINESE_REMAINDER);
            else
                pCrtToken->keyType = uint_to_bigendian(RSA_PKCS_PRIVATE_CHINESE_REMAINDER);

            pCrtToken->keyLength = uint_to_bigendian(tokdatsize);
            *(rsakeygen->key_private_size) = tokdatsize;

        } else {

            //
            // write out the private key token in modulus/exponent format to
            // the buffer passed to this call - first write out the private exponent
            //


            bufsize = *(rsakeygen->key_private_size);
            pModExpoToken = rsakeygen->x.key_private_modexpo;
            if (bufsize < sizeof(struct _ICA_KEY_RSA_MODEXPO))
                memset((unsigned char *)pModExpoToken, 0, bufsize);
            else
                memset((unsigned char *)pModExpoToken, 0, sizeof(struct _ICA_KEY_RSA_MODEXPO));
            tokdatsize = sizeof(struct _ICA_KEY_RSA_MODEXPO) - sizeof(ICA_KEY_RSA_MODEXPO_REC);;
            pModExpoToken->expLength = uint_to_bigendian(exponentDSize);
            pModExpoToken->expOffset = uint_to_bigendian(tokdatsize);
            BOUNDS_CHECK;
            memcpy((unsigned char *)pModExpoToken + tokdatsize,
                   exponentD, exponentDSize);
            tokdatsize += exponentDSize;

            //
            // now write out the modulus to the public token
            //

            pModExpoToken->nLength = uint_to_bigendian(modulusNSize);
            pModExpoToken->nOffset = uint_to_bigendian(tokdatsize);
            BOUNDS_CHECK;
            memcpy((unsigned char *)pModExpoToken + tokdatsize,
                   modulusN, modulusNSize);
            tokdatsize += modulusNSize;

            //
            // now write out the header info
            //
#ifdef linux
	    pModExpoToken->modulusBitLength = modbits;
#else
	    pModExpoToken->modulusBitLength = uint_to_bigendian(modbits);
#endif
         
            if(strongprimes)
                pModExpoToken->keyType = uint_to_bigendian(RSA_X931_PRIVATE_MODULUS_EXPONENT);
            else
                pModExpoToken->keyType = uint_to_bigendian(RSA_PRIVATE_MODULUS_EXPONENT);
            pModExpoToken->keyLength = uint_to_bigendian(tokdatsize);
            *(rsakeygen->key_private_size) = tokdatsize;


        }
    }

    /* Clean up used space */

    memset(d, 0, MAXSIZE*sizeof(unit));
    memset(phi, 0, MAXSIZE*sizeof(unit));
    memset(p, 0, sizeof(unit)*MAXSIZE/2);

    memset(q, 0, sizeof(unit)*MAXSIZE/2);
    memset(tempunit, 0, sizeof(unit)*MAXSIZE);
    memset(n, 0, sizeof(unit)*MAXSIZE);
    memset(e, 0, sizeof(unit)*MAXSIZE);
    memset(dpq, 0, sizeof(unit)*MAXSIZE/2);
    memset(def_seed, 0, 24);
    memset(primeP, 0, sizeof(primeP));
    memset(primeQ, 0, sizeof(primeQ));
    memset(modulusN, 0, sizeof(modulusN));
    memset(exponentD, 0, sizeof(exponentD));
    memset(subprimeP, 0, sizeof(subprimeP));
    memset(subprimeQ, 0, sizeof(subprimeQ));
    memset(qInverse, 0, sizeof(qInverse));
    memset(exponentE, 0, sizeof(exponentE));

  /* If we failed to generate a key, return the error code.
     Otherwise, subject the newly generated key to an encrypt/decrypt
     test on known date to verify correct that the generated keytoken
     is functional. This test is also a requirement for FIPS 140-1.
  */

  if (retval)
  {
    P_LEAVE( P_rsa_key_gen )    /* profiler */
    return retval;
  }
  else
  {
    unsigned char sig_out[256];
    unsigned char sig_in[256];
    unsigned int inDataLength = (rsakeygen->mod_size+7)/8;
    unsigned int outDataLength=sizeof(sig_out);
    /* Perform an encrypt/decrypt test on known data */

#ifdef _DEBUG_RSA_
    printf("VALIDATION DECrypt test Started\n");
#endif

    //
    // run the key through a known answer test to validate it - first do
    // a decryption using the private key
    //

    if(pkcs)
        retval = icaRsaCrt(devhandle, inDataLength, test_sig_dat_in,
                           (rsakeygen->x.key_private_crt), &outDataLength, sig_out);
    else
        retval = icaRsaModExpo(devhandle, inDataLength, test_sig_dat_in,
                               (rsakeygen->x.key_private_modexpo), &outDataLength, sig_out);

#ifdef _DEBUG_RSA_
    if (retval)
     {
        printf("ERROR--key token failed VALIDATION DECrypt test->retval=%04x\n",retval);
        printf("ERROR--Address data_in  (%04x)",rsa_param.data_in);
        printf("ERROR--Address data_out (%04x)",rsa_param.data_out);
        printf("ERROR--Address keytok   (%04x)",rsa_param.key_token);
        printf("ERROR--Address data_size (%04d)",rsa_param.data_size);
        printf("ERROR--Address key_size (%04x)",rsa_param.key_size);
        printf("ERROR--Options          (%04d)",rsa_param.options);
    }
#endif
    if (!retval)
    {
#ifdef _DEBUG_RSA_
    printf("VALIDATION ENCrypt test Started\n");
#endif

        //
        // now run the decrypted output through the encryption process using
        // public key
        //
        retval = icaRsaModExpo(devhandle, outDataLength, sig_out,
                               (rsakeygen->key_token), &outDataLength, sig_in);

#ifdef _DEBUG_RSA_
      if (retval)
      {
         printf("ERROR--key token failed VALIDATION ENCrypt test->retval=%04x\n",retval);
         printf("ERROR--Address data_in  (%04x)",rsa_param.data_in);
         printf("ERROR--Address data_out (%04x)",rsa_param.data_out);
         printf("ERROR--Address keytok   (%04x)",rsa_param.key_token);
         printf("ERROR--Address data_size (%04d)",rsa_param.data_size);
         printf("ERROR--Address key_size (%04x)",rsa_param.key_size);
         printf("ERROR--Options          (%04d)",rsa_param.options);
     }
#endif
      if (!retval)
      {
        //
        // The outDataLength may have leading zeros that need to be ignored
        //
        retval = memcmp(sig_in, test_sig_dat_in, outDataLength);
      }
    }
    if (retval)
    {
#ifdef _DEBUG_RSA_
        printf("ERROR--key token failed VALIDATION encrypt+decrypt test is \n");
        { int i;
         printf("KeyType->%04d, tokenLength->%04d, n_BitLength->%04d\n",
                 keytok->type, keytok->tokenLength, keytok->n_BitLength);
         for(i=0; i<keytok->tokenLength; i++)
         {
           if (i%16)            /**** 16 per line ******/
            printf("%02x ", keytok[i]);
           else
           {
            printf("\n");
            printf("%-04X %-04d--",i,i);
            printf("%02x ", keytok[i]);
           }
         }
         printf("\n");
        }

#endif

//      memset(keytok, 0, keytok->tokenLength);
      memset((unsigned char *)rsakeygen->key_token, 0, *(rsakeygen->key_size));
      *(rsakeygen->key_size) = 0;
      if(pkcs)
          memset((unsigned char *)rsakeygen->x.key_private_crt, 0,
                 *(rsakeygen->key_private_size));
      else
          memset((unsigned char *)rsakeygen->x.key_private_modexpo, 0,
                 *(rsakeygen->key_private_size));
      *(rsakeygen->key_private_size) = 0;

      retval = PKARSAKeyGenFailed;
    }
    memset(sig_out, 0, 256);
    memset(sig_in, 0, 256);
//    memset(&rsa_param, 0, sizeof(icaRSA_RB_t));
    P_LEAVE( P_rsa_key_gen )    /* profiler */
    return retval;
  }
  } /* var scope parens */
}/*rsa_key_gen()*/


void rsa_init(void)
{

  mpmath_init();

}

/**********************************************************************/
/* Display the data on the NAP screen                                 */
/**********************************************************************/
#ifdef _DEBUG_RSA_
void printfUnitData( unit * lsbBuffer,
                      int   inputSize)

{
   unsigned char buffer[MAXSIZE * sizeof(unit)];
   unsigned int  sz_buf = inputSize * sizeof(unit);
   unsigned int i;

    mpint_to_bigendian_bytearray(MS_UNIT(lsbBuffer,inputSize),
                                         inputSize,
                                          buffer,
                                          sz_buf);
         for (i=0; i< sz_buf; i++)
         {
           if (i%(16))            /**** 16 per line ******/
            printf("%02x ", buffer[i]);
           else
           {
            printf("\n");
            printf("%-04X %-04d--",i,i);
            printf("%02x ", buffer[i]);
           }
         }
         printf("\n");
}
#endif
