
/*
             Common Public License Version 0.5

             THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF
             THIS COMMON PUBLIC LICENSE ("AGREEMENT"). ANY USE,
             REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES
             RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT.

             1. DEFINITIONS

             "Contribution" means: 
                   a) in the case of the initial Contributor, the
                   initial code and documentation distributed under
                   this Agreement, and 

                   b) in the case of each subsequent Contributor:
                   i) changes to the Program, and
                   ii) additions to the Program;

                   where such changes and/or additions to the Program
                   originate from and are distributed by that
                   particular Contributor. A Contribution 'originates'
                   from a Contributor if it was added to the Program
                   by such Contributor itself or anyone acting on such
                   Contributor's behalf. Contributions do not include
                   additions to the Program which: (i) are separate
                   modules of software distributed in conjunction with
                   the Program under their own license agreement, and
                   (ii) are not derivative works of the Program.


             "Contributor" means any person or entity that distributes
             the Program.

             "Licensed Patents " mean patent claims licensable by a
             Contributor which are necessarily infringed by the use or
             sale of its Contribution alone or when combined with the
             Program. 

             "Program" means the Contributions distributed in
             accordance with this Agreement.

             "Recipient" means anyone who receives the Program under
             this Agreement, including all Contributors.

             2. GRANT OF RIGHTS

                   a) Subject to the terms of this Agreement, each
                   Contributor hereby grants Recipient a
                   non-exclusive, worldwide, royalty-free copyright
                   license to reproduce, prepare derivative works of,
                   publicly display, publicly perform, distribute and
                   sublicense the Contribution of such Contributor, if
                   any, and such derivative works, in source code and
                   object code form.

                   b) Subject to the terms of this Agreement, each
                   Contributor hereby grants Recipient a
                   non-exclusive, worldwide, royalty-free patent
                   license under Licensed Patents to make, use, sell,
                   offer to sell, import and otherwise transfer the
                   Contribution of such Contributor, if any, in source
                   code and object code form. This patent license
                   shall apply to the combination of the Contribution
                   and the Program if, at the time the Contribution is
                   added by the Contributor, such addition of the
                   Contribution causes such combination to be covered
                   by the Licensed Patents. The patent license shall
                   not apply to any other combinations which include
                   the Contribution. No hardware per se is licensed
                   hereunder.

                   c) Recipient understands that although each
                   Contributor grants the licenses to its
                   Contributions set forth herein, no assurances are
                   provided by any Contributor that the Program does
                   not infringe the patent or other intellectual
                   property rights of any other entity. Each
                   Contributor disclaims any liability to Recipient
                   for claims brought by any other entity based on
                   infringement of intellectual property rights or
                   otherwise. As a condition to exercising the rights
                   and licenses granted hereunder, each Recipient
                   hereby assumes sole responsibility to secure any
                   other intellectual property rights needed, if any.

                   For example, if a third party patent license is
                   required to allow Recipient to distribute the
                   Program, it is Recipient's responsibility to
                   acquire that license before distributing the
                   Program.

                   d) Each Contributor represents that to its
                   knowledge it has sufficient copyright rights in its
                   Contribution, if any, to grant the copyright
                   license set forth in this Agreement.

             3. REQUIREMENTS

             A Contributor may choose to distribute the Program in
             object code form under its own license agreement, provided
             that:
                   a) it complies with the terms and conditions of
                   this Agreement; and

                   b) its license agreement:
                   i) effectively disclaims on behalf of all
                   Contributors all warranties and conditions, express
                   and implied, including warranties or conditions of
                   title and non-infringement, and implied warranties
                   or conditions of merchantability and fitness for a
                   particular purpose;

                   ii) effectively excludes on behalf of all
                   Contributors all liability for damages, including
                   direct, indirect, special, incidental and
                   consequential damages, such as lost profits;

                   iii) states that any provisions which differ from
                   this Agreement are offered by that Contributor
                   alone and not by any other party; and

                   iv) states that source code for the Program is
                   available from such Contributor, and informs
                   licensees how to obtain it in a reasonable manner
                   on or through a medium customarily used for
                   software exchange.

             When the Program is made available in source code form:
                   a) it must be made available under this Agreement;
                   and
                   b) a copy of this Agreement must be included with
                   each copy of the Program. 

             Contributors may not remove or alter any copyright notices
             contained within the Program.

             Each Contributor must identify itself as the originator of
             its Contribution, if any, in a manner that reasonably
             allows subsequent Recipients to identify the originator of
             the Contribution. 


             4. COMMERCIAL DISTRIBUTION

             Commercial distributors of software may accept certain
             responsibilities with respect to end users, business
             partners and the like. While this license is intended to
             facilitate the commercial use of the Program, the
             Contributor who includes the Program in a commercial
             product offering should do so in a manner which does not
             create potential liability for other Contributors.
             Therefore, if a Contributor includes the Program in a
             commercial product offering, such Contributor ("Commercial
             Contributor") hereby agrees to defend and indemnify every
             other Contributor ("Indemnified Contributor") against any
             losses, damages and costs (collectively "Losses") arising
             from claims, lawsuits and other legal actions brought by a
             third party against the Indemnified Contributor to the
             extent caused by the acts or omissions of such Commercial
             Contributor in connection with its distribution of the
             Program in a commercial product offering. The obligations
             in this section do not apply to any claims or Losses
             relating to any actual or alleged intellectual property
             infringement. In order to qualify, an Indemnified
             Contributor must: a) promptly notify the Commercial
             Contributor in writing of such claim, and b) allow the
             Commercial Contributor to control, and cooperate with the
             Commercial Contributor in, the defense and any related
             settlement negotiations. The Indemnified Contributor may
             participate in any such claim at its own expense.


             For example, a Contributor might include the Program in a
             commercial product offering, Product X. That Contributor
             is then a Commercial Contributor. If that Commercial
             Contributor then makes performance claims, or offers
             warranties related to Product X, those performance claims
             and warranties are such Commercial Contributor's
             responsibility alone. Under this section, the Commercial
             Contributor would have to defend claims against the other
             Contributors related to those performance claims and
             warranties, and if a court requires any other Contributor
             to pay any damages as a result, the Commercial Contributor
             must pay those damages.


             5. NO WARRANTY

             EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE
             PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT
             WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR
             IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR
             CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR
             FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely
             responsible for determining the appropriateness of using
             and distributing the Program and assumes all risks
             associated with its exercise of rights under this
             Agreement, including but not limited to the risks and
             costs of program errors, compliance with applicable laws,
             damage to or loss of data, programs or equipment, and
             unavailability or interruption of operations. 

             6. DISCLAIMER OF LIABILITY
             EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER
             RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY
             FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
             OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION
             LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF
             LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
             (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
             OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE
             OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE
             POSSIBILITY OF SUCH DAMAGES.

             7. GENERAL

             If any provision of this Agreement is invalid or
             unenforceable under applicable law, it shall not affect
             the validity or enforceability of the remainder of the
             terms of this Agreement, and without further action by the
             parties hereto, such provision shall be reformed to the
             minimum extent necessary to make such provision valid and
             enforceable.


             If Recipient institutes patent litigation against a
             Contributor with respect to a patent applicable to
             software (including a cross-claim or counterclaim in a
             lawsuit), then any patent licenses granted by that
             Contributor to such Recipient under this Agreement shall
             terminate as of the date such litigation is filed. In
             addition, If Recipient institutes patent litigation
             against any entity (including a cross-claim or
             counterclaim in a lawsuit) alleging that the Program
             itself (excluding combinations of the Program with other
             software or hardware) infringes such Recipient's
             patent(s), then such Recipient's rights granted under
             Section 2(b) shall terminate as of the date such
             litigation is filed.

             All Recipient's rights under this Agreement shall
             terminate if it fails to comply with any of the material
             terms or conditions of this Agreement and does not cure
             such failure in a reasonable period of time after becoming
             aware of such noncompliance. If all Recipient's rights
             under this Agreement terminate, Recipient agrees to cease
             use and distribution of the Program as soon as reasonably
             practicable. However, Recipient's obligations under this
             Agreement and any licenses granted by Recipient relating
             to the Program shall continue and survive. 

             Everyone is permitted to copy and distribute copies of
             this Agreement, but in order to avoid inconsistency the
             Agreement is copyrighted and may only be modified in the
             following manner. The Agreement Steward reserves the right
             to publish new versions (including revisions) of this
             Agreement from time to time. No one other than the
             Agreement Steward has the right to modify this Agreement.

             IBM is the initial Agreement Steward. IBM may assign the
             responsibility to serve as the Agreement Steward to a
             suitable separate entity. Each new version of the
             Agreement will be given a distinguishing version number.
             The Program (including Contributions) may always be
             distributed subject to the version of the Agreement under
             which it was received. In addition, after a new version of
             the Agreement is published, Contributor may elect to
             distribute the Program (including its Contributions) under
             the new version. Except as expressly stated in Sections
             2(a) and 2(b) above, Recipient receives no rights or
             licenses to the intellectual property of any Contributor
             under this Agreement, whether expressly, by implication,
             estoppel or otherwise. All rights in the Program not
             expressly granted under this Agreement are reserved.


             This Agreement is governed by the laws of the State of New
             York and the intellectual property laws of the United
             States of America. No party to this Agreement will bring a
             legal action under this Agreement more than one year after
             the cause of action arose. Each party waives its rights to
             a jury trial in any resulting litigation. 



*/

/* (C) COPYRIGHT International Business Machines Corp. 2001          */


/***********************************************************************
***                                                                  ***
***       (C) COPYRIGHT IBM CORP  1997                               ***
***                                                                  ***
***       LICENSED MATERIALS  -  PROPERTY OF IBM                     ***
***                                                                  ***
***       All Rights Reserved                                        ***
***                                                                  ***
***       U.S. Government Users Restricted Rights - Use,             ***
***       duplication or disclosure restricted by GSA ADP            ***
***       Schedule Contract with IBM Corp.                           ***
***                                                                  ***
***                                                                  ***
***       ORIGINS: RES (IBM Research Division)                       ***
***                                                                  ***
************************************************************************
*
* Module Name:       x931prim.c
*
* Descriptive Name:  X9.31 compliant prime generation routines.
*
* Status:            Release 1 Version 1
*
* Function:          X9.31 prime generation routines
*
*
* Module type:
*      Processor:    Intel x86 family
*
*      Language:     C source
*
*      Compiler:     IBM VisualAge on OS/2
*
* Restrictions:
*
* Linkage:           these routines are called by the RSA module
*
*
*
* Change History:    written Sept 1997 by Suresh Chari
*                    IBM Research, Hawthorne, NY
*
*
*   Date    Ver   Notes                                            by
* --------- ----  -----                                            ---
* 01-Oct-97       initial implementations                          SC
* 29-Jan-99       remove compiler warnings                         jgd
* 08-mar-99       profiling...                                     jgd
***********************************************************************/
#include <stdlib.h>

#include "platform.h"
#include "mpmath.h"
#include "ica_int.h"
#include "ansipran.h"
#include "x931prim.h"
#include "sieve.h"
#include "rand.h"
#include <string.h> /* for memset */

#ifndef __PROFILE__
#define __PROFILE__ 0
#endif
#include "profiler.h"

/*--------------------------------------------------------------
  constants
---------------------------------------------------------------*/
#define FACTOR_SIZE           101       /* bits */
#define FACTOR_BYTE_SIZE      13         /* bytes */
#define FACTOR_UNIT_SIZE      ((FACTOR_BYTE_SIZE+sizeof(unit)-1)/sizeof(unit))
#define allone                (unit)( ( int) -1)
#define FACTOR_MSB_NUMBYTES   ((FACTOR_BYTE_SIZE %sizeof(unit)))
#define IS_VALID_BIT_LENGTH(p)     ( ! ( ( p - 256 )  % 128 ) )
#define NUM_RM_ITERATIONS                 8
static unit  factor_and_mask;
static unit  factor_or_mask;

/*---------------------------------------------------------
  Initialize module: Init static variables.
-----------------------------------------------------------*/
void init_x931( void )
{

  int i = 0;
  factor_and_mask = (unit) 0x1F;
  factor_or_mask = (unit) 0x10;
  for ( i = 0; i <( FACTOR_MSB_NUMBYTES -1); i++)
    {   factor_and_mask <<=8; factor_and_mask+=255;
        factor_or_mask <<=8;}

}

/*----------------------------------------------------------
  Multiply multiprecision integer a by unit u
  result is b.

  assume size of b is at least size of a + 1
-----------------------------------------------------------*/
static int mp_multiply_by_unit( mp_int *a, unit u, mp_int * b)
{

  double_unit d;
  unit        carry;
  int         s = a->size;
  unit        *p, *q;


  if ( b->maxsize  < ( a->size + 1))
    return -1;
  b->size = a->size;

  carry = ( unit) 0;
  p = MP_LS_UNIT( a );
  q = MP_LS_UNIT( b );
  while (s--){
    d = (double_unit) ( (*p) * u  + carry );
    *q = get_lower_unit( d );
    carry = get_upper_unit( d );
    UNIT_MINUS_MINUS( p );
    UNIT_MINUS_MINUS( q );
  }

  if ( carry ){
    if ( mp_extend( b , b->size +1 ))
      return -1;
    *(MP_MS_UNIT( b )) = carry;
  }

  return 0;
}



#define GET_RANDOM_UNIT( h, u, c){\
  int GRUi;\
  for ( GRUi =0; GRUi < sizeof( unit ); GRUi++){ \
  *u= ( *u << 8);\
  *u +=ANSI_Pran_get_next_byte( h, c); }}

/*---------------------------------------------------------------------------
   robust_primality_test

  INPUT:
           ctx         prng handle to choose random nonces.
           cand        candidate to be tested.
           num_rm_iterations    confidence required.

  OUTPUT:
           0           if candidate is a possible prime
           negative    values otherwise

  COMMENTS:
           If return value is 0 then the probability that the
           candidate is composite is less than 1/ ( 4^num_rm_iterations )
-----------------------------------------------------------------------------*/

int mp_robust_primality_test( ICA_ADAPTER_HANDLE devhandle, ansi_pran_ctx *ctx,
                              mp_int * cand, unsigned int num_rm_iterations )
{
  P_ENTER( P_mp_robust_primality_test )

  unit  runit[ MAXSIZE ];
  mp_int r;
  int i;
  int  rejected=0;
  int  rc;

  rc = cheap_fermat( devhandle, MP_MS_UNIT( cand), cand ->size );
  if ( rc )
  { P_LEAVE( P_mp_robust_primality_test )
    return rc;
  }

  r.value = runit;
  r.maxsize = MAXSIZE;
  r.size = cand->size;
  for ( i = 0; ( i< num_rm_iterations) && (!rejected); i++) {
    int j;
    for( j=0; j< cand->size; j++ )
      GET_RANDOM_UNIT( devhandle, MP_MS_PLUS_K_MS_UNIT( &r, j),ctx);

    rejected = mp_rabin_miller( devhandle, MP_MS_UNIT( &r), MP_MS_UNIT( cand ),
                                cand->size);

  }
  memset( runit, 0, sizeof( runit ));
  P_LEAVE( P_mp_robust_primality_test )
  return rejected;
}

/*---------------------------------------------------------------------------
   generate_a_101_bit_prime

  INPUT:
           ctx         prng candidate to choose random nonces.
           p           placeholder for prime.

  OUTPUT:
           0           if candidate is a possible prime
           negative    values otherwise

  COMMENTS:
           generate a prime of size exactly 101 bits.
-----------------------------------------------------------------------------*/

static int generate_a_101_bit_prime(ICA_ADAPTER_HANDLE devhandle,
                                    ansi_pran_ctx *ctx, mp_int *p)
{
  unsigned char candnotfound = 1;
  signed int primenotfound = 1;


  while ( primenotfound){
    candnotfound =1;
    while ( candnotfound){
      int i ;
      p->size= FACTOR_UNIT_SIZE;
      for ( i = 0; i < FACTOR_UNIT_SIZE; i++)
        GET_RANDOM_UNIT(devhandle, MP_MS_PLUS_K_MS_UNIT(p, i), ctx );

      *(MP_MS_UNIT( p)) &= factor_and_mask;
      *(MP_MS_UNIT(p)) |=factor_or_mask;
      *(MP_LS_UNIT( p)) |=0x1; /* Now it is odd and exactly 101 bits */
      mp_normalize( p);
      candnotfound = generalized_sieve_and_rescue( devhandle,
                                                           small_primes, 2, 256, p,
                                                   MAX_SIEVE_INTERVAL_SIZE, (mp_int*) 0);
    }
    primenotfound = mp_robust_primality_test(devhandle, ctx, p, NUM_RM_ITERATIONS);
    //
    //Check the error code. -1 or -2 indicates not prime, anything else is an error.
    //
    if ((primenotfound == -1) || (primenotfound == -2))
    {
     // do nothing
    }else {
     return (primenotfound);
    }
  }
  return 0;
}



/*------------------------------------------------------------------------

  Generates primes as specified by X9.31 standard.

  Inputs:

  prime_bitlength      length of required prime in bits.
  exponent_type        can be a fixed modulus type OR RANDOM.
  e                    it contains the fixed value of the public
                       exponent. If e is one of the fixed values
                       2, 3, or F4 then this is ignored. can be NULL

  p                    place to store the generated prime.
  q                    If q is NON null then it is assumed that
                       this is the second prime in the RSA prime
                       pair. So the generated prime will be far
                       from q and also if the exponent is even
                       and q is not NULL then the generated prime
                       will be 7 (mod 8).
  abort_callback       routine called to abort the generation.
-----------------------------------------------------------------------------*/

int mp_generate_x931_strong_prime(ICA_ADAPTER_HANDLE devhandle,
                                  ansi_pran_ctx *CTX,
                                  unsigned long prime_bitlength,
                                  unsigned long exponent_type,
                                  mp_int *e, mp_int *p, mp_int *q,
                                  int (*abort_callback)( void ))
{
  P_ENTER( P_mp_generate_x931_strong_prime )

  mp_int   p1,p2;
  unit    temp1[ MAXSIZE ];
  unit    temp2[ MAXSIZE ];
  unit    temp3[ MAXSIZE ];
  unit    temp4[ MAXSIZE ];
  int     candnotfound = 1;
  int     primenotfound = 1;
  unit    Runit[ MAXSIZE ];
  unit    Yunit[ MAXSIZE ];
  mp_int  R, Y;
  mp_int  product, temp;
  int      pmod8 = 0;
  int     status;
  mp_int  *mp_large, *mp_small;
  double_unit primes_mask;
  double_unit primes_zero_mask;
  int psize, shift;

  primes_mask = ((double_unit)3) << (UNITSIZE-2);
  primes_zero_mask = (double_unit)0 - (double_unit) 1;
  psize = (prime_bitlength + UNITSIZE - 1)/UNITSIZE;
  shift = prime_bitlength % UNITSIZE;
  if (!shift)
    shift = UNITSIZE;
  primes_mask = primes_mask << shift;
  shift = UNITSIZE - shift;
  primes_zero_mask >>= shift;

  p1.maxsize = p2.maxsize = MAXSIZE;
  p1.value = temp1;
  p2.value = temp2;
  product.maxsize = MAXSIZE;
  product.value = temp3;
  Y.maxsize = R.maxsize = MAXSIZE;
  Y.value = Yunit;
  R.value = Runit;
  temp.maxsize = MAXSIZE;
  temp.value = temp4;


  /* get 2 101 bit primes: factors of p-1 and p+1.*/
  status = generate_a_101_bit_prime(devhandle, CTX, &p1);
  if(status)
   return status;
  status = generate_a_101_bit_prime(devhandle, CTX, &p2);
  if(status)
   return status;

  mp_normalize( &p1);
  mp_normalize( &p2);
  product.size = p1.size + p2.size;
  do {

    if ( (status = mp_multiply(devhandle, &product, &p1, &p2 )) != 0 )
      break;
    mp_normalize( &product );

    /*-----------------------------------------------
      Use chinese remaindering to  compute R with
      R = -1 mod p1
        = 1  mod p2
                      and if the exponent is even
        = pmod8 ( mod 8)
     -------------------------------------------------*/

    R.size = p1.size+p2.size;

    if ( mp_compare_general( &p1, &p2) < 0 ){
      mp_large = &p2;
      mp_small = &p1;
    }else{
      mp_large = &p1;
      mp_small = &p2;
    }

    if ( (status = mp_inv(devhandle, mp_small, mp_large, &R)) != 0 )
      break;

    if ( (status = mp_extend( &R, R.size+1)) != 0 )
      break;
    if ( (status = shift_left( MP_LS_UNIT(&R), R.size)) != 0 )
      break;
    Y.size = 0;
    if ( (status = mp_extend( &Y, p1.size + p2.size ) ) != 0 )
      break;

    if ( (status=mp_mod(devhandle, &R, mp_large, &Y, (mp_int *)0)) != 0 )
      break;

    mp_normalize( &Y);
    if( (status = mp_multiply(devhandle, &R, &Y, mp_small )) != 0 )
      break;
    if ( (status = mp_minus_eq_unit( MP_LS_UNIT( &R), (unit)1, R.size) ) != 0 )
      break;


    if ( ( exponent_type == RSA_EXPONENT_2) ||
         ( ( exponent_type == RSA_EXPONENT_FIXED) &&
           ( !(*MP_LS_UNIT(e) & (unit) 0x1 ))))
      {
        /* even exponent case */
        int size;


        pmod8 = (q==0)? 3: 7;


        pmod8 -= (unsigned char ) ( *(MP_LS_UNIT( &R)) & (unit) 0x7);
        pmod8 = ( pmod8+8)%8;
        pmod8 *= (unsigned char) ( *(MP_LS_UNIT( &product)) & (unit) 0x7);
        pmod8 = ( pmod8 %8);

        /* add this multiple of product to R */
        Y.size = 0;
        if ( (status = mp_extend( &Y, product.size + 1)) != 0 )
          break;

        if ( (status = mp_multiply_by_unit( &product, (unit) pmod8, &Y)) != 0 )
          break;
        mp_normalize( &Y);
        if( (status = mp_plus_eq( &R, &Y) ) != 0 )
          break;
        /* now we have R . Need to multiply product by 8 */
        if ( (status = mp_extend(&product, product.size + 1)) != 0 )
          break;
        for ( size = 0; size < 3; size++)
          if( (status = shift_left( MP_LS_UNIT(&product), product.size)) != 0 )
            break;
      }

  } while( &mp_generate_x931_strong_prime==0 /*0*/ );

  mp_normalize( &R);

  primenotfound =1;
  while ( primenotfound && (!status )) {
    candnotfound =1;
    if ( abort_callback && ( abort_callback()))
    {
       P_LEAVE( P_mp_generate_x931_strong_prime )
       return -1;
    }
    while( candnotfound && (!status)) {
      int i;

      /* check need to abort? */
      if ( abort_callback && ( abort_callback( ) ))
      {  P_LEAVE( P_mp_generate_x931_strong_prime )
         return -1;
      }

      /* get random candidate */

      Y.size = psize;

      for ( i = 0; i< Y.size; i++)
        GET_RANDOM_UNIT( devhandle, MP_MS_PLUS_K_MS_UNIT( &Y, i), CTX);


      /* ---------------------------------------------

       make candidate = R mod ( p1p2). ensures candidate is -1 mod p1
       and 1 mod p2
       -----------------------------------------------*/

      /* Make the most signifant 2 bits 1, zero out bits beyond
         bitlength
      */
      *(MP_MS_UNIT( &Y )) |= get_upper_unit(primes_mask);
      *(MP_MS_UNIT( &Y )) &= get_upper_unit(primes_zero_mask);

      *(MP_MS_PLUS_K_MS_UNIT( &Y, 1)) |= get_lower_unit(primes_mask);
      *(MP_MS_PLUS_K_MS_UNIT( &Y, 1)) &= get_lower_unit(primes_zero_mask);

      *(MP_LS_UNIT( &Y)) |= 0x1; /* make it odd */

      temp.size = 0;
      do {
         if( (status = mp_extend( &temp, product.size )) != 0 )
           break;
         if ( (status=mp_mod(devhandle, &Y, &product, &temp, (mp_int*)0)) != 0 )
           break;
         if( (status = mp_extend( &Y, Y.size +1 )) != 0 )
           break;

         if ( mp_compare_general( &temp, &R) > 0) {
           mp_extend( &Y, Y.size +1 );
           if(  (status = mp_plus_eq( &Y, &product)) != 0 )
             break;
           mp_normalize( &Y);
        }
        if( (status = mp_extend( &temp, Y.size)) != 0 )
          break;

        if( (status = mp_minus_eq( MP_LS_UNIT(&Y), MP_LS_UNIT(&temp), Y.size)) != 0 )
          break;
        if( (status = mp_extend( &Y, Y.size + 1)) != 0 )
          break;

        if( (status = mp_plus_eq( &Y, &R)) != 0 )
          break;


        /* sieve to increase chance of being prime.
           Sieving done carefully to maintain Y ( mod p1) = 1
           and Y ( mod p2) = -1. */
        candnotfound = generalized_sieve_and_rescue( devhandle, small_primes, 2,
                                                     256, &Y, MAX_SIEVE_INTERVAL_SIZE, &product);


        /* Check that p is relative prime with required exponent */

        mp_normalize( &Y);
        /* test against  exponent */
        if (!(candnotfound)){
          switch( exponent_type) {
            u_int32 rem32;
          case RSA_EXPONENT_3:
            rem32 = get_32_rem( MP_MS_UNIT( &Y), Y.size, (u_int32) 3);
            candnotfound = ( rem32==1);
            break;
          case RSA_EXPONENT_65537:
            rem32 = get_32_rem( MP_MS_UNIT( &Y), Y.size, (u_int32)65537);
            candnotfound = ( rem32==1);
            break;

          case RSA_EXPONENT_FIXED:
             {
              unit temp_1[ MAXSIZE ];
              unit temp2_1[MAXSIZE];
              mp_int t, t2;


              t2.maxsize = MAXSIZE;
              t2.value = temp2_1;

              mp_copy( &t2, &Y);

              t.size = t2.size; t.maxsize = MAXSIZE;
              t.value = temp_1;

              mp_minus_eq_unit(  MP_LS_UNIT( &t2), (unit) 1 , t2.size );
              if (!( *MP_LS_UNIT(e) & 0x1))
                shift_right( MP_MS_UNIT( &t2), t2.size);
              mp_gcd(devhandle, e, &t2, &t);
              mp_normalize( &t);
              candnotfound = !((t.size ==1) &&((*(MP_MS_UNIT( &t))==(unit)1)));
              memset( temp_1, 0, sizeof( temp_1 ));
              memset( temp2_1, 0, sizeof( temp2_1 ));
            }
            break;
          default:
            candnotfound = 0;
          }
        }

        if ( q) {
          /* check that the candidate is sufficiently far from p */
         unit  tempunit[ MAXSIZE];
         mp_int temp_2;

          temp_2.maxsize = MAXSIZE;
          temp_2.size = MAXSIZE;
          temp_2.value = tempunit;
          mp_copy( &temp_2, q );

          if ( mp_compare_general( &temp_2, &Y)){
            mp_minus_eq( MP_LS_UNIT( &temp_2), MP_LS_UNIT( &Y), temp_2.size );
            mp_normalize( &temp_2);
            if ( (( temp_2.size -1)*UNITSIZE ) < (prime_bitlength -100 ))
              candnotfound = 1;
          }else{

            mp_minus_eq( MP_LS_UNIT( &Y), MP_LS_UNIT( &temp_2), Y.size);
            mp_normalize( &Y);
            if ( (( Y.size -1)*UNITSIZE ) < (prime_bitlength -100 ))
              candnotfound = 1;
            else
              mp_plus_eq( &Y, &temp_2);
          }
          memset( tempunit, 0, sizeof( tempunit ));

        }
      } while( &mp_generate_x931_strong_prime==0 /*0*/ );
    }
    mp_normalize( &Y);

    if (    (Y.size == psize)
         && (*MP_MS_UNIT(&Y) <= get_upper_unit(primes_zero_mask))
       )
      primenotfound = mp_robust_primality_test( devhandle, CTX, &Y, NUM_RM_ITERATIONS);
  }

  if (!status ) { mp_copy( p, &Y );}
  memset( temp1, 0, sizeof( temp1 ));
  memset( temp2, 0, sizeof( temp2 ));
  memset( temp3, 0, sizeof( temp3));
  memset( Yunit, 0, sizeof( Yunit ));
  memset( Runit, 0, sizeof( Runit ));
  P_LEAVE( P_mp_generate_x931_strong_prime )

  return status;
}


/*----------------------------------------------------------------------
  mp_generate_strong_prime

  Generate a strong prime having large factors for p-1 and
  p+1.

  INPUT:
  CTX                   prng to generate random nonces.
  prime_bitlength       number of bits in prime.
  exponent_type         can be 2,3,F4, FIXED, or RANDOM.
  e                     for FIXED type of exponent, contains
                        the fixed exponent.
  p                     place holder to store the required prime.
  abort_callback        function to call to check prime generation
                        abort.
-----------------------------------------------------------------------*/

int mp_generate_strong_prime( ICA_ADAPTER_HANDLE devhandle,
                              ansi_pran_ctx *CTX,
                              unsigned long prime_bitlength,
                              unsigned long exponent_type,
                              mp_int *e, mp_int *p,
                              int (*abort_callback)( void ))
{
  #if(__PROFILE__)
    P_ENTER( P_mp_generate_strong_prime )
    int retval = mp_generate_x931_strong_prime( CTX, prime_bitlength, exponent_type,
                                        e, p, (mp_int *) 0, abort_callback);
    P_LEAVE( P_mp_generate_strong_prime )
    return retval;
  #else
    return mp_generate_x931_strong_prime(devhandle, CTX, prime_bitlength, exponent_type,
                                        e, p, (mp_int *) 0, abort_callback);
  #endif
}

/*------------------------------------------------------------------
  Given modulus length and ( optionally ) a fixed exponent e
  generates 2 primes p and q according to the X9.31 prime generation
  standard.


  Inputs:
  CTX                  ANSI pseudorandom generation context.

  modulus_bitlength    length of required modulus in bits.
  exponent_type        can be a fixed modulus type OR RANDOM.
  e                    it contains the fixed value of the public
                       exponent. If e is one of the fixed values 2, 3, or F4
                       then this is ignored can be NULL

  p, q                 place to store the generated primes.

  abort_callback       routine which will be called to abort the generation.
--------------------------------------------------------------------------*/


int generate_x931_primes( ICA_ADAPTER_HANDLE devhandle,
                          ansi_pran_ctx *CTX,
                          unsigned long modulus_bitlength,
                          unsigned long  exponent_type,
                          mp_int *e,
                          mp_int *p,
                          mp_int *q,
                          int (*abort_callback)( void  ))
{
  P_ENTER( P_generate_x931_primes )

  unsigned long prime_bitlength = modulus_bitlength/2;
  int status = 0;


  /* checks for space and validity*/
  if ( !(IS_VALID_BIT_LENGTH( prime_bitlength )))
  { P_LEAVE( P_generate_x931_primes)
    return PKABadParm;
  }
  if( p->maxsize < ((prime_bitlength / (8 * sizeof(unit )))))
  { P_LEAVE( P_generate_x931_primes)
    return PKANoSpace;
  }
  if( q->maxsize < ((prime_bitlength / ( 8 * sizeof(unit )))))
  { P_LEAVE( P_generate_x931_primes)
    return PKANoSpace;
  }




  if ( (status =  mp_generate_x931_strong_prime(devhandle, CTX, prime_bitlength,
                                               exponent_type, e, q,
                                               (mp_int *)0, abort_callback))
                                               != 0 )
  { P_LEAVE( P_generate_x931_primes)
    return status;
  }

  if ( (status =  mp_generate_x931_strong_prime(devhandle, CTX, prime_bitlength,
                                               exponent_type, e, p,
                                               q, abort_callback))
                                               != 0 )
    {
      int temp = q->size;

      /* If we cant generate second prime, clean out previously
         generated prime.
      */

      q->size = 0;
      mp_extend( q, temp);
      P_LEAVE( P_generate_x931_primes)
      return status;
    }

  P_LEAVE( P_generate_x931_primes )
  return status;

}

/*------------------------------------------------------------------------

  Generates a strong prime pair, with the strongness
  properties required by the X9.31 standard without the restriction
  on the size of modulus.

  Inputs:

  modulus_bitlength    length of required modulus in bits. This MUST BE > 480
                       bits.
  exponent_type        can be a fixed  type OR RANDOM.
  e                    it either contains the fixed value of the public
                       exponent OR if the value of the flag type is RANDOM
                 is the buffer to write the value of e into.
                 If e is one of the fixed values 2, 3, or F4
                 then this is ignored can be NULL

  p,q                  place to store the generated primes.

  abort_callback       routine called to abort the generation.

  OUTPUT:
         0             if successful.
         nonzero       otherwise.

---------------------------------------------------------------------------*/

int mp_generate_strong_prime_pair(ICA_ADAPTER_HANDLE devhandle,
                                  ansi_pran_ctx *CTX,
                                  unsigned long modulus_bitlength,
                                  unsigned long exponent_type,
                                  mp_int *e,
                                  mp_int *p,
                                  mp_int *q,
                                  int (*abort_callback)( void ))
{
  P_ENTER( P_mp_generate_strong_prime_pair )

  unsigned long p_len, q_len;
  int status = 0;


  if (modulus_bitlength <= 480)
  {
    P_LEAVE( P_mp_generate_strong_prime_pair )
    return PKABadParm;
  }

  p_len = (modulus_bitlength+1)/2;
  q_len = modulus_bitlength - p_len;

  if( p->maxsize < ((p_len / (8 * sizeof(unit )))))
  {
    P_LEAVE( P_mp_generate_strong_prime_pair )
    return PKANoSpace;
  }

  if( q->maxsize < ((q_len / ( 8 * sizeof(unit )))))
  {
    P_LEAVE( P_mp_generate_strong_prime_pair )
    return PKANoSpace;
  }


  if ( (status =  mp_generate_x931_strong_prime(devhandle, CTX, q_len,
                                               exponent_type, e, q,
                                               (mp_int *)0, abort_callback))
                                               != 0 )
  {
    P_LEAVE( P_mp_generate_strong_prime_pair )
    return status;
  }

  if ( (status =  mp_generate_x931_strong_prime(devhandle, CTX, p_len,
                                                exponent_type, e, p,
                                                q, abort_callback))
                                                != 0 )
  {
    int temp = q->size;

    /* If we cant generate second prime, clean out previously
       generated prime.
    */

    q->size = 0;
    mp_extend( q, temp);
    P_LEAVE( P_mp_generate_strong_prime_pair )
    return status;
  }

  P_LEAVE( P_mp_generate_strong_prime_pair )
  return status;

}


